commit b1c01698f577577e4a88bad0ae08fb5d998e7ebb
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Jan 9 11:26:14 2019 +0100

    Only call drmmode_validate_leases if RandR is enabled
    
    It would crash if RandR is disabled, e.g. because Xinerama is enabled.
    
    Bugzilla: https://bugs.freedesktop.org/109230
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 38db1bbcfc019c92884c7819a6630c70e543f6b2
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Jan 9 11:33:18 2019 +0100

    Only call drmmode_uevent_init if RandR is enabled
    
    There's no point in listening for hotplug events if RandR is disabled,
    as there's no other mechanism for them to be propagated. We were already
    mostly ignoring them in that case.
    
    Inspired by
    https://gitlab.freedesktop.org/xorg/driver/xf86-video-intel/commit/1a489142c8e6a4828348cc9afbd0f430d3b1e2d8
    (via https://bugs.freedesktop.org/109230#c11).
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 803f872f7d4b2d80be434bb42ce64dfd295b122c
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Dec 21 18:04:21 2018 +0100

    Use two HW cursor buffers per CRTC
    
    Switch to the other buffer when xf86_config->cursor changes. Avoids
    these issues possible when re-using the same buffer:
    
    * The HW may intermittently display a mix of the old and new cursor
      images.
    * If the hotspot changes, the HW may intermittently display the new
      cursor image at the location corresponding to the old image's hotspot.
    
    Bugzilla: https://bugs.freedesktop.org/108832
    (Ported from amdgpu commit 0d60233d26ec70d4e1faa343b438e33829c6d5e4)

commit 91e557f78ad261e76a1829f54722c2c0781742d2
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Dec 21 18:00:09 2018 +0100

    Update cursor position in drmmode_show_cursor if hotspot changed
    
    The cursor position is updated to be consistent with the new hotspot in
    the same ioctl call.
    
    (Ported from amdgpu commit b04697de5270e8e45744a7025c24df1f454a4cf0)

commit 92df709786830d4e30a106dd49d8e0355c50c8f0
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Dec 21 17:54:36 2018 +0100

    Use drmIoctl in drmmode_show_cursor
    
    This should be functionally equivalent to what drmModeSetCursor(2) do
    behind the scenes, but allows for new tricks in following changes.
    
    (Ported from amdgpu commit b344e1559e936046ef02c777fc4f6bcefa3830bc)

commit e14c3d2f86c7be2b5c3d06a47bf0abe954207d0b
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Dec 21 17:38:51 2018 +0100

    Drop RADEONInfoRec::cursor_bo array
    
    Not needed or even useful for anything.
    
    (Ported from amdgpu commit e95044e45350870fa7e237860e89ade91ac03550)

commit f66254c171f5a3b052a2a9e0339f17dfb5a60dc2
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Dec 21 12:49:27 2018 +0100

    Automatically try re-enabling TearFree after a flip failed
    
    Specifically, after both the page flip and vblank ioctls failed, but
    then the vblank ioctl started working again. This can happen
    intermittently e.g. when hotplugging a DP display. Previously, TearFree
    would stay disabled in that case until a modeset was triggered somehow.
    
    Bugzilla: https://bugs.freedesktop.org/103791
    (Ported from amdgpu commit bcfa6c258fdf41a9928f8a3c78fc528d0fafee25)

commit ce7db51020d32f17e442338bfd305220feb51630
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Dec 21 12:47:18 2018 +0100

    Cancel pending scanout update in drmmode_crtc_scanout_update
    
    drmmode_crtc_scanout_update does the equivalent of a scanout update,
    so no need to do it again. This might also avoid issues if there's a
    pending scanout update at this point.
    
    (Ported from amdgpu commit 4e7a24ac5a64e402146953ec5850d13c05742116)

commit 21d65e5b78c8889e363aee8596cd0b0f942fee46
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Dec 21 12:38:04 2018 +0100

    Perform scanout buffer update immediately if drmmode_wait_vblank fails
    
    Otherwise the damaged screen contents may never be displayed in that
    case.
    
    (Ported from amdgpu commit 500fadb16285146e91f62fce3a0ce1360ca684ba)

commit 64942d2c49f9fa1afcc42c07943d076a40963e51
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Dec 20 19:00:08 2018 +0100

    Move deferred vblank events to separate drm_vblank_deferred list
    
    It was still possible for nested xorg_list_for_each_entry_safe loops
    to occur over the drm_vblank_signalled list, which could mess up that
    list. Moving deferred events to a separate list allows processing the
    drm_vblank_signalled list without xorg_list_for_each_entry_safe.
    
    Bugzilla: https://bugs.freedesktop.org/108600
    (Ported from amdgpu commit 51ba6dddee40c3688d4c7b12eabeab516ed153b7)

commit f450632077843a95a6ef269febbfb64a605045ed
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Dec 20 18:48:19 2018 +0100

    Explicitly keep track of whether a DRM event is for a flip or not
    
    When an async flip is performed, and TearFree is enabled on the CRTC
    used for timing, we schedule a vblank event for completing the page
    flip. The DRM event queuing code treated this event like a vblank event,
    but it needs to be treated like a page flip event.
    
    (Ported from amdgpu commit e2c7369cae65069aa93eed1c0b678f975ce5c274)

commit 189b6facb3988c00c96d970f8c13ed8d58fa3998
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Dec 20 18:44:24 2018 +0100

    Use drm_abort_one in drm_queue_handler
    
    At this point, we've already established that e->handler is NULL, no
    need to check again in drm_queue_handle_one. This also makes it clearer
    what's happening.
    
    (Ported from amdgpu commit eda571222f5a6be47f8897e82d85199bb9d95251)

commit 06957e3067b9eb38d30b32d98a07895399f4cb36
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Dec 20 18:40:19 2018 +0100

    glamor: Can work at depth >= 15 with current xserver Git master
    
    (Ported from amdgpu commit 0734cdf544ffd3f2ac8749ad0e4bf43f8a5cea50)

commit 99ac121770da53196124d80375a5c8edbcf827fa
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Dec 20 18:38:33 2018 +0100

    Skip gamma correction of cursor data if premultiplied R/G/B > alpha
    
    The un-premultiplied R/G/B values would overflow the gamma LUT, so just
    pass through the data unchanged, and leave it up to the HW how to
    interpret such weird premultiplied alpha pixels.
    
    Bugzilla: https://bugs.freedesktop.org/108355
    (Ported from amdgpu commit 13c94a373b4858a2d2aa14c22b5f98d53c84c0d9)

commit 0c40a76d1c050d018e6d59bebb5efc9c62be308c
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Dec 20 18:25:21 2018 +0100

    Detect and fix up non-premultiplied cursor data
    
    X server >= 1.18 already has code for this, but handle it with older X
    servers as well.
    
    (Ported from amdgpu commits ad6dfb0124860cf67730bde85867f81d9258c84d &
     426f9a49655f01863cf4d898f525e5f95984e0c4)

commit 0058fd2ebf4c900b12f129984e98886a7ac84b2f
Author: Mario Kleiner <mario.kleiner.de@gmail.com>
Date:   Tue Dec 18 11:40:35 2018 +0100

    Fix crash when page flipping in multi-X-Screen/Zaphod mode
    
    radeon_do_pageflip() indexed the flipdata->fb[] array
    indexing over config->num_crtc, but the flip completion
    routines, e.g., drmmode_flip_handler(), index that array
    via the crtc hw id from drmmode_get_crtc_id(crtc).
    
    This is mismatched and causes indexing into the wrong
    array slot at flip completion -> Server crash.
    
    Always use drmmode_get_crtc_id(crtc) for indexing into
    the array to fix this.
    
    Tested on a dual-X-Screen setup with one video output
    assigned to each X-Screen, page-flipping an OpenGL app
    on either of both X-Screens. This used to crash when
    flipping on X-Screen 1, now it doesn't anymore.
    
    Fixes: 740f0850f1e4 "Store FB for each CRTC in drmmode_flipdata_rec"
    Reviewed-by: Michel Dänzer <michel.daenzer@amd.com>
    Signed-off-by: Mario Kleiner <mario.kleiner.de@gmail.com>

commit b559fd83b2b026b50fe39a2b69bdc0901fd3330c
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Mon Nov 19 11:38:22 2018 +0100

    Post-release version bump

commit 33cbd449b5305b8e8c0319af8becc1ab1832c101
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sun Nov 18 12:22:16 2018 -0800

    Update README for gitlab migration
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 5e6fa5c17a810127f0049816f20db6b871ca77e0
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Oct 24 18:22:05 2018 +0200

    Allow up to six instances in Zaphod mode
    
    Corresponding to up to six CRTCs being available in the hardware.
    
    (Ported from amdgpu commit c9d43c1deb9a9cfc41a8d6439caf46d12d220853)

commit c480fd066fe129fa6561fca8c09f037613b753e8
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Oct 24 18:19:42 2018 +0200

    Make wait_pending_flip / handle_deferred symmetric in set_mode_major
    
    We were always calling the latter, but not always the former, which
    could result in handling deferred DRM events prematurely.
    
    (Ported from amdgpu commit 955373a3e69baa241a1f267e96d04ddb902f689f)

commit 86fe8d27b9a3f043e5288ce50eaf1f5fffd24516
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Oct 24 18:14:02 2018 +0200

    Handle pending scanout update in drmmode_crtc_scanout_free
    
    We have to wait for a pending scanout flip or abort a pending scanout
    update, otherwise the corresponding event handler will likely crash
    after drmmode_crtc_scanout_free cleaned up the data structures.
    
    Fixes crash after VT switch while dedicated scanout pixmaps are enabled
    for any CRTC.
    
    (Ported from amdgpu commit 0cd2c337d2c02b8ec2bd994d6124b4aaaad10741)

commit f892d3791219d1041e0cbb1b866e15774004aa18
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Mon Oct 15 17:14:41 2018 +0200

    dri3: Handle radeon_get_pixmap_bo returning NULL
    
    We were trying to already, but testing the wrong pointer.
    
    Fixes: b85b7b11f5b5 "Add struct radeon_buffer"
    Bug: https://bugs.debian.org/910846
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 80514b7b1b88f46f3965ff023035dea83b57e652
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Sep 14 17:48:49 2018 +0200

    Bump version for 18.1.0 release

commit 2d58830c3feafc54dccc0b7bf761a466437d4a09
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Sep 5 18:23:29 2018 +0200

    Fix uninitialized use of local variable pitch in radeon_setup_kernel_mem
    
    Fixes server reset.
    
    Pointed out by clang:
    
    ../../src/radeon_kms.c:2721:9: warning: variable 'pitch' is used uninitialized whenever 'if' condition is false [-Wsometimes-uninitialized]
        if (!info->front_buffer) {
            ^~~~~~~~~~~~~~~~~~~
    ../../src/radeon_kms.c:2765:27: note: uninitialized use occurs here
        pScrn->displayWidth = pitch / cpp;
                              ^~~~~

commit 5d5d883496842da84d9418e91cb13454751da625
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Sep 7 18:16:22 2018 +0200

    Bail early from drm_wait_pending_flip if there's no pending flip
    
    No need to process any events in that case.
    
    (Ported from amdgpu commit ca5eb9894fff153c0a1df7bdc4a4745713309e27)

commit 4c7d5e50a5e469a541bc463cecb505fe850c0824
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Sep 5 11:29:43 2018 +0200

    Don't use xorg_list_for_each_entry_safe for signalled flips
    
    drm_wait_pending_flip can get called from drm_handle_event, in which
    case xorg_list_for_each_entry_safe can end up processing the same entry
    in both. To avoid this, just process the first list entry until the list
    is empty.
    
    (Ported from amdgpu commit 26770be44b89b83bf39c28f2fe284c8cb92ed0c0)

commit 87b9a3e516d19dd1b89a64f6cac990fae53fc1b3
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Sep 5 11:27:25 2018 +0200

    Always delete entry from list in drm_queue_handler
    
    We left entries without a handler hook in the list, so the list could
    keep taking longer to process and use up more memory.
    
    (Ported from amdgpu commit 7eea3e2cd74eed22e982319144e18ae5b1087b78)

commit de88ea2755611bdcb18d91d8234d2ab5be8ff2e9
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Aug 24 11:00:16 2018 +0200

    glamor: Handle ihandle == -1 in radeon_glamor_set_shared_pixmap_backing

commit 84bde2df5b453f8aab35aa18b0cf1f20b8d20488
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Aug 24 10:58:51 2018 +0200

    EXA: Handle ihandle == -1 in RADEONEXASharePixmapBacking

commit 1799680f7bd84e0618f34f4c7486799521ddaf83
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Aug 24 10:56:58 2018 +0200

    Handle ihandle == -1 in radeon_set_shared_pixmap_backing
    
    It means to stop using the shared pixmap backing.
    
    Fixes crash when changing PRIME slave output configuration.

commit 3c42bd04800211f64a17640c7ce7c4111ffd4978
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Aug 24 10:55:49 2018 +0200

    EXA: Handle NULL BO pointer in radeon_set_pixmap_bo

commit cba8fe4d64819aaa8ba516aa68dbe6d2aa153046
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Aug 23 18:59:18 2018 +0200

    Use AC_CONFIG_MACRO_DIR instead of AC_CONFIG_MACRO_DIRS
    
    Older versions of autoconf only supported the former.
    
    Acked-by: Alex Deucher <alexander.deucher@amd.com>

commit 7b01c10137aba24c8f61dd9b2a19ea257ad24371
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Aug 23 18:42:28 2018 +0200

    Add m4 directory
    
    Although normally it only warns about it, under some circumstances,
    aclocal can error out if this directory doesn't exist.
    
    Reported-by: John Lumby <johnlumby@hotmail.com>
    Acked-by: Alex Deucher <alexander.deucher@amd.com>

commit 60cd28bbbe4f9db391b4f27c5ff9289d5c2bef40
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Aug 16 18:06:31 2018 +0200

    Remove drmmode_crtc_private_rec::present_vblank_* related code
    
    Not needed anymore with the more robust mechanisms for preventing nested
    drmHandleEvent calls introduced in the previous changes.
    
    (Ported from amdgpu commit 85cd8eef0cbed7b409b07f58d76dacd34aa3ddea)
    Acked-by: Alex Deucher <alexander.deucher@amd.com>

commit c42f6e2e61d166c8d3ef3fcad175d7050a00288b
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Jul 20 16:56:22 2018 +0200

    Defer vblank event handling while waiting for a pending flip
    
    This is to avoid submitting more flips while we are waiting for pending
    ones to complete.
    
    (Ported from amdgpu commit e52872da69ecc84dafb3355839e35b0383f0d228)
    Acked-by: Alex Deucher <alexander.deucher@amd.com>

commit ba83a866af5a3784fc4822614375cc081e93197c
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Aug 16 17:44:45 2018 +0200

    Add radeon_drm_handle_event wrapper for drmHandleEvent
    
    Instead of processing DRM events directly from drmHandleEvent's
    callbacks, there are three phases:
    
    1. drmHandleEvent is called, and signalled events are re-queued to
       _signalled lists from its callbacks.
    2. Signalled page flip completion events are processed.
    3. Signalled vblank events are processed.
    
    This should make sure that we never call drmHandleEvent from one of its
    callbacks, which would usually result in blocking forever.
    
    (Ported from amdgpu commit 739181c8d3334ff14b5a607895dfdeb29b0d9020)
    Acked-by: Alex Deucher <alexander.deucher@amd.com>

commit 93621e408c17dd9e082236c17f051c06558d7f4d
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Aug 16 17:27:06 2018 +0200

    Add radeon_drm_wait_pending_flip function
    
    Replacing the drmmode_crtc_wait_pending_event macro.
    
    (Ported from amdgpu commit 6029794e8a35417faf825491a89b85f713c77fc1)
    Acked-by: Alex Deucher <alexander.deucher@amd.com>

commit ecdf0b7ec9378bc386ce8276f16fb16d09f72812
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Aug 16 17:14:42 2018 +0200

    Move DRM event queue related initialization to radeon_drm_queue_init
    
    And make radeon_drm_queue_handler not directly accessible outside of
    radeon_drm_queue.c.
    
    (Ported from amdgpu commit 0148283984c77f7a6e97026edc3093497547e0a4)
    Acked-by: Alex Deucher <alexander.deucher@amd.com>

commit 824189b3da9edc33e1a4f5c6130a043da73c1a4c
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Aug 16 18:22:27 2018 +0200

    Use correct FB handle in radeon_do_pageflip
    
    We were always using the handle of the client provided FB, which
    prevented RandR transforms from working, and could result in a black
    screen.
    
    Bugzilla: https://bugs.freedesktop.org/107519
    Fixes: 740f0850f1e4 "Store FB for each CRTC in drmmode_flipdata_rec"
    (Ported from amdgpu commit f6cd72e64e85896b6d155bee0930e59771dcb701)
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 740f0850f1e40403c8dd727e074eae36caeb1f63
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Aug 2 18:49:48 2018 +0200

    Store FB for each CRTC in drmmode_flipdata_rec
    
    We were only storing the FB provided by the client, but on CRTCs with
    TearFree enabled, we use a separate FB. This could cause
    drmmode_flip_handler to fail to clear drmmode_crtc->flip_pending, which
    could result in a hang when waiting for the pending flip to complete. We
    were trying to avoid that by always clearing drmmode_crtc->flip_pending
    when TearFree is enabled, but that wasn't reliable, because
    drmmode_crtc->tear_free can already be FALSE at this point when
    disabling TearFree.
    
    Now that we're keeping track of each CRTC's flip FB separately,
    drmmode_flip_handler can reliably clear flip_pending, and we no longer
    need the TearFree hack.
    
    (Ported from amdgpu commit 9b6782c821e0bdc53336d98f87ddde752faf7902)
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit ef2a6b818fa47ad571bb0bc105aa8193d51a2190
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Aug 2 18:48:04 2018 +0200

    glamor: Set RADEON_CREATE_PIXMAP_DRI2 for DRI3 pixmaps
    
    Not doing this resulted in falling back to software for DRI3 client
    presentation operations with ShadowPrimary.
    
    (Ported from amdgpu commit 2989d40ef74d9966e8e8df2ef7727b2cc48d4960)
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit db28d35ce9fd07a2a4703f3df0633d4c8291ff9b
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Jul 27 11:30:57 2018 +0200

    glamor: Use glamor_egl_create_textured_pixmap_from_gbm_bo when possible
    
    Inspired by the modesetting driver.
    
    Fixes screen pixmap corruption with Xorg < 1.20, and as a bonus,
    simplifies the code slightly.
    
    Bugzilla: https://bugs.freedesktop.org/107385
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 7de4ea15880565c6536ed6859fd32ec89ce0b4c0
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Jul 27 09:13:12 2018 +0200

    Bump version to 18.0.99
    
    Forgot to do this after the 18.0.1 release.

commit fed411290b696ecf9f0e799ec4bad054e4a95017
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Jul 24 17:28:46 2018 +0200

    Use strcpy for RandR output property names
    
    Instead of strncpy with the string length. Avoids new warnings with GCC
    8:
    
    ../../src/drmmode_display.c: In function ‘drmmode_output_create_resources’:
    ../../src/drmmode_display.c:2240:2: warning: ‘strncpy’ output truncated before terminating nul copying 8 bytes from a string of the same length [-Wstringop-truncation]
      strncpy(tearfree_prop->name, "TearFree", 8);
      ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ../../src/drmmode_display.c:2244:2: warning: ‘strncpy’ output truncated before terminating nul copying 3 bytes from a string of the same length [-Wstringop-truncation]
      strncpy(tearfree_prop->enums[0].name, "off", 3);
      ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ../../src/drmmode_display.c:2245:2: warning: ‘strncpy’ output truncated before terminating nul copying 2 bytes from a string of the same length [-Wstringop-truncation]
      strncpy(tearfree_prop->enums[1].name, "on", 2);
      ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ../../src/drmmode_display.c:2247:2: warning: ‘strncpy’ output truncated before terminating nul copying 4 bytes from a string of the same length [-Wstringop-truncation]
      strncpy(tearfree_prop->enums[2].name, "auto", 4);
      ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    
    (Ported from amdgpu commit f3b2ed37d683f8616a0a31ff63133ddb8fe1a4a3)
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit d258413c956cd46a237d4b5b94a35817ca7ce8f4
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Mon Jul 23 18:54:40 2018 +0200

    Remove drmmode_terminate_leases
    
    The RandR screen private is already freed when our CloseScreen runs, so
    this can't do anything useful. This cleanup has to be done by the X
    server itself.
    
    (Ported from amdgpu commit 5f06d6b8ba570b500956ad26fee711d5ac427818)
    Acked-by: Alex Deucher <alexander.deucher@amd.com>

commit ffdbd46b0abcf8cbe73eb8930ddcd7fd2485d9b5
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Mon Jul 23 11:02:32 2018 +0200

    Hardcode "non-desktop" RandR property name
    
    It's a bit silly to require current randrproto just for this definition,
    which can't really change anyway.
    
    Suggested-by: Qiang Yu <qiang.yu@amd.com>
    (Ported from amdgpu commit ae8e02c6fc4ef5d5340b8cd4739e66b19b9e3386)
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 64bd009d17986c71726724859f100ad40a6e3096
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Jul 19 11:33:42 2018 +0200

    Don't allocate drmmode_output->props twice
    
    This was accidentally duplicated when porting RandR lease support from
    amdgpu.
    
    Trivial.

commit 499d2f9d5d301ef1efd4ffc2952677609ef05122
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Jul 17 11:43:12 2018 +0200

    glamor: Invalidate cached GEM handle in radeon_set_pixmap_bo
    
    We continued using the stale cached handle, causing issues e.g. when
    resizing the screen via RandR.
    
    Reported-by: iive on IRC
    Acked-by: Alex Deucher <alexander.deucher@amd.com>

commit d9a139bc6d453d33593685de67d1425611f3ab6f
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Mon Jul 16 12:51:26 2018 +0200

    glamor: Fix glamor_block_handler argument in radeon_glamor_finish
    
    I missed this before because this code isn't compiled with current
    xserver.
    
    Trivial.

commit f533b1f654952cee794de49d28d01947a6571daf
Author: Keith Packard <keithp@keithp.com>
Date:   Wed Jul 11 19:13:28 2018 +0200

    Add RandR leases support
    
    Signed-off-by: Keith Packard <keithp@keithp.com>
    (Ported from xserver commit e4e3447603b5fd3a38a92c3f972396d1f81168ad)
    Signed-off-by: Michel Dänzer <michel.daenzer@amd.com>
    (Ported from amdgpu commit 61040bdfa360975614fb47aa7ea1b3a1abac3427)
    Acked-by: Alex Deucher <alexander.deucher@amd.com>

commit b4f0f44a9f67f2eafd4a2b5ab919e6ea7fa2acf7
Author: Keith Packard <keithp@keithp.com>
Date:   Wed Jul 11 19:10:20 2018 +0200

    modesetting: Create CONNECTOR_ID properties for outputs [v2]
    
    This lets a DRM client map between X outputs and kernel connectors.
    
    v2:
            Change CONNECTOR_ID to enum -- Adam Jackson <ajax@nwnk.net>
    
    Signed-off-by: Keith Packard <keithp@keithp.com>
    (Ported from xserver commit 023d4aba8d45e9e3630b944ecfb650c081799b96)
    Signed-off-by: Michel Dänzer <michel.daenzer@amd.com>
    (Ported from amdgpu commit ab7e39c5a03e24c3ce3ee2f22ada7572bc2d9aa7)
    Acked-by: Alex Deucher <alexander.deucher@amd.com>

commit 612bda0a5e769f23478b364cf89620222cfac349
Author: Keith Packard <keithp@keithp.com>
Date:   Wed Jul 11 19:07:59 2018 +0200

    modesetting: Record non-desktop kernel property at PreInit time
    
    Save any value of the kernel non-desktop property in the xf86Output
    structure to avoid non-desktop outputs in the default configuration.
    
    [Also bump randrproto requirement to a version that defines
    RR_PROPERTY_NON_DESKTOP - ajax]
    
    Signed-off-by: Keith Packard <keithp@keithp.com>
    (Ported from xserver commit b91c787c4cd2d20685db69426c539938c556128a)
    Signed-off-by: Michel Dänzer <michel.daenzer@amd.com>
    (Ported from amdgpu commit 14db71a606128c4a207f43298809af279b77e2a8)
    Acked-by: Alex Deucher <alexander.deucher@amd.com>

commit 4b3e5f81c6032003237bb05c3ab96423c39524fc
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Jul 11 19:04:26 2018 +0200

    Call drmmode_crtc_gamma_do_set from drmmode_setup_colormap
    
    Instead of from drmmode_set_mode_major. There's no need to re-set the
    gamma LUT on every modeset, the kernel should preserve it.
    
    (Ported from amdgpu commit baea4fa492f635cdfe746a84be2e337d9aeae8a9)
    Acked-by: Alex Deucher <alexander.deucher@amd.com>

commit 16ddc109660dbe813c457765eda66422fb745a3e
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Jul 11 19:03:12 2018 +0200

    Remove #if 0'd code
    
    This has always been disabled, no need to keep it.
    
    (Ported from amdgpu commit 19a40758be04e1d451a030f452efb49e8aaad541)
    Acked-by: Alex Deucher <alexander.deucher@amd.com>

commit 447ef0458fac047919d021f2ba1753a647f5c503
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Jul 11 19:01:31 2018 +0200

    Check dimensions passed to drmmode_xf86crtc_resize
    
    When enabling a secondary GPU output, Xorg can try resizing the screen
    beyond the limit advertised by the driver, leading to drmModeAddFB
    failing and primary GPU outputs turning off. Check for this and bail
    instead.
    
    (Ported from amdgpu commit 940c8b39f79789d4d5ddb8ab8d25a8ae05932756)
    Acked-by: Alex Deucher <alexander.deucher@amd.com>

commit 6a0c01bbd4ed48c696c38952ee33ce21afec9f91
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Jul 11 18:59:58 2018 +0200

    Use drmmode_crtc_dpms in drmmode_set_desired_modes
    
    Simplifies the latter slightly.
    
    (Ported from amdgpu commit 74124f2c17dbb4b752707bb7eee398ae099e8a2c)
    Acked-by: Alex Deucher <alexander.deucher@amd.com>

commit 59441ee3dae15e0e81ed20688b0ba6dba12d7917
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Jul 11 18:58:20 2018 +0200

    Call drmmode_do_crtc_dpms from drmmode_crtc_dpms as well
    
    Leo pointed out that drmmode_do_crtc_dpms wasn't getting called when
    turning off an output with
    
     xrandr --output <output> --off
    
    This meant that the vblank sequence number and timestamp wouldn't be
    saved before turning off the CRTC in this case.
    
    Reported-by: Leo (Sunpeng) Li <sunpeng.li@amd.com>
    (Ported from amdgpu commit ceeacb455cd058492a493aac954deab8455804b5)
    Acked-by: Alex Deucher <alexander.deucher@amd.com>

commit 4050b0ad51b1c65945c6474981d1228888738cd4
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Jul 11 18:42:58 2018 +0200

    Replace 'foo == NULL' with '!foo'
    
    Shorter and sweeter. :)
    
    (Ported from amdgpu commit e8e688f3852fb06b0c34ed5bce47c9493bcd1613)
    Acked-by: Alex Deucher <alexander.deucher@amd.com>

commit cf8bc72e3473cef2b511e2c938eb00aca82de909
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Jul 10 18:57:49 2018 +0200

    Wait for pending flips in drmmode_output_set_tear_free
    
    This prevents a nested call to drmHandleEvent, which would hang.
    
    Fixes hangs when disabling TearFree on a CRTC while a DRI3 client is
    page flipping.
    
    (Ported from amdgpu commit 04947b83cce3a7782e59dece2c7797cc396c1e05)
    Acked-by: Alex Deucher <alexander.deucher@amd.com>

commit f01d8cf2bd9681b8f5f0e2eddec0a79614389771
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Jul 10 18:53:54 2018 +0200

    Refactor drmmode_output_set_tear_free helper
    
    Preparation for the following fix, no functional change intended.
    
    (Ported from amdgpu commit fa30f4601de7a44edfb4a95873bd648946fd4292)
    Acked-by: Alex Deucher <alexander.deucher@amd.com>

commit ee7e15746148122abf6728fb0f59d6c8ae329e4e
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Jul 10 18:53:06 2018 +0200

    Set drmmode_crtc->scanout_id = 0 when TearFree is disabled
    
    When disabling TearFree, drmmode_crtc->scanout_id could remain as 1,
    but drmmode_set_mode_major would destroy drmmode_crtc->scanout[1], so
    scanout_do_update() would keep bailing, and the scanout buffer would
    stop being updated.
    
    Fixes freeze after disabling TearFree on a CRTC with active RandR
    rotation or other transform.
    
    (Ported from amdgpu commit 7db0c8e9d7586cff4312d4b93684d35de3e6376f)
    Acked-by: Alex Deucher <alexander.deucher@amd.com>

commit e9d2d149481e2a9c7cba50d43c6a5146124be3f2
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Jul 10 18:52:08 2018 +0200

    Simplify drmmode_handle_transform
    
    Set crtc->driverIsPerformingTransform for any case we can handle before
    calling xf86CrtcRotate. We already clear it afterwards when the latter
    clears crtc->transform_in_use.
    
    This should allow our separate scanout buffer mechanism to be used in
    more cases.
    
    (Cherry picked from amdgpu commit 8e544b4a0de6717feb4abf00052d57c5b726b5ce)
    Acked-by: Alex Deucher <alexander.deucher@amd.com>

commit 89d38e976fd6ba6e026cda7c5d05971f1f177f13
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Jul 10 18:51:00 2018 +0200

    Don't call scanout_flip/update with a legacy RandR scanout buffer
    
    It means we are not using our own scanout buffers.
    
    Fixes crash when TearFree is supposed to be enabled, but
    drmmode_handle_transform doesn't set crtc->driverIsPerformingTransform.
    
    Bugzilla: https://bugs.freedesktop.org/105736
    (Ported from amdgpu commit 463477661c88cab3a87746499e5838c5b9f9a13b)
    Acked-by: Alex Deucher <alexander.deucher@amd.com>

commit 9f2409c4d3a9ecad8e769783e307e57a75b1255e
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Jul 10 18:49:05 2018 +0200

    Simplify drmmode_crtc_scanout_update
    
    Use our own BoxRec for the extents, and RegionEmpty for clearing the
    scanout damage region.
    
    (Ported from amdgpu commit 72c3e9c7308fbcdf85708b72f9be14a5f2f8e7b5)
    Acked-by: Alex Deucher <alexander.deucher@amd.com>

commit e07c38649280b3f4361005bc4c256f2145a72537
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Jul 10 18:48:16 2018 +0200

    Update RandR CRTC state if set_mode_major fails in set_desired_modes
    
    Without this, RandR would report the CRTC and its outputs as enabled,
    even though they were actually off due to the failure.
    
    (Cherry picked from amdgpu commit 4dcda0b48d62944c841cd9540f4ad4c7ac8dee47)
    Acked-by: Alex Deucher <alexander.deucher@amd.com>

commit 05390ae36a0abb19f1d533ff95a3fceaafdf79c8
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Jul 10 18:45:51 2018 +0200

    Abort scanout_update_pending event when possible
    
    We don't need to wait for a non-TearFree scanout update before scanning
    out from the screen pixmap or before flipping, as the scanout update
    won't be visible anyway. Instead, just abort it.
    
    (Ported from amdgpu commit 36d01989cd842588f12fdae5b2cba5fdcf9c91dd)
    Acked-by: Alex Deucher <alexander.deucher@amd.com>

commit 290291a11598ba9aa594417998502b0e0ac96970
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Jul 10 18:43:28 2018 +0200

    Track DRM event queue sequence number in scanout_update_pending
    
    Preparation for next change, no behaviour change intended.
    (Ported from amdgpu commit 04a5c5f7cfacad8d9ccffe81e388cc3da2036cb5)
    Acked-by: Alex Deucher <alexander.deucher@amd.com>

commit d14ff6b77824d0e32728869907e88d6866243101
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Jul 10 18:41:43 2018 +0200

    Ignore RADEON_DRM_QUEUE_ERROR (0) in radeon_drm_abort_entry
    
    This allows a following change to be slightly simpler.
    (Ported from amdgpu commit 8fcc3a9b43d3907052a83a96e5a2423afab5ad3f)
    Acked-by: Alex Deucher <alexander.deucher@amd.com>

commit 731d4b386a55cdb468e37b69d41284150952cf8c
Author: Emil Velikov <emil.velikov@collabora.com>
Date:   Tue Jul 10 18:39:31 2018 +0200

    Do not export the DriverRec RADEON
    
    Unused externally and should not be exported.
    
    Signed-off-by: Emil Velikov <emil.velikov@collabora.com>
    (Ported from amdgpu commit 7fb8b49895e225b3908c8bd186539de23afe91d1)
    Acked-by: Alex Deucher <alexander.deucher@amd.com>

commit cc1d0824a8a7ef29f8911b95695f7cb1b4abe9b8
Author: Jim Qu <Jim.Qu@amd.com>
Date:   Tue Jul 10 18:36:42 2018 +0200

    Wait for pending scanout update before calling drmmode_crtc_scanout_free
    
    There is a case that when set screen from reverse to normal, the old
    scanout damage is freed in modesetting before scanout update handler,
    so it causes segment fault issue.
    
    Signed-off-by: Jim Qu <Jim.Qu@amd.com>
    
    [ Michel Dänzer: Only call drmmode_crtc_wait_pending_event before
      drmmode_crtc_scanout_free is actually called, slightly tweak commit
      message ]
    Signed-off-by: Michel Dänzer <michel.daenzer@amd.com>
    (Ported from amdgpu commit 9f6a8905611b5b1d8fcd31bebbc9af7ca1355cc3)
    Acked-by: Alex Deucher <alexander.deucher@amd.com>

commit 413622bcccc9d36a9c87679f379dc84b21a3c655
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Jul 10 17:23:24 2018 +0200

    Swap pixmap privates in radeon_dri2_exchange_buffers
    
    Instead of only the BOs.
    
    This matches what amdgpu does, and fixes issues with DRI2 page flipping.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 3c4c0213c11d623cba7adbc28dde652694f2f758
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Jun 29 17:57:03 2018 +0200

    glamor: Use GBM for BO allocation when possible
    
    Inspired by amdgpu. This avoids various issues due to a GEM handle
    lifetime conflict between us and Mesa with current glamor.
    
    Bugzilla: https://bugs.freedesktop.org/105381
    Tested-by: Konstantin Kharlamov <hi-angel@yandex.ru>
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit b85b7b11f5b5e792f21951b881bd8433d3d70858
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri May 18 18:49:35 2018 +0200

    Add struct radeon_buffer
    
    Inspired by amdgpu, preparation for the following change. For now, this
    is mostly a wrapper around struct radeon_bo, no functional change
    intended.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 37ba075b34130c41bb7a2261bd666af5b29ffaf3
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Jun 15 18:23:53 2018 +0200

    Refactor radeon_finish helper
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 6c986e997159ad0086f940294b244fc4c30b61fc
Author: Jammy Zhou <Jammy.Zhou@amd.com>
Date:   Fri Jun 15 18:41:34 2018 +0200

    Remove throttling from radeon_dri2_copy_region2
    
    Throttling should be handled by the client-side drivers.
    
    Signed-off-by: Jammy Zhou <Jammy.Zhou@amd.com>
    (Ported from amdgpu commit 8a34a8149860ac15e83ccdbd8d9a527d8d3e5997)
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 90b94d40449f665f2d12874598062a5e5e5b64cd
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Jun 15 18:27:46 2018 +0200

    Move flush from radeon_scanout_do_update to its callers
    
    No functional change intended.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 5da2bf43e64f2d702fe05016263f617c10f8f134
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Mon May 28 18:35:32 2018 +0200

    Factor out radeon_surface_initialize helper
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit ba5d5402b3e2e807d7e47205ac83f930b6c8caf5
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu May 17 12:36:29 2018 +0200

    glamor: Don't store radeon_surfaces in pixmaps
    
    Only EXA needs them.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit eec4a41925127ae490f0a5156a881a08d521e28e
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu May 17 18:25:37 2018 +0200

    Only initialize libdrm_radeon surface manager for >= R600
    
    Not used with older GPUs.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit ac18a993a3a68629805b8f272a339e25444c0897
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed May 23 12:18:36 2018 +0200

    EXA: Remove old RADEONEXACreatePixmap hook
    
    Not used by any supported version of xserver.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 25836375e0aab17a2e6bd91acb1c19b837ae2109
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu May 17 18:18:42 2018 +0200

    Drop unused drmmode_create_bo_pixmap surface parameter
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 65c9dfea4e841b7d6f795c7489fede58c5e9631f
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue May 15 18:59:30 2018 +0200

    glamor: Bail CreatePixmap on unsupported pixmap depth
    
    Fixes crash in that case.
    
    Bugzilla: https://bugs.freedesktop.org/106293
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 3dcfce8d0f495d09d7836caf98ef30d625b78a13
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu May 17 09:50:50 2018 +0200

    Bail from dri2_create_buffer2 if we can't get a pixmap
    
    We would store the NULL pointer and continue, which would lead to a
    crash down the road.
    
    Bugzilla: https://bugs.freedesktop.org/106293
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit fdba5373522c008f43e9ca5a9e76e35c6e7ad73d
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Mar 15 17:19:59 2018 +0100

    Bump version for 18.0.1 release

commit e0f5020117d0a6340f4208ec52bd3e3b3aa99a1b
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Mar 14 16:54:52 2018 +0100

    Pass extents to radeon_scanout_do_update by value
    
    radeon_scanout_extents_intersect could leave the scanout damage region
    in an invalid state, triggering debugging checks in pixman:
    
    *** BUG ***
    In pixman_region_append_non_o: The expression r->x1 < r->x2 was false
    Set a breakpoint on '_pixman_log_error' to debug
    
    (Ported from amdgpu commit 8af989546907ad9fb491d940e1936d3bfc89276b)

commit b915e8e6fb956e983c2ce2a5565c20838c85707c
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Mar 7 17:28:55 2018 +0100

    Wrap the whole miPointerScreenFuncRec, instead of only Set/MoveCursor
    
    We were clobbering entries in mi's global miSpritePointerFuncs struct,
    which cannot work correctly with multiple primary screens. Instead,
    assign a pointer to our own wrapper struct to PointPriv->spriteFuncs.
    
    Fixes crashes with multiple primary screens.
    
    Fixes: 1fe8ca75974c ("Keep track of how many SW cursors are visible on
                          each screen")
    Reported-by: Mario Kleiner <mario.kleiner.de@gmail.com>

commit 7e18aea984e186dd2ab1144470b0c0e832562ad1
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Mar 6 18:15:45 2018 +0100

    Bump version for 18.0.0 release

commit 504b8721b17a672caf1ed3eab087027c02458cab
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Mon Mar 5 18:41:44 2018 +0100

    Only change Set/MoveCursor hooks from what we expect
    
    Since xf86CursorCloseScreen runs after RADEONCloseScreen_KMS,
    PointPriv->spriteFuncs doesn't point to the same struct in the latter as
    in RADEONCursorInit_KMS. So we were restoring info->Set/MoveCursor to
    the wrong struct. Then in the next server generation,
    info->Set/MoveCursor would end up pointing to
    drmmode_sprite_set/move_cursor, resulting in an infinite loop if one of
    them was called.
    
    To avoid this, only change the Set/MoveCursor hooks if their values
    match our expectations, otherwise leave them as is. This is kind of a
    hack, but the alternative would be invasive and thus risky changes to
    the way we're wrapping CloseScreen, and it's not even clear that can
    work without changing xserver code.
    
    Fixes: 1fe8ca75974c ("Keep track of how many SW cursors are visible on
                          each screen")
    Acked-by: Alex Deucher <alexander.deucher@amd.com>

commit e0d23092337efe4c1e406c9124ca8d8856863e65
Author: Keith Packard <keithp@keithp.com>
Date:   Fri Mar 2 12:13:43 2018 +0100

    modesetting: Update property values at detect and uevent time
    
    We were updating the link-status property when a uevent came in, but
    we also want to update the non-desktop property, and potentially
    others as well. We also want to check at detect time in case we don't
    get a hotplug event.
    
    This patch updates every property provided by the kernel, sending
    changes to DIX so it can track things as well.
    
    Signed-off-by: Keith Packard <keithp@keithp.com>
    
    (Ported from amdgpu commit 374cb8fef4fdbb648af089ee80803ec78321f1b2)

commit aef8fe6e9e94ebecbbb6adf940160d3a7ab4d5ac
Author: Daniel Martin <consume.noise@gmail.com>
Date:   Fri Mar 2 12:12:09 2018 +0100

    modesetting: Reset output_id if drmModeGetConnector failed
    
    If drmModeGetConnector() fails in drmmode_output_detect(), we have to
    reset the output_id to -1 too.
    
    Yet another spot leading to a potential NULL dereference when handling
    the mode_output member as output_id was != -1. Though, this case should
    be very hard to hit.
    
    Signed-off-by: Daniel Martin <consume.noise@gmail.com>
    
    (Ported from amdgpu commit 10054b6c3d9a755b30abb43020121b9631fa296d)

commit 1ef12a92ca53cd6fbfed3ef8628616445b007c9a
Author: Daniel Martin <consume.noise@gmail.com>
Date:   Fri Mar 2 12:08:09 2018 +0100

    modesetting: Use helper to fetch drmModeProperty(Blob)s
    
    Replace the various loops to lookup drmModeProperty(Blob)s by
    introducing helper functions.
    
    Signed-off-by: Daniel Martin <consume.noise@gmail.com>
    
    (Ported from amdgpu commit fb58e06acd6c6bd59de2dbdadbca27eb1dd0025b)

commit ace1e3871c39a86becdf473a47fdc096e8ef39f5
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Feb 21 17:53:59 2018 +0100

    Disable all unused CRTCs before setting desired modes
    
    This might avoid modeset failures in some cases where a CRTC which isn't
    used by Xorg was enabled before.
    
    (Ported from amdgpu commit e3aae7a24296f640c0153d1459f3e0820485468a)
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit f2915eb7a4beb6140ebec183aeac02111fc6ba77
Author: Christoph Haag <haagch@frickel.club>
Date:   Thu Mar 1 15:07:00 2018 +0100

    fix include order for present.h configure test
    
    xorg-server.h defines _XSERVER64 which is used in X.h to choose the
    correct definition of XID
    
    this prevents a failure in the present.h configure test that disables
    DRI3 on X.Org 1.20
    
    Reviewed-and-Tested-by: Michel Dänzer <michel.daenzer@amd.com>

commit f777e909fd23e063729ecb038997db445f82ef5e
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Feb 16 16:55:03 2018 +0100

    Don't bail from drmmode_set_desired_modes immediately
    
    If we fail to find or set the mode for a CRTC, keep trying for the
    remaining CRTCs, and only return FALSE if we failed for all CRTCs that
    should be on.
    
    (Ported from amdgpu commit f5ac5f385f41d1547cfd7ccc8bb35a537a8fffeb)

commit 2d63748667d0bcfcd9999e4e41f775eba87897a0
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Feb 15 17:47:14 2018 +0100

    Simplify depth 30 "kernel too old" error message
    
    We know it's depth 30, no need to have xf86DrvMsg fill it in.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 680b4ab43f00b1f635f9359281e13a031d09ad24
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Jan 24 12:29:17 2018 +0100

    If glamor is too old for depth 30, fall back to EXA or ShadowFB
    
    Instead of not starting up at all.
    
    Corresponding to amdgpu commit 37c7260bdef3a53b0f0295a531f33938e9aad8cf.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 16954fab59f95bdca4540c4496b2ec0759c447e9
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Feb 14 18:20:04 2018 +0100

    Call RADEONFreeRec from RADEONFreeScreen_KMS even if info == NULL
    
    It's safe now.
    
    (Ported from amdgpu commit c9bd1399a13cea2e1331af2c826ca054b88db071)
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 6b44b8c584f3b63712858be11277842c97d03426
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Feb 14 18:06:18 2018 +0100

    Don't call RADEONFreeRec from RADEONPreInit_KMS
    
    If the latter fails, Xorg will call RADEONFreeScreen_KMS, which calls
    the former.
    
    (Ported from amdgpu commit 103b7285845b786929fb509083c57e074c48f9be)
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 8a55e66bfd77dcb2553a43e86215b9d3c87b03f0
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Feb 14 18:13:16 2018 +0100

    Don't use RADEONEntPriv in RADEONFreeRec
    
    It crashes if info == NULL.
    
    (Ported from amdgpu commits fb8444e731765588c0ff1e9053c1c7b73f5f0907 &
     cfccf4c4e7e5c73fe4040fabeb1b43283cf29b33)
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 703cbb7177c6f69264836e975c1921e552fd60a4
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Feb 14 17:28:10 2018 +0100

    glamor: Allow depth 30 with Xorg >= 1.19.99.1
    
    Corresponding to amdgpu commit 6aee5770fb913713bb1b9a1af8f0d0892a66f21a.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 733f606dd6ca8350e6e7f0858bfff5454ddc98ed
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Jan 25 16:59:30 2018 +0100

    Always use screen depth/bpp for KMS framebuffers
    
    DRI clients can use depth 32 pixmaps while the screen is depth 24, in
    which case page flipping would fail.
    
    Reported-by: Mario Kleiner <mario.kleiner.de@gmail.com>
    Reviewed-and-Tested-by: Mario Kleiner <mario.kleiner.de@gmail.com>

commit 83124426040bc1f2dba74c8eeb5a5a9c7c64e664
Author: Mario Kleiner <mario.kleiner.de@gmail.com>
Date:   Wed Jan 24 18:19:38 2018 +0100

    Make XvMC extension initialize at depth 30.
    
    Signed-off-by: Mario Kleiner <mario.kleiner.de@gmail.com>
    Reviewed-by: Michel Dänzer <michel.daenzer@amd.com>

commit 2d171c892d373b45ef9f1ee068648437e2529a78
Author: Mario Kleiner <mario.kleiner.de@gmail.com>
Date:   Wed Jan 24 18:19:37 2018 +0100

    Add missing depth 30 -> cpp=4 handling for DRI2.
    
    Missing this apparently didn't cause any ill side effects, only a bit of
    confusion when looking at xtrace's of DRI2 clients.
    
    Signed-off-by: Mario Kleiner <mario.kleiner.de@gmail.com>
    Reviewed-by: Michel Dänzer <michel.daenzer@amd.com>

commit 574bfab4bf1fcd95163a8f33cea2889189429d30
Author: Mario Kleiner <mario.kleiner.de@gmail.com>
Date:   Mon Jan 22 03:14:37 2018 +0100

    Support exa screen color depth 30 on Linux 3.16 and later. (v2)
    
    Linux 3.16's radeon-kms introduced 10 bpc fb support.
    Currently, as of X-Server 1.19, this works with exa accel,
    but not yet when using glamor acceleration.
    
    v2: Style fixes, check for glamor first, as suggested
        by Michel.
    
    Signed-off-by: Mario Kleiner <mario.kleiner.de@gmail.com>
    Reviewed-by: Michel Dänzer <michel.daenzer@amd.com>

commit ee7e6c25989e4faf1adfa4754b7edd5a9a4722ce
Author: Fredrik Höglund <fredrik@kde.org>
Date:   Mon Jan 22 03:14:36 2018 +0100

    exa: Accelerate ARGB2101010 pictures
    
    Tested by Mario on a Radeon HD 4000 series for the r600
    exa path, and on Radeon HD 5770 for the evergreen exa
    path.
    
    Signed-off-by: Fredrik Höglund <fredrik@kde.org>
    Reviewed-and-Tested-by: Mario Kleiner <mario.kleiner.de@gmail.com>
    Reviewed-by: Michel Dänzer <michel.daenzer@amd.com>

commit 1f1d4b1fa7d4b22dd8553f7e71251bf17ca7a7b1
Author: Mario Kleiner <mario.kleiner.de@gmail.com>
Date:   Mon Jan 22 03:14:35 2018 +0100

    Skip xf86HandleColormaps() at color depth 30. (v2)
    
    The hardware gamma luts get bypassed at color
    depth 30 anyway, so skip their setup.
    
    v2: Also don't hook up drmmode_crtc_gamma_set()
        to .gamma_set for a screen with depth 30,
        so the server can spare itself the effort of
        updating and setting unused cluts.
        Suggested by Michel.
    
    Signed-off-by: Mario Kleiner <mario.kleiner.de@gmail.com>
    Reviewed-by: Michel Dänzer <michel.daenzer@amd.com>

commit 21f6753462464acfd3c452393328c977a375ce26
Author: Mario Kleiner <mario.kleiner.de@gmail.com>
Date:   Mon Jan 22 03:14:34 2018 +0100

    Define per x-screen individual drmmode_crtc_funcs
    
    This allows to en-/disable some functions depending on individual screen
    settings.
    
    Prep work for more efficient depth 30 support.
    
    Suggested-by: Michel Dänzer <michel.daenzer@amd.com>
    Signed-off-by: Mario Kleiner <mario.kleiner.de@gmail.com>
    Reviewed-by: Michel Dänzer <michel.daenzer@amd.com>

commit 1fe8ca75974c5241c3b556b757f9c966c9ce5002
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Dec 27 17:13:30 2017 +0100

    Keep track of how many SW cursors are visible on each screen
    
    And use this to determine when we cannot use page flipping for DRI
    clients. We previously did this based on whether the HW cursor cannot
    be used on at least one CRTC, which had at least two issues:
    
    * Even while the HW cursor cannot be used, no SW cursor may actually be
      visible (e.g. because all cursors are disabled), in which case we can
      use page flipping for DRI clients anyway
    * Even while the HW cursor can be used, there may be SW cursors visible
      from non-core pointer devices, in which case we cannot use page
      flipping for DRI clients anyway
    
    (Ported from amdgpu commit 69e20839bfeb3ee0b0a732d72de0a32d6c5435fc)
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit b4ce8913ac392df339081f6f3e28bf79a239ee75
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Dec 27 17:05:26 2017 +0100

    Move cursor related ScreenInit calls into RADEONCursorInit_KMS
    
    And bail if xf86_cursors_init fails.
    
    (Ported from amdgpu commit dfccaa7043ccb157a1f8be7313123792bb7e7001)
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit ee907e9b9563609cb4a4817e17215b50bb1c7177
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Dec 1 15:49:11 2017 +0100

    Add radeon_dirty_src_drawable helper
    
    Allows tidying up radeon_dirty_src_equals and redisplay_dirty slightly.
    
    (Cherry picked from amdgpu commit 1d65ac395971571094df21ca0408d5972c6b56ec)
    Acked-by: Alex Deucher <alexander.deucher@amd.com>

commit fccfd75ecf9ccfa628a8ff9c1fbb7f60c0f10ea5
Author: Joakim Tjernlund <joakim.tjernlund@infinera.com>
Date:   Fri Nov 24 17:27:09 2017 +0100

    Fix non GLAMOR build
    
    Non GLAMOR builds needs pRADEONEnt so move the USE_GLAMOR define
    down to make pRADEONEnt defined in this case.
    
    Signed-off-by: Joakim Tjernlund <joakim.tjernlund@infinera.com>
    Reviewed-by: Michel Dänzer <michel.daenzer@amd.com>

commit 15350bd5538c21cd4c6b406d565ca765b7e0218a
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Nov 15 18:01:29 2017 +0100

    Use correct ScrnInfoPtr in redisplay_dirty
    
    We used the destination pixmap's screen for flushing drawing commands.
    But when we are the master screen, the destination pixmap is from the
    slave screen.
    
    Fixes crash when the slave screen isn't using the same acceleration
    architecture as us.
    
    Bugzilla: https://bugs.freedesktop.org/103613
    Fixes: 01b040b4a807 ("Adapt to PixmapDirtyUpdateRec::src being a
                         DrawablePtr")
    (Ported from amdgpu commit 3a4f7422913093ed9e26b73ecd7f9e773478cb1e)
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 6441210bc53978a2c46c572e9174215b14f9e813
Author: Daniel Martin <consume.noise@gmail.com>
Date:   Fri Oct 20 10:05:35 2017 +0200

    modesetting: Check crtc before searching link-status property
    
    No need to lookup the link-status property if we don't have a crtc.
    
    Signed-off-by: Daniel Martin <consume.noise@gmail.com>
    (Ported from xserver commit 8d7f7e24261e68459e6f0a865e243473f65fe7ad)
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit cafcb55768b58dc63a8c5682000eba21ad904689
Author: Keith Packard <keithp@keithp.com>
Date:   Mon Sep 25 16:18:22 2017 -0700

    modesetting: Skip no-longer-present connectors when resetting BAD links
    
    Outputs may have NULL mode_output (connector) pointers if the
    connector disappears while the server is running. Skip these when
    resetting outputs with BAD link status.
    
    (Ported from xserver commit 37f4e7651a2fd51efa613a08a1e705553be33e76)
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 0cd14777b7e39619f231b841a2d73f3122458030
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Oct 20 17:20:30 2017 +0200

    Always call drmModeFreeProperty after drmModeGetProperty
    
    We were not doing so in all cases, leaking memory allocated by the
    latter.
    
    (Cherry picked from amdgpu commit f6b39bcd45cb06976ba8a3600df77fc471c63995)
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 84c7d9c1c71d9cee9f50f96671032529b606cf04
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Oct 20 17:19:09 2017 +0200

    Call TimerFree for timer created in LeaveVT
    
    We were leaking the memory allocated by TimerSet.
    
    (Ported from amdgpu commit 84aad09f18fed6b52b0c073f0bbd675a6de07807)
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit d588015f4f60ce270bcfd8433215fc981a84f143
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Oct 20 17:13:36 2017 +0200

    Free memory returned by xf86GetEntityInfo
    
    We were leaking it.
    
    (Ported from amdgpu commit cfccf4c4e7e5c73fe4040fabeb1b43283cf29b33)
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit ec90c94881239791d0a66a02fc6d003c73a6c1f3
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Oct 20 16:51:16 2017 +0200

    Free pRADEONEnt memory in RADEONFreeRec
    
    We were leaking it.
    
    (Inspired by amdgpu commit 9d84934309e4ccd9a43c73d958b8ff10ef2fc990)
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit b93ae9b159790e8a979e9d5d567a0e6fccd7d08a
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Oct 19 18:57:45 2017 +0200

    Unreference pixmap's FB with EXA as well in radeon_set_pixmap_bo
    
    Not doing so resulted in DRI2 page flips not actually changing the FB
    being scanned out, showing intermittent flicker of the "back" buffer
    rendering.
    
    Bugzilla: https://bugs.freedesktop.org/102643
    Fixes: 55e513b978b2 "Use reference counting for tracking KMS framebuffer
                         lifetimes"
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 61113768bd79ec5c2164835e2e048e8f2a42ce9a
Author: Darren Salt <devspam@moreofthesa.me.uk>
Date:   Thu Oct 19 18:17:07 2017 +0200

    Clarify when TearFree is automatically enabled.
    
    (Ported from amdgpu commit 2f72be038d22c54620e436af30121dd89f79a003)
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 7d435354099119234d443b07e2df1c7b9f97cf3c
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Oct 4 11:11:33 2017 +0200

    Bail if there's a problem with ShadowFB
    
    If we hit a problem while setting up ShadowFB, just carrying on trying
    to set up HW acceleration instead is unlikely to work.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit b71836c9962f8f2eadf0c2188e03faed737c18da
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Oct 4 11:05:49 2017 +0200

    Post-release version bump

commit 34da04daec82077571558ac3fe1ec0c1203a01ad
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Oct 3 12:47:14 2017 +0200

    Fix VT switching with ShadowFB
    
    We were trying to call acceleration specific functions from LeaveVT.
    Instead, memset the scanout buffer to all 0 in LeaveVT and allocate a
    new one in EnterVT.
    
    Bugzilla: https://bugs.freedesktop.org/102948
    Fixes: 06a465484101 ("Make all active CRTCs scan out an all-black
                          framebuffer in LeaveVT")
    Signed-off-by: Michel Dänzer <michel.daenzer@amd.com>
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit f9aca8c1a7a423b9e738c88400ae821bdfbcdb1c
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Sep 8 17:02:59 2017 +0900

    Bump version for 7.10.0 release

commit 5cdd334b3402c2431deb3a87a8d04ef590da53ee
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Aug 30 18:48:19 2017 +0900

    Require xserver >= 1.13
    
    xserver 1.13.0 was released on September 6th, 2012, almost 5 years ago.
    
    This allows cleaning up a bunch of backwards compatibility code.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>
    Reviewed-by: Emil Velikov <emil.l.velikov@gmail.com>

commit 9d9c565c84601f4c6c73ad769f86491088683f7a
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Aug 29 18:07:51 2017 +0900

    Use a timer for unreferencing the all-black FB
    
    The timer fires 1 second after LeaveVT. This gives the next DRM master
    enough time to set up scanout of its own buffers.
    
    Fixes prolonged intermittent black screen when switching from Xorg to
    e.g. the GDM Wayland mode login VT.
    
    Fixes: 06a465484101 ("Make all active CRTCs scan out an all-black
                          framebuffer in LeaveVT")
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit e4a3df19d588a4310fcb889ef34e205d0e92e4d7
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Mon Aug 28 17:54:23 2017 +0900

    Remove drmmode_scanout_free
    
    Not used anymore.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 06a465484101f21e99d3a0a62fb03440bcaff93e
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Aug 23 18:00:15 2017 +0900

    Make all active CRTCs scan out an all-black framebuffer in LeaveVT
    
    And destroy all other FBs. This is so that other DRM masters can only
    get access to this all-black FB, not to any other FB we created, while
    we're switched away and not DRM master.
    
    Fixes: 55e513b978b2 ("Use reference counting for tracking KMS
                          framebuffer lifetimes")
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 7f0cd68d1b0c132e32ae736371bce3e12ed33c7a
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Mon Aug 28 17:53:19 2017 +0900

    Create radeon_master_screen helper
    
    Preparatory, no functional change intended yet.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 20f6b56fdb74d88086e8e094013fedbb14e50a24
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Aug 24 17:10:29 2017 +0900

    Create radeon_pixmap_get_fb_ptr helper
    
    Preparatory, no functional change intended yet.
    
    Also inline radeon_pixmap_create_fb into radeon_pixmap_get_fb, since
    there's only one call-site anymore.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 4bc992c31059eb50e22df4ebf5b92d08411f41ef
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Aug 23 17:24:53 2017 +0900

    Create drmmode_set_mode helper
    
    Preparatory, no functional change intended yet.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 3f6210ca2c8ef60d59efc8139151d3b9838bb875
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Jun 22 18:37:26 2017 +0900

    Create radeon_pixmap_clear helper
    
    Preparatory, no functional change intended yet.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 0472a605e0ec8fec1892bbc3a84698b7ef9c5296
Author: Martin Peres <martin.peres@linux.intel.com>
Date:   Mon Apr 10 16:48:21 2017 +0300

    modesetting: re-set the crtc's mode when link-status goes BAD
    
    Despite all the careful planning of the kernel, a link may become
    insufficient to handle the currently-set mode. At this point, the
    kernel should mark this particular configuration as being broken
    and potentially prune the mode before setting the offending connector's
    link-status to BAD and send the userspace a hotplug event. This may
    happen right after a modeset or later on.
    
    Upon receiving a hot-plug event, we iterate through the connectors to
    re-apply the currently-set mode on all the connectors that have a
    link-status property set to BAD. The kernel may be able to get the
    link to work by dropping to using a lower link bpp (with the same
    display bpp). However, the modeset may fail if the kernel has pruned
    the mode, so to make users aware of this problem a warning is outputed
    in the logs to warn about having a potentially-black display.
    
    This patch does not modify the current behaviour of always propagating
    the events to the randr clients. This allows desktop environments to
    re-probe the connectors and select a new resolution based on the new
    (currated) mode list if a mode disapeared. This behaviour is expected in
    order to pass the Display Port compliance tests.
    
    (Ported from xserver commit bcee1b76aa0db8525b491485e90b8740763d7de6)
    
    [ Michel: Bump libdrm dependency to >= 2.4.78 for
      DRM_MODE_LINK_STATUS_BAD ]
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit d822a0f47070374ad0c1a97b559bae27724dc52a
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Aug 17 16:20:52 2017 +0900

    Make radeon_scanout_do_update take a PixmapPtr instead of a DrawablePtr
    
    All callers were already passing in a pixmap.
    
    This allows simplifying the rotated scanout case slightly.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 3e24770b1b472fc15df56d06f5f04778c9db63dd
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Aug 9 13:02:34 2017 +0900

    Use xorg_list_append for the DRM event list
    
    We were adding entries at the start of the list, i.e. the list was
    ordered from most recently added to least recently added. However, the
    corresponding DRM events are generally expected to arrive in the same
    order as they are queued, which means that radeon_drm_queue_alloc would
    generally have to traverse the whole list to find the entry
    corresponding to an arrived event. Fix this by adding entries at the end
    of the list.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 36ce7920136c0d723c9397a84e7dd5926a9c7943
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Aug 9 19:01:15 2017 +0900

    Consolidate radeon_scanout_flip_abort/handler helpers
    
    While at it, make them use crtc->driver_private.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit d314cbfb228bb4b8762714f98d0c114a8ee3f061
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Mon Jul 31 17:12:59 2017 +0900

    Always allow DRI2 page flipping with TearFree
    
    Even if TearFree is enabled for the CRTC we're synchronizing to.
    
    v2:
    * Move manpage hunk here from previous change.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com> # v1

commit 4445765af5b97d0cfd10889fe6d6f58f2ce85659
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Feb 9 13:01:03 2017 +0900

    Always allow Present page flipping with TearFree
    
    Even if TearFree is active for the the CRTC we're synchronizing to. In
    that case, for Present flips synchronized to vertical blank, the other
    scanout buffer is immediately synchronized and flipped to during the
    target vertical blank period. For Present flips not synchronized to
    vertical blank, we simply use the MSC and timestamp values of the last
    vertical blank period for timing purposes, and let the normal TearFree
    mechanism handle display updates.
    
    v2:
    * Move manpage hunk to next change, since TearFree can still prevent
      DRI2 page flipping with this change.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com> # v1

commit 65e0c5ea1b4adff21d673dbf54af99704c429627
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Feb 8 17:52:28 2017 +0900

    Pass extents to radeon_scanout_do_update
    
    Preparation for following change, no functional change intended yet.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 1443270e52e8562bd8dc3603f301963bd4027cef
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Feb 7 18:58:23 2017 +0900

    Add source drawable parameter to radeon_scanout_do_update
    
    Preparation for following changes, no functional change intended yet.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 7c10ee9c88378d773c0bcf651fdc5d9f2c6dc5e5
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Aug 3 18:16:36 2017 +0900

    Handle multiple "pending" Present flips
    
    The xserver Present code can submit a flip in response to notifying it
    that a vblank event arrived. This can happen before the completion event
    of the previous flip is processed. In that case, we were clearing the
    drmmode_crtc->flip_pending field prematurely.
    
    Prevent this by only clearing drmmode_crtc->flip_pending when it matches
    the framebuffer being scanned out since the flip whose completion event
    we're processing.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit e6d7dc2070f4d21a6900916bb70a31839112882c
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Aug 3 17:51:20 2017 +0900

    Wait for pending flips synchronously before turning off a CRTC
    
    Allows removing drmmode_clear_pending_flip and the pending_dpms_mode
    field and cleaning up the code considerably.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit f87acdbfb1b0b6d2769764772a52ea8b81675e20
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Jul 28 12:28:53 2017 +0900

    Create drmmode_crtc_wait_pending_event helper macro
    
    Preparation for following change, no functional change intended yet.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 99f1d7a474af3683fe1a66f50c0bb8935478ff0a
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Mon Aug 14 12:23:04 2017 +0900

    Create drmmode_wait_vblank helper
    
    Allows cleaning up the code considerably.
    
    v2:
    * Fix "drmWaiVBlank" typo, add blank line for readability (Slava Abramov)
    * Rename in/out sequence parameters to "target_seq" and "result_seq",
      hopefully that will be clearer.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com> # v1

commit 49cc61ab970ee28d4509b4e2dd0a57165136889f
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Aug 1 18:45:53 2017 +0900

    Pass reference CRTC to radeon_do_pageflip directly
    
    Simplifies the code slightly.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 3f120fa1d5d921656a367751bc079e020e9ab105
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Aug 3 17:42:51 2017 +0900

    Remove drmmode_crtc->scanout_destroy[] array
    
    No longer necessary since we're reference counting framebuffers.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com

commit 01b040b4a80754b8c8a305cbe968416182b54246
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Aug 15 17:15:27 2017 +0900

    Adapt to PixmapDirtyUpdateRec::src being a DrawablePtr

commit 5309bde0c4e28adf2b167191c6d7011a19e31eed
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Jul 27 16:11:19 2017 +0900

    Allow DRI page flipping when some CRTCs use separate scanout buffers
    
    As long as the CRTC we're synchronizing to doesn't.
    
    v2:
    * Remove redundant checks from can_exchange which still prevented DRI2
      page flipping
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 9bc3eef74452d924f9101c024f66ad9b14c404c8
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Jul 27 15:46:41 2017 +0900

    Add drmmode_crtc_can_flip helper
    
    To reduce code duplication between DRI2 and Present. No functional
    change intended yet.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit c2d26890691ec105858f086b63170ad94c6f7f05
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Jul 12 12:13:03 2017 +0900

    Use root window (pixmap) instead of screen pixmap for scanout updates
    
    Preparation for following changes, no functional change intended yet.
    
    v2:
    * Add drmmode_screen_damage_destroy callback to prevent use-after-free
      on server shutdown
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 377c9dc7e51cc8ebd06816b08682a8098a49508a
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Jul 27 15:27:54 2017 +0900

    autogen.sh: Pass -f to autoreconf
    
    To ensure that any existing copies of autotools files will be replaced
    with the current versions.
    
    (Cherry picked from amdgpu commit a47c0093338d80d84e7033ad15d051925d542ca0)
    Acked-by: Alex Deucher <alexander.deucher@amd.com>

commit bf0a759e3bced3a93bead033a26871cc340bd309
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Jul 27 15:26:23 2017 +0900

    Makefile.am: Set ACLOCAL_AMFLAGS = -I m4
    
    Suggested by one of the tools called by autoreconf.
    
    (Cherry picked from amdgpu commit 842bad4b951296ca25f47b50cb358e502bf30ebb)
    Acked-by: Alex Deucher <alexander.deucher@amd.com>

commit e628f604d032d32971a1ca8670469e88939e3de2
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Jul 27 15:24:37 2017 +0900

    Add AC_CONFIG_MACRO_DIRS([m4]) to configure.ac
    
    Suggested by one of the tools called by autoreconf.
    
    (Cherry picked from amdgpu commit 227b399badaad9bbef0be5a776ce008d0d243449)
    Acked-by: Alex Deucher <alexander.deucher@amd.com>

commit 7d7abf99b5441ddb04dbee99bc8fa7abc30d4c46
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Jul 26 18:13:35 2017 +0900

    Only handle reflection in the driver with Xorg < 1.16
    
    Xorg doesn't handle the hardware cursor correctly in that case for
    rotation and general transforms, and we can't force the SW cursor.
    
    Fixes: f2bc882f1c10 ("Handle rotation in the driver also with Xorg
                          1.12-1.18")
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 94dc2b80f3ef0b2c17c20501d824fb0447d52e7a
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Mar 14 16:57:17 2017 +0900

    If a TearFree flip fails, fall back to non-TearFree operation
    
    In order to avoid possible freeze / log file spam in that case.
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=99769
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit aff267ee36cc6a703a532f91f82adc1ba1425ff3
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Mar 14 16:23:45 2017 +0900

    Use drmmode_crtc->scanout_id instead of 0 to check for scanout buffer
    
    Preparation for following change, no functional change intended.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit df88d51c5005476e6fbfca3f31b54be079ec5aaa
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Jun 27 19:15:18 2017 +0900

    Use pRADEONEnt->fd exclusively for the DRM file descriptor
    
    This brings us closer to amdgpu.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 19626bce4e5e31c863eedb503ea3884ac3f60bea
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Jun 27 18:32:28 2017 +0900

    Improve drmmode_fb_reference debugging code
    
    If a reference count is <= 0, call FatalError with the call location
    (in case it doesn't get resolved in the backtrace printed by
    FatalError).
    
    (Ported from amdgpu commit 1b6ff5fd9933c00ec1ec90dfc62e0b531927749b)
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit bc46ffdf71ab3dfa0f95572529e818f2b619d380
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Jun 27 18:19:31 2017 +0900

    Increase reference count of FB assigned to drmmode_crtc->flip_pending
    
    Otherwise, it could happen that we destroy the FB before the flip
    completes, resulting in use-after-free and most likely a crash.
    
    (Ported from amdgpu commit af7221e1c4d2dbdfd488eb0976a835584ea8441c)
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit c9dd28cb0c9c3de676eadac61e727732510f6b9b
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Jun 22 12:38:55 2017 +0900

    Only call drmmode_scanout_free for non-GPU screens in LeaveVT
    
    Destroying the scanout buffers of GPU screens resulted in a crash when
    switching back to the Xorg VT.
    
    Fixes: 4cfa4615f79f ("Use drmmode_crtc_scanout_* helpers for RandR 1.4
                          scanout pixmaps")
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 78fad9ca1635cca04b89807e3db029477cf46681
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Mon Jun 26 18:58:30 2017 +0900

    Include xf86Pci.h for DRICreatePCIBusID with xserver Git master
    
    The declaration has been moved there from dri.h.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit ef95e3a3cc9189c8906fe5b4d70bfa9f1055d7ce
Author: Adam Jackson <ajax@redhat.com>
Date:   Tue Jun 13 09:32:44 2017 -0400

    modesetting: Validate the atom for enum properties
    
    The client could have said anything here, and if what they said doesn't
    actually name an atom NameForAtom() will return NULL, and strcmp() will
    be unhappy about that.
    
    [copied from xserver d4995a3936ae283b9080fdaa0905daa669ebacfc]
    
    Signed-off-by: Adam Jackson <ajax@redhat.com>
    Reviewed-and-Tested-by: Michel Dänzer <michel.daenzer@amd.com>

commit d80d01a73c2eaba2e3649b7bc0a3541b3ff782f6
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu May 18 11:12:34 2017 +0900

    Update URLs
    
    * Point to the amd-gfx mailing list
    * Specify the component in all bugzilla URLs
    * Use https:// for all HTML URLs
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 2b7d77b90108911777a11ecaa63435552000c958
Author: Eric Anholt <eric@anholt.net>
Date:   Tue May 16 11:04:29 2017 -0700

    Use plain glamor_egl_create_textured_screen().
    
    Since 5064ffab631 (2014), glamor's implementation of _ext just drops the
    back_pixmap arg, which we were passing NULL (the default) to anyway.
    
    Signed-off-by: Eric Anholt <eric@anholt.net>
    Reviewed-by: Michel Dänzer <michel.daenzer@amd.com>

commit 3a9f7e87c30b9f6334d38dfdd1cb15b28fe37fcb
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu May 11 18:57:25 2017 +0900

    Remove unused struct members from drmmode_display.h
    
    (Ported from amdgpu commit 462ac3341e5bfbded9086d3d9043821d19352b3e)
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 7dc68e26755466f9056f8c72195ab8690660693d
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue May 2 11:47:58 2017 +0900

    Simplify tracking of PRIME scanout pixmap
    
    Remember the shared pixmap passed to drmmode_set_scanout_pixmap for each
    CRTC, and just compare against that.
    
    Fixes leaving stale entries in ScreenRec::pixmap_dirty_list under some
    circumstances, which would usually result in use-after-free and a crash
    down the line.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 55e513b978b2afc52b7cafc5bfcb0d1dc78d75f6
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Sat Apr 29 17:05:58 2017 +0900

    Use reference counting for tracking KMS framebuffer lifetimes
    
    References are held by the pixmaps corresponding to the FBs (so
    the same KMS FB can be reused as long as the pixmap exists) and by the
    CRTCs scanning out from them (so a KMS FB is only destroyed once it's
    not being scanned out anymore, preventing intermittent black screens and
    worse issues due to a CRTC turning off when it should be on).
    
    v2:
    * Only increase reference count in drmmode_fb_reference if it was sane
      before
    * Make drmmode_fb_reference's indentation match the rest of
      drmmode_display.h
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 944391b0052466b71bf9919b56139dc197a7e072
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Feb 8 18:14:30 2017 +0900

    Pass pixmap instead of handle to radeon_do_pageflip
    
    This brings us in line with amdgpu and prepares for the following
    change, no functional change intended.
    
    (Ported from amdgpu commit e463b849f3e9d7b69e64a65619a22e00e78d297b)
    
    v2:
    * Be more consistent with the amdgpu code, which should make porting
      the following change to amdgpu easier
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit f32c45194ac6f82cbe42d255ed72f857018778e0
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue May 9 11:18:00 2017 +0900

    Apply gamma correction to HW cursor
    
    The display hardware CLUT we're currently using for gamma correction
    doesn't affect the HW cursor, so we have to apply it manually when
    uploading the HW cursor data.
    
    This currently only works in depth 24/32.
    
    (Ported from amdgpu commit 82fa615f38137add75f9cd4bb49c48dd88de916f)
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 4c91f36d3058180b5a2d6a23e9b82f5c933d8716
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Mon Apr 17 18:32:31 2017 +0900

    Don't set modes before RADEONWindowExposures_oneshot is called
    
    The root window contents may be undefined before that, so we don't want
    to show anything yet.
    
    Fixes a crash on startup with rotation and virtual resolution set in
    xorg.conf.
    
    Bugzilla: https://bugs.freedesktop.org/100276
    Fixes: cc9d6b7db9c2 ("Move DPMS check from radeon_scanout_do_update to
                          radeon_scanout_flip")
    (Ported from amdgpu commit 981bac185cfd74ae50dffc28f57cf34623a9595f)
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit d6c29250dbc293c932ca14997eb23399610b106d
Author: Daniel Stone <daniels@collabora.com>
Date:   Fri Apr 7 14:27:58 2017 +0100

    Set correct DRM event context version
    
    DRM_EVENT_CONTEXT_VERSION is the latest context version supported by
    whatever version of libdrm is present. We were blindly asserting we
    supported whatever version that may be, even if we actually didn't.
    
    Set the version as 2, which should be bumped only with the appropriate
    version checks.
    
    Signed-off-by: Daniel Stone <daniels@collabora.com>
    (Ported from xserver commit 0c8e6ed85810e96d84173a52d628863802a78d82)
    v2: Remove second paragraph of commit log, we always initialize
        page_flip_handler2 = NULL (Emil Velikov)
    Reviewed-by: Emil Velikov <emil.l.velikov@gmail.com>
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com> # v1

commit 23985d3ef3150ef8cad30b92ef0cd8ba6cfa1f4d
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Mar 23 18:06:45 2017 +0900

    manpage: Don't put "'" at the beginning of a line
    
    It caused the whole line to be dropped.
    
    Fixes: 58cd1600057e ("Allow toggling TearFree at runtime via output
                          property")
    Reported-by: Andy Furniss <adf.lists@gmail.com>
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com> (amdgpu commit)
    (Ported from amdgpu commit 165b51447643ce37f391f25ca6aecb8d76fabaa3)

commit dc30f5e27ef8a8e980adb21c1fea7c4f60c7e896
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Mar 23 18:06:23 2017 +0900

    Post-release version bump

commit 66227060872219c1a0dc84fa4cea6264f7548446
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Mar 16 16:38:15 2017 +0900

    Bump version for 7.9.0 release

commit 9a71445094b728f3d78db8f6808b4782ee19a453
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Mar 8 17:42:56 2017 +0900

    Pass TRUE to drmmode_set_desired_modes the first time for GPU screens
    
    This is the only place we call drmmode_set_desired_modes for GPU screens
    during server startup. Without this change, the display outputs of
    secondary GPUs may stay on even while Xorg isn't using them.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 67ae5e00a748ad52cf92738d401afff2947b1891
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Mar 8 11:20:30 2017 +0900

    Skip some initialization steps for GPU screens
    
    Xorg doesn't use the following functionality of GPU screens, so don't
    bother initializing it:
    
    * DRI page flipping
    * DRI3 / Present / SYNC fences
    * XVideo / XvMC
    * Root window with background None
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit f0e7948e1c0e984fc27f235f365639e9cf628291
Author: Jochen Rollwagen <joro-2013@t-online.de>
Date:   Sun Mar 5 11:32:38 2017 +0100

    Fix build for XServer 1.13
    
    Latest git build stops with the error message
    
    radeon_kms.c: In function 'RADEONWindowExposures_oneshot':
    radeon_kms.c:1644:45: error: expected expression before 'RegionPtr'
         pScreen->WindowExposures(pWin, pRegion, RegionPtr pBSRegion);
    
    This patch fixes the build.
    
    Reviewed-by: Michel Dänzer <michel.daenzer@amd.com>

commit d63881623f0686a66a2e3e3c1f84e496aa52ec6b
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Mar 2 16:22:51 2017 +0900

    Don't call radeon_cs_flush_indirect & radeon_bo_wait in drmmode_copy_fb
    
    RADEONWindowExposures_oneshot takes care of it.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit cc9d6b7db9c2078be1e530a64af6d517c6a42024
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Mar 1 17:35:59 2017 +0900

    Move DPMS check from radeon_scanout_do_update to radeon_scanout_flip
    
    When radeon_scanout_do_update is called from
    drmmode_crtc_scanout_update, drmmode_crtc->pending_dpms_mode may still
    be != DPMSModeOn, e.g. during server startup.
    
    Fixes intermittently showing garbage with TearFree enabled.

commit 0a12bf1085505017068dfdfd31d23133e51b45b9
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Mar 1 18:00:40 2017 +0900

    Call drmmode_set_desired_modes from a WindowExposures hook
    
    This is the earliest opportunity where the root window contents are
    guaranteed to be initialized, and prevents drmmode_set_mode_major from
    getting called before drmmode_set_desired_modes via RADEONUnblank ->
    drmmode_crtc_dpms. Also, in contrast to the BlockHandler hook, this is
    called when running Xorg with -pogo.
    
    Fixes intermittently showing garbage on server startup or after server
    reset.
    
    As a bonus, this avoids trouble due to higher layers (e.g. the tigervnc
    Xorg module) calling RADEONBlockHandler_oneshot repeatedly even after
    we set pScreen->BlockHandler = RADEONBlockHandler_KMS.
    
    v2:
    * Drop spaces between XORG_VERSION_NUMERIC arguments
    * Call radeon_bo_wait after radeon_cs_flush_indirect
    
    Bugzilla: https://bugs.freedesktop.org/99457
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com> (v1)

commit df2d749a4db33298c8ce9f2cfb77c20c5538c9cc
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Mar 2 16:05:42 2017 +0900

    Fix bogus indentation
    
    Trivial.
    
    Fixes: 58cd1600057e ("Allow toggling TearFree at runtime via output property")

commit 9035b6abea557828e672ee455f0c84e43da0906f
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Feb 28 18:13:42 2017 +0900

    present: Flush before flipping
    
    This isn't necessary for DRI clients, but the Present extension can also
    be used for presenting normal pixmaps rendered to via the X11 protocol.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 0a4eb0e12f0c9c653cf4cea6fd62e1a507eb261c
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Feb 10 12:52:02 2017 +0900

    present: Use async flip for unflip if possible
    
    In that case, unflip operations should finish faster in general.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 9a951a3e551db58ba50e7a594521ceac54d90615
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Feb 28 18:06:55 2017 +0900

    present: Also flush before using a flip to unflip
    
    Not doing so might result in intermittently scanning out stale contents
    of the screen pixmap.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit f2bc882f1c1082bed9f496cfab6c8f07a76bc122
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Feb 28 17:31:14 2017 +0900

    Handle rotation in the driver also with Xorg 1.12-1.18
    
    We cannot use the HW cursor in that case, but in turn we get more
    efficient and less teary updates of rotated outputs.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit ae921a3150f69c38b5b3c88a9e37d54fdf0d5093
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Feb 28 17:47:09 2017 +0900

    Fold drmmode_crtc_scanout_allocate into drmmode_crtc_scanout_create
    
    Not used anywhere else anymore.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 987a34adb319923ad36e2b47a26837248f187c3e
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Feb 28 17:17:20 2017 +0900

    Call drmmode_crtc_scanout_create in drmmode_crtc_shadow_allocate as well
    
    Calling drmmode_crtc_scanout_allocate in drmmode_crtc_shadow_allocate
    resulted in drmmode_crtc_scanout_create called from
    drmmode_crtc_shadow_create passing an uninitialized pitch value to
    drmmode_create_bo_pixmap.
    
    Fixes issues such as failure to allocate the scanout pixmap or visual
    corruption and GPUVM faults when attempting to use rotation with Xorg
    <1.19.
    
    Bugzilla: https://bugs.freedesktop.org/99916
    Fixes: ea30d856ba5e ("Pass pitch from drmmode_crtc_scanout_allocate to drmmode_create_bo_pixmap")
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 244d4bc7f8c8f6bc90f49556c0b9344c8aa40295
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Feb 9 18:55:04 2017 +0900

    present: Wait for screen pixmap BO idle before setting modes for unflip
    
    To make sure the screen pixmap contents are up to date when it starts
    being scanned out.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 3ff29e5a14451916bc66b4e0028e9a317f0723f8
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Feb 9 18:50:40 2017 +0900

    present: Only call drmModeRmFB after setting modes for unflip
    
    Fixes display intermittently blanking when a modeset is used for unflip.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 0c29deb5a97d9a57e994cc0053c49ddf7aca6ecb
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Feb 21 16:56:27 2017 +0900

    Use drmmode_crtc_scanout_free in drmmode_fini
    
    We were leaking drmmode_crtc->scanout_damage, which caused trouble on
    server reset. Fixes server reset with active separate scanout pixmaps.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 58cd1600057e41aade0106d4acf78e23eac6e44f
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Dec 1 18:37:57 2016 +0900

    Allow toggling TearFree at runtime via output property
    
    Option "TearFree" now sets the default value of the output property.
    See the manpage update for details.
    
    TearFree is now enabled by default for outputs using rotation or other
    RandR transforms, and for RandR 1.4 slave outputs.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 305e2cbf335837a2ab6a24e9ff65815afe038296
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Feb 21 15:55:13 2017 +0900

    Factor out drmmode_crtc_scanout_update helper
    
    Cleanup in preparation for following change, no functional change
    intended.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 649644a88347a6d03de68f8c41db03a82deeb23b
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Feb 14 17:36:31 2017 +0900

    Factor out radeon_prime_dirty_to_crtc helper
    
    Cleanup in preparation for the following change, no functional change
    intended.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 1351e48efe7a2c28eab447e16f36a00fbd02ae48
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Feb 7 18:43:56 2017 +0900

    Don't destroy current FB if drmModeAddFB fails
    
    It would probably result in a black screen.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 481394e3c9f9f7d88bb66fe9ae8834c87952a8ab
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Feb 7 18:39:05 2017 +0900

    Fix flip event data leak if calloc or drmModeAddFB fails
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 80fc78633962c1ec996b1721bfb757b98dc85bfc
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Jan 31 16:25:37 2017 +0900

    Don't handle Option "SwapbuffersWait" at all with glamor
    
    It never had any effect with glamor.
    
    v2: Better formatting, no functional change from v1.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com> (v1)

commit d611d21d9bf9aaa100ff7a5762e5980634846207
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Jan 24 18:05:45 2017 +0900

    Enable tiling by default with glamor on PALM
    
    The DFS check is only relevant for EXA.
    
    The lack of tiling prevented DRI3 clients from using page flipping,
    resulting in tearing.
    
    Bugzilla: https://bugs.freedesktop.org/99491
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 55a33205cb9bd8091b4bcd478c2d1d191248681b
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Jan 24 18:22:49 2017 +0900

    Add 10-radeon.conf xorg.conf.d snippet
    
    This instructs Xorg >= 1.16 to try loading the radeon driver for devices
    managed by the radeon kernel driver, even if the ati wrapper driver
    isn't available.
    
    Copied from the amdgpu driver.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 8e6a4e96b7b27559e186f71b5547abb0a80b96dd
Author: Mihail Konev <k.mvc@ya.ru>
Date:   Thu Jan 26 14:00:22 2017 +1000

    autogen: add default patch prefix
    
    Signed-off-by: Mihail Konev <k.mvc@ya.ru>

commit e062933b5489705bdcba7a266d14ba6fd3e767ba
Author: Emil Velikov <emil.l.velikov@gmail.com>
Date:   Mon Mar 9 12:00:52 2015 +0000

    autogen.sh: use quoted string variables
    
    Place quotes around the $srcdir, $ORIGDIR and $0 variables to prevent
    fall-outs, when they contain space.
    
    Signed-off-by: Emil Velikov <emil.l.velikov@gmail.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 4fe183111f82d412760b175b3c9c8583acba804a
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Jan 24 10:32:07 2017 +1000

    autogen.sh: use exec instead of waiting for configure to finish
    
    Syncs the invocation of configure with the one from the server.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Emil Velikov <emil.velikov@collabora.com>

commit a1787e4615a76ab0bb12498be66591c86a6b07ae
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Jan 18 19:07:11 2017 +0900

    ati: Support loading the amdgpu driver from the ati wrapper
    
    If .../share/X11/xorg.conf.d/10-amdgpu.conf doesn't exist, but the ati
    wrapper is loaded, it will otherwise try to use the radeon driver even
    for GPUs driven by the amdgpu kernel driver. This can only fail,
    potentially in bad ways.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 41b82c776b571e1556f300d77c715aebdd87d8e6
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Jan 24 18:14:23 2017 +0900

    .editorconfig: src/ati.c only uses spaces for indentation
    
    Trivial.

commit ea30d856ba5e7274c8ea499293b8b0e721b8e082
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Jan 6 17:36:05 2017 +0900

    Pass pitch from drmmode_crtc_scanout_allocate to drmmode_create_bo_pixmap
    
    radeon_bo_get_tiling can fail, e.g. for linear BOs.
    
    Fixes TearFree not working in those cases.
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=97873
    Fixes: 040a7b80e1fc ("Explicitly set the fbcon pixmap pitch again")
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 720dd07e79b5f5cbbf3ef8bd92300578c485d583
Author: Jammy Zhou <Jammy.Zhou@amd.com>
Date:   Mon Dec 19 17:27:19 2016 +0900

    Use render node for DRI3 if available
    
    Signed-off-by: Jammy Zhou <Jammy.Zhou@amd.com>
    (ported from amdgpu commit ea558e645786b08d75307716036045170e97b43e)
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>
    [ Second attempt, let's see if there's any fallout this time... ]

commit 92fc387a6256ce3c95d62142735783ea07162c54
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Dec 15 12:44:47 2016 +0900

    Simplify drmmode_handle_uevents
    
    No functional change intended.
    
    Reviewed-by: Jim Qu <Jim.Qu@amd.com>
    (Cherry picked from amdgpu commit edd276185d42962a13faf9ec9eeebc754ef284e7.)

commit 404c64752774d23a2db9aa3134f6ada3155708c9
Author: jimqu <Jim.Qu@amd.com>
Date:   Wed Dec 14 11:46:16 2016 +0900

    udev_monitor_receive_device() will block when hotplug monitor
    
    udev_monitor_receive_device() will block and wait for the event of udev
    use select() to ensure that this will not block.
    
    Signed-off-by: JimQu <Jim.Qu@amd.com>
    Reviewed-by: Michel Dänzer <michel.daenzer@amd.com>
    (Cherry picked from amdgpu commit 732cf4d3a248b288532ad0f3443da49e08dc7507)

commit a89c0bced423ce3e09f66edafc35642a7cc03b2f
Author: Jochen Rollwagen <joro-2013@t-online.de>
Date:   Fri Dec 2 10:56:39 2016 +0100

    Calculate log base 2 in radeon.h based on clz for all platforms
    
    This commit replaces the inline assembler code (for x86 platforms) and
    loop (for non-x86 platforms) in RADEONLog2 with a one-liner version
    based on clz (count leading zeroes).
    
    Reviewed-by: Michel Dänzer <michel.daenzer@amd.com>

commit e2942449171fe628a7726e59bcaab65e27d88563
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Mon Nov 21 18:47:53 2016 +0900

    Call radeon_drm_abort_entry on failure to flip to a scanout pixmap
    
    Fixes leaking the corresponding struct radeon_drm_queue list entry in
    that case.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 14c3f59f5157885ad8f941f0bad6c0c5e3db12f8
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Mon Nov 21 18:45:30 2016 +0900

    Call ValidateGC after ChangeClip in radeon_sync_scanout_pixmaps
    
    The wrong order meant that the clipping region wasn't actually applied,
    so it always copied the full contents from the other scanout pixmap.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit a995f5830916a0fee5126263d1bfe48632be3a15
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Mon Nov 21 18:39:00 2016 +0900

    Fix radeon_scanout_extents_intersect for GPU screens
    
    Fixes incorrect screen updates with TearFree enabled on PRIME slave
    outputs which are not located at (0, 0).
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit e543ef3a2fb304cbe3a965fb780632af2e4186f4
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Mon Nov 21 18:33:25 2016 +0900

    Take current scanout_id into account everywhere involved with TearFree
    
    Fixes various potential issues with TearFree enabled, e.g. outputs
    freezing after display configuration changes.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit f130b10e63f7526360b41aa0918b4940f63f662a
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Nov 25 18:12:40 2016 +0900

    Add radeon_is_gpu_screen helper
    
    This will hopefully decrease the chance of accidentally breaking the
    build against xserver < 1.13 in the future.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 487aa62a2a23b86e4ea4714fdfd465c9e513141f
Author: Jochen Rollwagen <joro-2013@t-online.de>
Date:   Thu Nov 24 18:44:01 2016 +0100

    fix build for xserver < 1.13
    
    same procedure every few patches.....
    
    Fixes: 13c6bc5e3827 ("Don't install Flush/EventCallback for GPU screens")
    Reviewed-by: Michel Dänzer <michel.daenzer@amd.com>

commit 5fea5ef2f07eee4a0f94baab427010b936f1d4b4
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Nov 24 18:45:22 2016 +0900

    Pass fb_id into drmmode_page_flip_target_absolute/relative
    
    drmmode->fb_id isn't what we need in the TearFree case. Fixes TearFree
    freezing with
    
    (WW) RADEON(0): flip queue failed in radeon_scanout_flip: No such file or directory
    
    in the log file.
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=98834
    Fixes: 1106b2f773ad ("Use DRM_MODE_PAGE_FLIP_TARGET_ABSOLUTE/RELATIVE flags when available")

commit 13c6bc5e382765fe567091e1c616c0a26eec04ca
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Mon Aug 1 18:11:57 2016 +0900

    Don't install Flush/EventCallback for GPU screens
    
    Their purpose is to flush GPU rendering commands corresponding to damage
    events, but there can be no damage events corresponding to GPU screen
    rendering operations.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit f11531c99fcd6473f58b4d10efaf3efd84304d8e
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Mon Nov 21 18:15:05 2016 +0900

    Enable glamor by default with >= R600 and Xorg >= 1.18.3
    
    glamor should now perform at least as well as EXA in general, and this
    allows DRI3 to be enabled by default for >= R600.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 1106b2f773ad0611c729b27f4c192a26b43ef1e7
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Jul 6 15:25:33 2016 +0900

    Use DRM_MODE_PAGE_FLIP_TARGET_ABSOLUTE/RELATIVE flags when available
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit aab80d2203efb8569b26dd02a1c651c792e1ef0c
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Nov 18 12:11:38 2016 +0900

    Post-release version bump

commit 5cbe1ee8e499e1b6b2646e341946292721d07e69
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Nov 17 11:27:16 2016 +0900

    Bump version for 7.8.0 release

commit 68023e01842ed7e5c798be77c25993bbe6a5a966
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Nov 17 11:32:37 2016 +0900

    Update manpage entry for Option "TearFree"
    
    It's now effective for arbitrary transforms as well.

commit 9760ef33cba5795eddeda4d5c2fcbe2dcce21689
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Nov 8 13:02:43 2016 +0900

    Use pRADEONEnt to find both screens of a GPU in radeon_mode_hotplug
    
    Fixes misbehaviour when hotplugging DisplayPort connectors on secondary
    GPUs.
    
    Fixes: c801f9f10a5d ("Handle Zaphod mode correctly in radeon_mode_hotplug")
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=98626
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 35bec4937d89b48a79acfcb4f814b7370cb631b2
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Nov 8 13:01:58 2016 +0900

    Refactor radeon_mode_hotplug
    
    Preparation for the next change, no functional change intended.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit be9f67339a19a6649eab52aa2e0c8971cd9b4727
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Mon Nov 7 16:34:37 2016 +0900

    Reindent code in radeon_dri2_create_buffer2
    
    Fixes warning about misleading indentation from recent versions of gcc:
    
    ../../src/radeon_dri2.c: In function ‘radeon_dri2_create_buffer2’:
    ../../src/radeon_dri2.c:224:2: warning: this ‘if’ clause does not guard... [-Wmisleading-indentation]
      if (flags & RADEON_CREATE_PIXMAP_TILING_MACRO)
      ^~
    ../../src/radeon_dri2.c:227:6: note: ...this statement, but the latter is misleadingly indented as if it is guarded by the ‘if’
          if (aligned_width == front_width)
          ^~
    
    No functional change intended.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 350a2645a1b127227ff294c0b62d20000d0fd48a
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Nov 1 16:30:42 2016 +0900

    Check Xorg version at runtime instead of build time in two places
    
    This means that all possible paths can be handled as intended, no matter
    which Xorg version the driver happened to be compiled against.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 5df36de39952c3a26cb2fbc125f298139a9dd5bc
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Aug 26 18:24:08 2016 +0900

    Require xserver 1.10 or newer
    
    1.10.0 was released in February 2011.
    
    We've been accidentally requiring 1.10 or newer since 121a6de72da5 ("Keep
    track of damage event related flushes per-client v2").
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 22b5ce9548393ba2ff73ee234ecd82eeaf0ef6c4
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Oct 25 17:28:03 2016 +0900

    Consume all available udev events at once
    
    We get multiple udev events for actions like docking a laptop into its
    station or plugging a monitor to the station. By consuming as many
    events as we can, we reduce the number of output re-evalutions.
    
    It depends on the timing how many events can be consumed at once.
    
    (Inspired by xserver commit 363f4273dd4aec3e26cc57ecb6c20f27e6c813d8)
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 82d3c8f5500d2a6fb1495e217a0b79c396f1534c
Author: Hans de Goede <hdegoede@redhat.com>
Date:   Tue Oct 25 16:56:40 2016 +0900

    PRIME: Fix swapping of provider sink / source capabilities
    
    When a card has import capability it can be an offload _sink_, not a
    source and vice versa for export capability.
    
    This went unnoticed sofar because most gpus have both import and export
    capability.
    
    Signed-off-by: Hans de Goede <hdegoede@redhat.com>
    (Ported from xserver commit 94a1c77259ce39ba59ad87615df39b570ffab435)
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 6c940446ddadf418ee4959e46fa552b6c1cf6704
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Oct 25 16:42:03 2016 +0900

    Always call PixmapStopDirtyTracking in drmmode_set_scanout_pixmap
    
    Otherwise, we may leak screen->pixmap_dirty_list entries if
    drmmode_set_scanout_pixmap is called repatedly with ppix != NULL, which
    can happen from RRReplaceScanoutPixmap.
    
    (Inspired by xserver commit b773a9c8126222e5fed2904d012fbf917a9f22fd)
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 61df12e2377cbb19a19ca9d5624df8959822da9f
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Oct 19 18:55:33 2016 +0900

    Don't rely on randr_crtc->scanout_pixmap in drmmode_set_scanout_pixmap
    
    RRReplaceScanoutPixmap may set randr_crtc->scanout_pixmap = NULL before
    we get here.
    
    (Inspired by xserver commit f4c37eeee7953df1fe0e3196eda452acf0078e61)
    v2: Always return TRUE in the if (!ppix) block.
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com> (v1)

commit 49cf3b5032a7ce40afe514b7092440e3e19e05aa
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Oct 20 15:33:09 2016 +0900

    Sayōnara, AM_MAINTAINER_MODE!
    
    If --enable-maintainer-mode got lost from config.status for any reason,
    builds would fail in mysterious ways after changing between different
    Git commits.
    
    There are more reasons for dropping it in the automake manual:
    
    https://www.gnu.org/software/automake/manual/html_node/maintainer_002dmode.html
    
    I'm not aware of any reason why --disable-maintainer-mode would ever be
    useful with this project.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 4b17de1cad12e7be12f2c71e5149bfc04564702d
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Oct 19 18:09:14 2016 +0900

    Remove PCI IDs and bus type from ati_pciids.csv
    
    This cleans up the list of unique chipsets a little further.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 1ce1b1656acc6211deb2091ff7f28d51b6daf86b
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Oct 19 18:08:36 2016 +0900

    Order unique chipsets according to first appearance in ati_pciids.csv
    
    Instead of lexically. This makes it more likely for similar generations
    to be close to each other in the list of unique chipsets.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 7c66be961de3477fc685eb71b46265adbae923f0
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Mon Oct 17 18:38:55 2016 +0900

    Enable HW cursor support with PRIME slave output & Xorg > 1.18.99.901
    
    Supported since Xorg 1.18.99.2, but buggy until 1.18.99.901.
    
    (Ported from amdgpu commit 7cc04035c55788261cda89a915c433c2add6cad9)
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit d016f20b14ffe4f90f7457375b2d9f5cf0f5650f
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Oct 13 16:33:45 2016 +0900

    Restore location of radeon_set_pixmap_bo call in drmmode_create_bo_pixmap
    
    radeon_set_pixmap_bo sets the tiling flags, so it needs to be called
    before radeon_get_pixmap_tiling_flags. Fixes a regression with EXA and
    TearFree.
    
    Fixes: 8523a733b6a5 ("Propagate failure from radeon_set_pixmap_bo")
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=98097
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 937398f6cd50db105d5e53ab553eb284d44121f4
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Oct 6 18:52:37 2016 +0900

    Rotate and reflect cursor hotspot position for drmModeSetCursor2
    
    We were always passing the hotspot position in the X screen coordinate
    space, but drmModeSetCursor2 needs it in the CRTC coordinate space. The
    wrong hotspot position would cause the kernel driver to adjust the
    HW cursor position incorrectly when the hotspot position changed.
    
    (Ported from amdgpu commit d42773eb45baff5933730e26878a0b45fcf07b65)
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 3fc839ff49f01c24eb94d5e1f0ab4065de47bc17
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Sep 21 17:50:36 2016 +0900

    Only list each unique chipset family once in the log file
    
    (Ported from amdgpu commit 6a1ba044c2b71081e6060d0c096917d6238f2145)

commit 9a5eb1915a240e3021ac38a6dacafef81e7bb743
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Sep 21 17:48:38 2016 +0900

    Clear damage in radeon_scanout_update if it doesn't intersect the CRTC
    
    There's no need to test that same damage again.
    
    (Ported from amdgpu commit a576430526cbc404de64b30e1377a356644e8024)

commit 792a30dbe5f7d7815ea14032dbab55b5de8eabca
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Sep 21 17:43:57 2016 +0900

    Remove w/h parameters from radeon_scanout_extents_intersect
    
    We can use the dimensions of the CRTC's mode instead.
    
    (Ported from amdgpu commit ede7f2bcae63be65e05e3029bfe7c742e5978932)

commit 80d794f11a5f047663897e4349da75d89ceff7c7
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Sep 21 17:38:57 2016 +0900

    Make the dedicated scanout mechanism work with arbitrary transforms
    
    This makes TearFree work with arbitrary transforms, and makes transforms
    work better even without TearFree, with xserver >= 1.12.
    
    (Ported from amdgpu commit bf000ea7ef91f5ecb59fc3c1ab8ed9eddcc0841d)

commit 09ba7b3b7b1b724aa386dbf2d33f567d7f26326b
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Sep 21 17:00:22 2016 +0900

    Remove drmmode_load_palette
    
    Not used by any supported version of xserver.
    
    (Ported from amdgpu commits 1091f28e1fa239ee1a973d84a8376fa4a95d7247
     and 5a4d3267ac3823fe58b51b0b9075b82375d7180c)

commit 730f443955cf2bcedd760c9fef5b11c81eacdd84
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Sep 21 16:48:49 2016 +0900

    present: Separate checks for flips vs unflips
    
    All unflip checks apply to flips as well, but not vice versa.
    
    (Ported from amdgpu commit 4d506c23c9a628204fa23607931557b07ada3e31)

commit 343d28672411a510de21fa57986324ef8bcdd1b6
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Sep 21 16:47:17 2016 +0900

    dri2: Don't allow flipping when using a dedicated scanout buffer
    
    Fixes issues when mixing rotation and page flipping with current xserver
    Git master.
    
    (Ported from amdgpu commit decabd574f90d3df397c80ec931b3fde8a4afb49)

commit 83e4781d15d66d6fa0e153eb4cd0e3d9e2ebed9f
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Sep 21 16:44:50 2016 +0900

    present: Don't allow flipping when using a dedicated scanout buffer
    
    Fixes issues when mixing rotation and page flipping with current xserver
    Git master.
    
    (Ported from amdgpu commit 3ed28ce7cd26f89969617ba901ff253091d0d469)

commit 8419db3de6157875f9a840773350ecd29cd42d83
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Sep 21 16:40:42 2016 +0900

    Make sure drmmode_crtc->scanout[] are destroyed when not needed
    
    We failed to do this when going back to scanning out directly from the
    screen pixmap.
    
    As a bonus, since we now destroy drmmode_crtc->scanout[] after setting
    the new scanout buffer, we may avoid the CRTC turning off intermittently
    in this case.
    
    (Ported from amdgpu commit 9c3324715fd395fd486ea341654d78f4f298b97f)

commit 956e03d6a6b9478dd8e77c81f426c0d371c5d7a1
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Sep 21 16:37:53 2016 +0900

    Simplify drmmode_set_mode_major error handling
    
    Initialize ret = FALSE and only set it to TRUE when we've succeeded.
    
    (Ported from amdgpu commit 3bce0519a4008cf87c0e31a7a579e10f5dcdd2f3)

commit ace455d1db4db3f9b8b434a3747acfa7e1273db4
Author: Hans de Goede <hdegoede@redhat.com>
Date:   Wed Sep 21 16:31:51 2016 +0900

    Only add main fb if necessary
    
    If we're doing reverse-prime; or doing rotation the main fb is not used,
    and there is no reason to add it in this case.
    
    Signed-off-by: Hans de Goede <hdegoede@redhat.com>
    (Ported from xserver commit 4313122dea0df9affc280ee698e929489061ccc6)
    (Ported from amdgpu commit a3ca1500703837cbb8d49c554199a25dea7d5e1e)

commit eea370dc4f96e680cc29b416fe62d6e2ea09bc91
Author: Hans de Goede <hdegoede@redhat.com>
Date:   Wed Sep 21 16:27:11 2016 +0900

    Remove unnecessary fb addition from drmmode_xf86crtc_resize
    
    drmmode_set_mode_major() is the only user of drmmode->fb_id and will
    create it if necessary.
    
    Signed-off-by: Hans de Goede <hdegoede@redhat.com>
    (Ported from xserver commit 877453212166fdc912e0d687cdecee11aba563b5)
    (Ported from amdgpu commit 9ca1c24235ff5ab2e028333fc326e2eff008c574)

commit cf52c76484a4adfa3e0b2271ea0c00f46d32ca48
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Sep 13 18:21:37 2016 +0900

    Free priv in amdgpu_set_pixmap_bo also if priv->bo == NULL
    
    Fixes memory leak when destroying pixmaps with priv->bo == NULL.
    
    Reported-by: Qiang Yu <qiang.yu@amd.com>
    (Ported from amdgpu commit 7f7f9825caf3983902491da27c16d14cd8bf9b7d)

commit 50abcc19e29bb50451d031b2c9e99d691d4faf70
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Sep 13 18:18:37 2016 +0900

    glamor: Fix leak of pixmap private when replacing BO
    
    Reported-by: Qiang Yu <qiang.yu@amd.com>
    (Ported from amdgpu commit 397aedafee437c125b8ac1feafb1c3b466842aeb)

commit 8523a733b6a5de6116a6332fefc871d4c32652d8
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Mon Sep 12 18:54:33 2016 +0900

    Propagate failure from radeon_set_pixmap_bo
    
    (Ported from amdgpu commits c315c00e44afc91a7c8e2eab5af836d9643ebb88
     and 0d42082108c264568e2aadd15ace70e72388bc65)

commit 53be26b00e83f871f0afd39caa5a7a1d6ec4aea1
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Aug 31 16:46:56 2016 +0900

    Add support for ScreenPtr::SyncSharedPixmap
    
    This allows deferring shared pixmap updates between different drivers.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 156b5bc00da2eecb71cad517136f8cd74cf5d2c9
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Sep 20 17:50:20 2016 +0900

    Only define transform_region function for XF86_CRTC_VERSION >= 4
    
    We're not using it with older xserver.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 80cc892ee1ce54fad3cb7dd11bd9df18c359136f
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Sep 20 17:45:16 2016 +0900

    Use local implementation of RegionDuplicate for older xserver
    
    It was only added in xserver 1.15. Fixes build against older xserver.
    
    Reported-by: Pali Rohár <pali.rohar@gmail.com>
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 12d30eeb9711bd2b1609d6bbb74c4a1760596f72
Author: Qiang Yu <Qiang.Yu@amd.com>
Date:   Wed Sep 14 17:03:03 2016 +0900

    DRI2: Fix radeon_dri2_exchange_buffers width/height copy'n'paste error
    
    Signed-off-by: Qiang Yu <Qiang.Yu@amd.com>
    (Ported from amdgpu commit 73c8dc000ad6b2b53ba3aa7155f5e8f6b55623b7)
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 11cc6843aa3b745aa1361f1a65e465e16696b914
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Sep 14 17:01:13 2016 +0900

    DRI2: Add interpolated_vblanks in radeon_dri2_get_crtc_msc
    
    We need that in radeon_dri2_drawable_crtc as well for priv->vblank_delta
    to work as intended.
    
    radeon_dri2_get_msc was already doing this.
    
    Fixes hangs in some cases when using VDPAU via DRI2 and moving the
    window between CRTCs.
    
    (Ported from amdgpu commit abd1a7901c95e4bc78415cf1b7923623b9177152)
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 380daff43cfefe2a8e4d496eaf65673f2815c878
Author: Qiang Yu <Qiang.Yu@amd.com>
Date:   Wed Sep 14 16:59:38 2016 +0900

    Fix radeon_mode_hotplug crash on multi GPU platform.
    
    On multi GPU platform, some screen is created by other GPU DDX.
    
    Signed-off-by: Qiang Yu <Qiang.Yu@amd.com>
    (Ported from amdgpu commit 978242977e5dc905e1d5a46b1b0d34b356c7af26)
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 4a5fa37f74c233c6b9c6a08306688628a8e216e8
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Sep 14 16:56:22 2016 +0900

    Destroy all dedicated scanout buffers during CloseScreen
    
    Fixes leaking active scanout buffers across a server reset, which also
    fixes server reset with glamor and active scanout buffers.
    
    (Ported from amdgpu commit d96dabc71b1b32dc4b422a9633cdd4e0e95da052)
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit cc2555835cd4c5fd2ae4f999a4bf7c18cdb1dda4
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Mon Sep 12 18:26:57 2016 +0900

    glamor: Reallocate linear pixmap BO if necessary for DRI2 PRIME
    
    Fixes corruption when using DRI2 PRIME render offloading with the master
    screen using this driver.
    
    (Ported from amdgpu commit 0007c2f018ba663303d91d847e7c085269a23062)
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit b3e5259e60157fdbdf46ee59b1b78995c2b15f72
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Mon Sep 12 18:12:06 2016 +0900

    Move DRI2's local fixup_glamor helper to radeon_glamor_set_pixmap_bo
    
    So it can be used outside of the DRI2 code.
    
    (Ported from amdgpu commit 5518bf5d793439b5bab369e5fc18de9a4a3b9dd6)
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 38632bbd5ff80a9cf8ce584b2bc499d17d15befe
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Mon Sep 12 18:05:51 2016 +0900

    Consolidate get_drawable_pixmap helper
    
    There were two static helpers for the same purpose. Consolidate them
    into a single inline helper which can be used anywhere.
    
    (Ported from amdgpu commit 641f4647b7f51dfd2da330376cd10fa9702b6423)
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit e91858e435672c32f9c4a854b3dec048199d6f7f
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Mon Sep 12 18:02:07 2016 +0900

    glamor: Fix radeon_glamor_share_pixmap_backing for priv->bo == NULL
    
    Fixes crash when running a compositor and DRI_PRIME client via DRI2.
    
    Reported-by: Qiang Yu <qiang.yu@amd.com>
    (Ported from amdgpu commit b36c77695ba77b59a0ccd868454e3af4fc04d5ff)
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 38797a33117222dadbc89e5f21ed8cd5deef9bea
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Sep 2 11:08:28 2016 +0900

    Make TearFree effective with PRIME slave scanout
    
    TearFree can now prevent tearing with any possible display
    configuration.
    
    Note that there may still be inter-GPU tearing if the primary GPU uses
    a different driver.
    
    v2:
    * Also test dirty->slave_dst in radeon_prime_scanout_do_update
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com> [v1]

commit eda1f3df6aaed683036369fe8820da4dac3c2ae2
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Sep 1 12:54:13 2016 +0900

    Synchronize scanout pixmaps for TearFree
    
    Copy the damaged areas which are still valid in the other scanout pixmap
    from there, then only copy the remaining damaged area from the screen
    pixmap.
    
    This is slightly more efficient (only needs one Damage record instead of
    two, and only needs to copy each screen update across PCIe once with
    ShadowPrimary and a discrete GPU), and will be significantly more
    efficient for PRIME with the following change.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 2f6e5fb15f1a9ce523c85550e493f8bda9d0c00f
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Sep 2 17:23:16 2016 +0900

    Move up radeon_scanout_extents_intersect
    
    Will be needed higher up by the following changes. No functional change.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 5a57005178fc13b6f7e513458ca6dae72a3e5783
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Sep 1 17:19:27 2016 +0900

    Factor out transform_region helper
    
    While we're at it, fix leaking the memory allocated for xRectangles.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 99232f64db52812a843cd616d263d3a6b90eef3d
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Dec 1 17:58:13 2015 +0900

    Only copy from screen pixmap to shared pixmap on demand for slave scanout
    
    Only copy once for each time we update the corresponding scanout pixmap.
    This can significantly reduce the bandwidth usage when there are
    frequent updates to the screen pixmap.
    
    This initial implementation only works when both the master and slave
    screens use this driver.
    
    v2:
    * Reduce churn in radeon_prime_scanout_update_handler
    * Clear the correct damage in radeon_dirty_update
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit a92c27484703abc7c410b6ae0e4b8d1efbbb8e6f
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Aug 26 18:09:03 2016 +0900

    Fix build against xserver < 1.13
    
    pScreen->isGPU was only introduced in 1.13.
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=97490
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 4bd2d01552f18153afa03a8947b22eebf3d67c6b
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Aug 26 12:02:38 2016 +0900

    Also handle disabled CRTCs in drmmode_clear_pending_flip
    
    If disabling a CRTC had to be deferred due to a pending flip in
    drmmode_crtc_dpms, there may no longer be any outputs associated with
    the CRTC when we get here. So we have to check for !crtc->enabled and
    call drmmode_crtc_dpms in that case as well.
    
    Fixes: 9090309e057d ("Wait for pending flips to complete before turning
    off an output or CRTC")
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit a36fdaff40d5b4795a1400c348a80eee94892212
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Aug 24 22:52:11 2016 +0900

    Don't override crtc parameter value in drmmode_flip_handler/abort
    
    When overriding the crtc parameter value of the last pending CRTC,
    drmmode_clear_pending_flip would work on the wrong CRTC, and the last
    pending CRTC's flip_pending flag might never get cleared. This would
    prevent that CRTC from properly turning off and back on again.
    
    Fixes: 9090309e057d ("Wait for pending flips to complete before turning
    off an output or CRTC")
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=97392
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit e520ce0ec0adf91ddce5c932d4b3f9477fd49304
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Aug 25 18:22:34 2016 +0900

    Also call drmmode_clear_pending_flip from radeon_scanout_flip_abort
    
    Not doing so could break DPMS with TearFree.
    
    Reported-and-Tested-by: furkan on IRC
    Fixes: 9090309e057d ("Wait for pending flips to complete before turning
    off an output or CRTC")
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit b0867063abb197b9134166706d99fcbe5f204bb5
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Mon Nov 30 18:54:12 2015 +0900

    Track damage accurately for RandR 1.4 slave scanout
    
    This further reduces the PCIe bandwidth usage.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit ad0a0656dd0e74683e6d7789decba827aa29c221
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Nov 27 16:31:21 2015 +0900

    Handle RandR 1.4 slave dirty updates via radeon_drm_queue
    
    This reduces PCIe bandwidth usage and tearing.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 4cfa4615f79f64062e5e771cd45dd7048f48b4f6
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Nov 27 16:53:30 2015 +0900

    Use drmmode_crtc_scanout_* helpers for RandR 1.4 scanout pixmaps
    
    This should allow using multiple CRTCs via RandR 1.4 even with xserver
    < 1.17. It also simplifies the code a little, and paves the way for
    following changes.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 121a6de72da5fcf9a32408eff36b2235f3dfbcfe
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Mon Jul 11 12:51:46 2016 +0900

    Keep track of damage event related flushes per-client v2
    
    This further reduces the compositing slowdown due to flushing overhead,
    by only flushing when the X server actually sends XDamageNotify events
    to a client, and there hasn't been a flush yet in the meantime.
    
    v2: Use ScreenPrivateKey, fixes invalid memory access with GPU screens
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 9090309e057dc703d1a5bffd88e6cae14108cfc3
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue May 10 18:45:30 2016 +0900

    Wait for pending flips to complete before turning off an output or CRTC
    
    At least with older kernels, the flip may never complete otherwise,
    which can result in us hanging in drmmode_set_mode_major.
    
    Fixes: https://bugs.launchpad.net/ubuntu/+source/xserver-xorg-video-ati/+bug/1577170
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 9a1afbf61fbb2827c86bd86d295fa0848980d60b
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Mon Jul 11 12:22:09 2016 +0900

    Use EventCallback to avoid flushing every time in the FlushCallback
    
    We only need to flush for XDamageNotify events.
    
    Significantly reduces compositing slowdown due to flushing overhead, in
    particular with glamor.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 94fe42f29e0b00a26e810581d6c438ac6d8ecd8a
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Jul 12 17:36:27 2016 +0900

    Don't enable DRI3 by default with EXA
    
    It doesn't work correctly in all cases, see e.g.
    https://bugs.freedesktop.org/show_bug.cgi?id=95475 . I'm not sure this
    is fixable, given EXA's architecture.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 6d91fb4fc701895473ff675f440a8eef655e80ca
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Jul 12 15:57:28 2016 +0900

    Don't enable micro-tiling for scanout buffers on pre-R600
    
    The display engine didn't support it.
    
    Fixes display corruption with options "TearFree" and "ShadowPrimary"
    (and rotation or transforms with current xserver) on pre-R600.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit a37af701768b12d86868a831a79f1e02ee4968cf
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Jul 6 12:46:01 2016 +0900

    Add explicit RADEON_DRM_QUEUE_ERROR define
    
    Should make the radeon_drm_queue_alloc error handling clearer, and gets
    rid of a compile warning about it returning NULL.
    
    Reviewed-by: Alexandre Demers <alexandre.f.demers@gmail.com>

commit 024afff27eb9f4c60043214099ddb42bbfb3d289
Author: Keith Packard <keithp@keithp.com>
Date:   Mon Jul 18 21:24:23 2016 -0700

    Adapt to video API 22
    
    Deal with drm fd wakeup
    
    Signed-off-by: Keith Packard <keithp@keithp.com>
    Reviewed-and-Tested-by: Michel Dänzer <michel.daenzer@amd.com>

commit eac4db4f0cb22a23d6e69161dcaacc7d53978aae
Author: Adam Jackson <ajax@redhat.com>
Date:   Tue Jul 19 10:03:56 2016 -0400

    Adapt Block/WakeupHandler signature for ABI 23
    
    Signed-off-by: Adam Jackson <ajax@redhat.com>

commit 3be841d0ae7d505cef325993205b12d15e98dba9
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Jun 24 11:12:49 2016 +0900

    Only use RandR APIs if RandR is enabled
    
    Fixes crash with Xinerama enabled, which disables RandR.
    
    Fixes: https://bugs.debian.org/827984
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 7835558acdce318130ba4a09ef936fd675e3197d
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Mon Mar 28 18:49:15 2016 +0900

    Adapt to XF86_CRTC_VERSION 7
    
    Now the HW cursor can be used with TearFree rotation.
    
    This also allows always using the separate scanout pixmap mechanism for
    rotation, so that should be much smoother even without TearFree enabled.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 0945db4d902056bda3d9ad4a4de2dfa685d10a70
Author: Tan Hu <tan.hu@zte.com.cn>
Date:   Fri May 27 17:05:15 2016 +0800

    EXA/6xx/7xx: accelerate PictOpOver with component alpha
    
    Subpixel text rendering is typically done with a solid src and
    a pixmap mask. Traditionally, this cannot be accelerated in a single
    pass and requires two passes [1]. However, we can cheat a little
    with a constant blend color.
    
    We can use:
    const.A = src.A / src.A
    const.R = src.R / src.A
    const.G = src.G / src.A
    const.B = src.B / src.A
    
    dst.A = const.A * (src.A * mask.A) + (1 - (src.A * mask.A)) * dst.A
    dst.R = const.R * (src.A * mask.R) + (1 - (src.A * mask.R)) * dst.R
    dst.G = const.G * (src.A * mask.G) + (1 - (src.A * mask.G)) * dst.G
    dst.B = const.B * (src.A * mask.B) + (1 - (src.A * mask.B)) * dst.B
    
    This only needs a single source value. src.A is cancelled down in
    the right places.
    
    [1] http://anholt.livejournal.com/32058.html
    
    r6xx still be used on some machine,
    Ported from commit 4375a6e75e5d41139be7031a0dee58c057ecbd07.
    
    Signed-off-by: Tan Hu <tan.hu@zte.com.cn>
    Reviewed-by: Grigori Goronzy <greg@chown.ath.cx>

commit 9b9ad669c748f53247e53fa3f3b03a77da5e5cb3
Author: Tan Hu <tan.hu@zte.com.cn>
Date:   Fri May 27 17:05:14 2016 +0800

    EXA/6xx/7xx: fast solid pixmap support
    
    Solid pixmaps are currently implemented with scratch pixmaps, which
    is slow. This replaces the hack with a proper implementation. The
    Composite shader can now either sample a src/mask or use a constant
    value.
    
    r6xx still be used on some machine,
    Ported from commit 94d0d14914a025525a0766669b556eaa6681def7.
    
    Signed-off-by: Tan Hu <tan.hu@zte.com.cn>
    Reviewed-by: Grigori Goronzy <greg@chown.ath.cx>

commit aa07b365d7b0610411e118f105e49daff5f5a5cf
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue May 31 18:16:26 2016 +0900

    Add .editorconfig file
    
    Basically a conversion from .dir-locals.el, but also correctly handles
    files which predominantly use tabs for indentation.
    
    Also, EditorConfig supports many more editors and IDEs.
    
    Acked-by: Alex Deucher <alexander.deucher@amd.com>

commit 040a7b80e1fcbaa93ac17f7113d696d9b853cf8a
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Apr 12 18:18:43 2016 +0900

    Explicitly set the fbcon pixmap pitch again
    
    The kernel driver returns 0 as the pitch of the fbcon BO via the
    DRM_RADEON_GEM_GET_TILING ioctl, so we ended up using an incorrect
    pitch in some cases.
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=94901
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 1181b9c582f10b6c523e4b2988e2ce87ecf3d367
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue May 10 19:02:20 2016 +0900

    Enable DRI3 by default when building for Xorg >= 1.18.3
    
    Seems to work well enough in general now.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit c801f9f10a5d72d935faf21e72f7e7808fb4f05f
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Apr 13 11:12:38 2016 +0900

    Handle Zaphod mode correctly in radeon_mode_hotplug
    
    We need to scan both screens of the entity for existing connectors, and
    enumerate DVI & HDMI connectors consistently regardless of which screen
    they're assigned to.
    
    Fixes crash when hot-(un)plugging connectors in Zaphod mode.
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=93415
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 1ca677309720e2f6c953c9e76f5b34c22a4416c6
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Mar 15 16:47:35 2016 +0900

    present: Support async flips
    
    The xserver Present code only calls radeon_present_flip with
    sync_flip=FALSE if radeon_present_screen_init sets
    PresentCapabilityAsync, and the latter only sets it if the kernel driver
    advertises support for async flips.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 90a915c62d012e99193833aecc93974e68880c60
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Mar 15 16:42:16 2016 +0900

    Add support for async flips to radeon_do_pageflip
    
    Will be used by the next change. No functional change here.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit ba8b6288c8e6fc4be5d7144ecbe9a1f241881674
Author: Qiang Yu <Qiang.Yu@amd.com>
Date:   Mon Apr 11 16:35:37 2016 +0900

    Remove RR_Capability_SinkOutput for GPU without CRTC
    
    Signed-off-by: Qiang Yu <Qiang.Yu@amd.com>
    (Ported from amdgpu commit a0bbb373f902e0ffc14570c85faec7e44134f62e)
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit bd4c72c8625996d842824ce4963f2d759fe2954a
Author: Tom St Denis <tom.stdenis@amd.com>
Date:   Fri Apr 8 10:22:11 2016 -0400

    dri3: Return NULL from radeon_dri3_pixmap_from_fd if calloc fails.
    
    Signed-off-by: Tom St Denis <tom.stdenis@amd.com>
    Reviewed-by: Michel Dänzer <michel.daenzer@amd.com>

commit 3300ea01fbdf770dc084eebbf2854fba35144220
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Mon Apr 11 16:11:57 2016 +0900

    Post 7.7.0 release version bump

commit df6662864b56d1aeeea4c67d9b668e64197afb20
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Apr 7 11:44:05 2016 +0900

    Bump version for 7.7.0 release

commit c12614cfdc5729041c204e3ead1dbfde38011f0c
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Mon Apr 4 14:59:41 2016 +0900

    Update manpage entry for Option "TearFree"
    
    It's now effective for rotation as well.
    
    (Ported from amdgpu commit faf9d720b7d650f5f1ea657a874d08eac3972e60)
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 4693b1bd5b5c381e8b7b68a6f7f0c6696d6a68df
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Mar 31 17:02:55 2016 +0900

    Identify DRM event queue entries by sequence number instead of by pointer
    
    If the memory for an entry was allocated at the same address as that for
    a previously cancelled entry, the handler could theoretically be called
    prematurely, triggered by the DRM event which was submitted for the
    cancelled entry.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 83734317e6bdaeebb4462a63f541e73a1d7c2f77
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Mar 30 11:44:09 2016 +0900

    Update pixmap pitch in radeon_set_pixmap_bo
    
    Stop second guessing it in drmmode_crtc_scanout_create.
    
    Fixes display corruption in some cases with TearFree enabled.
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=94751
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 0b3aac1de9db42bfca545fa331e4985836682ec7
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Mon Mar 28 18:43:36 2016 +0900

    DRI3: Refuse to open DRM file descriptor for ssh clients (v2)
    
    Fixes hangs when attempting to use DRI3 on display connections forwarded
    via SSH.
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=93261
    
    v2: Don't do this for Xorg > 1.18.99.1 since the corresponding xserver
        change has landed in Git master.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com> (v1)

commit 8a6cd4bda05b9569b3dd0a5a75b2cc385b9ecba9
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Mar 25 11:50:15 2016 +0900

    Revert "Use render node for DRI3 if available"
    
    This reverts commit cd94248ffa7d8fe0b57476f79e7e860dee66d1b0.
    
    It broke VDPAU<->GL interop with DRI3 enabled, because the Gallium VDPAU
    code doesn't support DRI3 yet. We can consider re-enabling this once
    there is a Mesa release where the Gallium VDPAU code supports DRI3.
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=94675
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit ed31cffba0d1bd4b14e5348a1456e4377277059c
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Mar 24 18:08:22 2016 +0900

    Call RADEONBlockHandler_KMS before setting initial modes
    
    Doing it the other way around meant that there was still a possibility
    for the front buffer contents to be uninitialized when they start being
    scanned out.
    
    (Ported from amdgpu commit 4a60b4b1851a3cbc2d8ad9048d68eeb6947cf132)
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit e592f32f8b5f5873fcc18b10a69dd5e4ccf11073
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Mar 23 18:25:48 2016 +0900

    Require xserver 1.9 or newer
    
    1.9.0 was released in August 2010.
    
    We were already unintentionally relying on things not available in 1.8
    for at least a year, and nobody has complained.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit bde466e5d44cad64b4e4eceaa5de80fdbf86356e
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Mar 23 18:16:42 2016 +0900

    Fix build against older versions of xserver
    
    Also slightly clean up the error handling in radeon_scanout_do_update.
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=94614
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit b2b079be0e7ef2704c3df9ee25fe46166e450e83
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Mar 23 17:29:47 2016 +0900

    Use radeon_alloc_pixmap_bo for allocating scanout BOs
    
    This enables tiling for scanout BOs used for TearFree / ShadowPrimary,
    and simplifies the code a little.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit d21ac4669a8b2cdd4eec5e5a94d1950b7423b8b5
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Mar 23 17:27:27 2016 +0900

    DRI3 only works with acceleration
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=94214
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit eb1a2c57e6c45d7ca57b2e2be643194243b7aae1
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Mar 23 17:23:31 2016 +0900

    TearFree can only work with acceleration
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit d670c5c9851b4eff21c845d26c7d7e4eb5ee0fa9
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Mar 18 16:46:08 2016 +0900

    Check for xf86CursorResetCursor
    
    If it's available, Xorg calls it on each mode configuration change. It
    does what xf86_reload_cursors does (and more), so we don't need to call
    the latter anymore.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 7f3d0780ca65a90117c2a61362dbc0899bd9c0b0
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Mar 9 18:28:47 2016 +0900

    Don't try DRI2/Present flipping while the HW cursor can't be used
    
    Flipping doesn't interact correctly with SW cursor: A flip makes the SW
    cursor disappear. It will only appear again when the cursor is moved,
    but it will be surrounded by corruption, because the SW cursor code
    will restore stale screen contents at the old cursor location before
    drawing the cursor at the new location.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 3de480e83c0a1824838d662d6d67c9fe85277298
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Mar 9 16:44:32 2016 +0900

    Factor out HW cursor checking code into drmmode_can_use_hw_cursor
    
    And add a check for RandR 1.4 multihead.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 2e0b458e747c7df81dd5f9579a762262af3350e1
Author: Ryan Kennedy <Ryan.Kennedy@amd.com>
Date:   Sun Mar 20 17:57:56 2016 -0400

    Use correct tiling in drmmode_create_bo_pixmap
    
    The callers were using 0 for the tiling flags, causing surfaces to be
    incorrectly treated as linear. This issue was causing corruption on Cayman
    just after login with GNOME3. The kernel was rejecting the cs in
    drmmode_copy_fb due to invalid texture pitch.
    
    Signed-off-by: Ryan Kennedy <Ryan.Kennedy@amd.com>
    Reviewed-by: Michel Dänzer <michel.daenzer@amd.com>

commit a03271de5ecdaa7790d1316e993c4450b91fe936
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Mar 9 18:23:10 2016 +0900

    present: Return rotated CRTCs from radeon_present_get_crtc
    
    Sync-to-vblank works fine with rotation. We're still checking for
    rotation in radeon_present_check_flip.
    
    Returning NULL from here resulted in the xserver present code falling
    back to the fake CRTC running at 1 fps.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 40191d82370eb7e58bd34c44966cbf44c3703229
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Mar 9 18:15:57 2016 +0900

    present: Clear drmmode->fb_id before calling set_mode_major for unflip
    
    Without this, drmmode_set_mode_major may just re-set the FB for the
    last flipped BO, in which case the display will probably freeze.
    
    Reproduction recipe: Enable rotation while a fullscreen client is
    flipping.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 798c4fd16d339b1ad5fd729cc884be084c60e38b
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Dec 25 18:57:42 2015 +0900

    Make Option "TearFree" effective for rotated/reflected outputs as well (v2)
    
    Support varies by xserver version:
    
    < 1.12:    No support for the driver handling rotation/reflection
    1.12-1.15: Support for driver handling rotation/reflection, but there's
               a bug preventing the HW cursor from being visible everywhere
               it should be on rotated outputs, so we can only support
               TearFree for reflection.
    >= 1.16:   While the bug above is still there (fixes pending review),
               the driver can force SW cursor for rotated outputs, so we
               can support TearFree for rotation as well.
    
    v2: Don't set crtc->driverIsPerformingTransform after xf86CrtcRotate if
        it wasn't set before. Fixes breaking rotation with TearFree disabled.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com> (v1)

commit eb611a2e4ecce7a1ab85fd72b9b78e3269311dd5
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Feb 2 18:04:11 2016 +0900

    Consolidate pScreen usage in drmmode_set_mode_major
    
    We were already relying on pScrn->pScreen being non-NULL in some cases,
    which is supposedly always true ever since this function is no longer
    getting called from ScreenInit.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 06602171386e538081c298645fb7ca1a70fe80cc
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Feb 4 17:13:57 2016 +0900

    Remove check for XF86_CRTC_VERSION 3
    
    We require xserver >= 1.8, which was already at version 3.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit a88985f5d1e39caca49ceb65678aaa9cb622a0d2
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Mon Feb 29 18:12:43 2016 +0900

    Deal with modesets and page flips crossing on a CRTC
    
    If we set a mode while a flip is pending, the kernel driver may program
    the flip to the hardware after the modeset. If that happens, the hardware
    will display the BO from the flip, whereas we will assume it displays the
    BO from the modeset. In other words, the display will most likely freeze,
    at least until another modeset.
    
    Prevent this condition by waiting for a pending flip to finish before
    setting a mode.
    
    Fixes display freezing when setting rotation or a transform with
    TearFree enabled.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit f5d968cbba3c9b7ec202161f2157d8d64778c817
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu May 21 12:54:31 2015 +0900

    Make DRM event queue xf86CrtcPtr based instead of ScrnInfoPtr based
    
    This allows for a minor simplification of the code.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit e87365117acbd80b7d80fbb5eb30890ef7153291
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Feb 25 16:49:16 2016 +0900

    DRI2: Also clear dri2_flipping when client disconnects before event
    
    Fixes the following problem:
    
    With DRI3 enabled, run glxgears with LIBGL_DRI3_DISABLE=1, make it
    fullscreen and press Escape while it's still fullscreen. This could
    result in dri2_flipping not getting cleared, spuriously preventing apps
    using DRI3 from flipping.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit d5dbb07db22d5420c81dfebc060f0dd86e7b8a20
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Feb 25 18:02:12 2016 +0900

    Remove radeon_scanout_flip_handler
    
    No longer necessary now that radeon_drm_queue_handler can handle
    e->handler == NULL.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 3989766edde85d1abe7024577b98fc9b007bc02a
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Feb 25 16:43:48 2016 +0900

    drm_queue: Don't abort events immediately from radeon_drm_abort_client
    
    Keep them around until the DRM event arrives, but then call the abort
    functions instead of the handler functions.
    
    This is a prerequisite for the following fix.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 7bc089ee9740a3ef91f16e36786d8ed64e165acd
Author: jimqu <Jim.Qu@amd.com>
Date:   Tue Feb 16 17:05:48 2016 +0900

    glamor: Return NullPixmap on failure to create shareable pixmap
    
    If we were asked to create a shareable pixmap, it doesn't make sense
    to return a pixmap which isn't shareable. Doing so caused trouble down
    the line such as a crash with older versions of glamor when trying to
    use GLX pixmaps of bpp < 32 via DRI2.
    
    Signed-off-by: JimQu <jim.qu@amd.com>
    (ported from amdgpu commit 2fcb7dadd3c71cd405cbbaafc777697538ca9c29)
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 4cc32031467157ab8788f5c684fb1ac67ae96ff9
Author: jimqu <Jim.Qu@amd.com>
Date:   Tue Feb 16 17:03:24 2016 +0900

    Move radeon_glamor_destroy_pixmap before radeon_glamor_create_pixmap
    
    The next commit will call the former from the latter. No functional
    change.
    
    Signed-off-by: JimQu <jim.qu@amd.com>
    (ported from amdgpu commit 5269a2228bff6023c1a7f3e8534027e1d7addc25)
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit a9b181083d56b5de9b6822d0ed89fcc86de777a6
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Feb 16 16:59:40 2016 +0900

    Remove pci_dev test from radeon_get_scrninfo
    
    The pci_dev parameter can never be NULL since we only support KMS.
    
    Reported-by: Tom St Denis <tom.stdenis@amd.com>
    (ported from amdgpu commit 6e42c58375a4c3229da93c27bbd104af145c6163)
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 2c7f068b0a0493daae86e5eacdf8d9812fcd28dc
Author: Mykola Lysenko <Mykola.Lysenko@amd.com>
Date:   Mon Feb 15 18:21:39 2016 +0900

    Initialize drmmode_crtc dpms_mode to DPMSModeOff
    
    This disables query of disabled pipes for drmWaitVBlank on X start
    
    Signed-off-by: Mykola Lysenko <Mykola.Lysenko@amd.com>
    (ported from amdgpu commit 4eb9cedca080b30c57ded349a397620ee7d0cd46)
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 9358e44f03c95396b7f7a4f7398f5b24d2559bb2
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Mon Feb 15 18:20:31 2016 +0900

    sync: Check if miSyncShmScreenInit symbol is resolved at runtime
    
    It may be disabled in the Xorg build, either explicitly or because the
    xshmfence library isn't available.
    
    (ported from amdgpu commit 1d0b0c1794e65e581a48aa9fb19679d928d82a5d)
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit cd94248ffa7d8fe0b57476f79e7e860dee66d1b0
Author: Jammy Zhou <Jammy.Zhou@amd.com>
Date:   Tue Feb 16 16:36:33 2016 +0900

    Use render node for DRI3 if available
    
    Signed-off-by: Jammy Zhou <Jammy.Zhou@amd.com>
    (ported from amdgpu commit ea558e645786b08d75307716036045170e97b43e)
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit d41fcccf2f11d0393d252e76bbbe6d233c4ac443
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Jan 20 11:20:30 2016 +0900

    Set RADEON_GEM_NO_CPU_ACCESS flag for BOs which don't need CPU access
    
    Failing to do this was resulting in the kernel driver unnecessarily
    leaving open the possibility of CPU access to those BOs.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 9483a3d777919b224f70c3b4d01e4b320a57db31
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Jan 15 16:48:46 2016 +0900

    Fix RandR CRTC transforms
    
    Currently, Xorg will only transform the cursor as of the first time the
    cursor image changes after a transform is set.
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=80678
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit b16856b25086ffb27365ac2249b8da921066ce62
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Jan 14 17:32:54 2016 +0900

    Set the RandR primary output on startup if Xorg hasn't
    
    Fixes xrandr (XRRGetOutputPrimary) not reporting any output as primary
    after startup.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit c7cf00487cd6d4a5d0f39d5b92ff04f6420d6a32
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Nov 27 12:52:28 2015 +0900

    Build RandR 1.4 provider name from chipset name and bus ID
    
    Instead of just "radeon", it's now e.g. "KAVERI @ pci:0000:00:01.0".
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit ff9a6b6f079a8419f4e6fadfee778060618bf735
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Dec 11 17:21:27 2015 +0900

    HAS_DIRTYTRACKING_ROTATION also supports multiple CRTCs
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 78fbca095ae9887a2d3de48bb07975e2d1126e68
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Dec 1 15:38:13 2015 +0900

    Load fb module before glamoregl/shadow modules
    
    Fixes unresolved symbols on some systems.
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=93105
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit b19417e2fddf4df725951aea5ad5e9558338f59e
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Nov 20 18:48:56 2015 +0900

    Don't advertise any PRIME offloading capabilities without acceleration
    
    Acceleration is required even for display offloading. Trying to enable
    display offloading without acceleration resulted in a crash.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 10b7c3def58bb34acc38f076bc230e25b454ab79
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Nov 10 16:31:09 2015 +0900

    glamor: Deal with glamor_egl_destroy_textured_pixmap being removed
    
    When it's not available, it's safe to call down to the glamor
    DestroyPixmap hook instead.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 535e5438b2c32f774b9c8c27ee0289b4749548ef
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Nov 10 17:31:52 2015 +0900

    glamor: Restore all ScreenRec hooks during CloseScreen
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit dfb52777e43f3855476cff812d64de687a199674
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Nov 12 13:49:04 2015 +0900

    Post 7.6.1 release version bump

commit 99cb8c3faf1a4ce368b7500f17a2a7868c15e8e8
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Nov 12 13:38:14 2015 +0900

    Set version for 7.6.1 release

commit 4a2114a717ec8d78cacd8fe158e132d62013faac
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Nov 12 13:32:25 2015 +0900

    Remove duplicate free(output_ids) call
    
    Fixes double-free regression introduced by commit 875ad48e ("Simplify
    drmmode_set_mode_major() and avoid leaking memory.").

commit 960a9f37096b53ec9603a99c7b1f3679f915e03f
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Nov 12 13:20:18 2015 +0900

    Post 7.6.0 release version bump

commit 9aae4b71fb402841439e3267fcb7f410d8429c3a
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Nov 12 11:56:48 2015 +0900

    Bump version for 7.6.0 release

commit 98291869ac4a542a0b478920586407ff9d2c8ef0
Author: Tom St Denis <tom.stdenis@amd.com>
Date:   Wed Nov 11 16:01:41 2015 +0900

    Clean up radeon_dri2_create_buffer2()
    
    Remove the depth_pixmap variable from the function and clear
    out any dead/odd behaviour that results.
    
    Signed-off-by: Tom St Denis <tom.stdenis@amd.com>
    (ported from amdgpu commit 6000aef4e2f0a121b94023484406fb6f04688f74)
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit c6fc7e309a8a922f94a1f5f3e8bfb9058cff7ad1
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Nov 11 15:59:06 2015 +0900

    Properly handle drmModeAddFB failure in drmmode_crtc_scanout_allocate
    
    We were printing an error message, but not propagating the failure. That
    would probably lead to trouble down the road.
    
    (ported from amdgpu commit 21e72fb2418b5cc7fc849a9cf951186e209036b0)
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 4e4f4d53da0539ef9feb8766230a6e9927ae005b
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Nov 11 15:57:21 2015 +0900

    Eliminate redundant data parameter from drmmode_crtc_scanout_create
    
    drmmode_crtc_scanout_create just needs to call
    drmmode_crtc_scanout_allocate when scanout->bo is NULL.
    
    This makes it clearer to the reader / compiler that
    drmmode_crtc_scanout_create doesn't dereference scanout->bo when it's
    NULL.
    
    (ported from amdgpu commit 8da1d0c870e1081d77925807d6e3bbc61a23f54f)
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 421a7e797bdd58d83e81af7a6512cc715a3df514
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Nov 11 15:51:58 2015 +0900

    Don't advertise rotation support without hardware acceleration v2
    
    Rotation currently doesn't work without acceleration (doesn't actually
    rotate with Option "NoAccel", crashes with Option "AccelMethod" "none"
    or when glamor fails to initialize) and would probably be too slow
    anyway.
    
    v2: Also remove now dead code checking for ShadowFB from
        drmmode_crtc_scanout_allocate().
    
    (ported from amdgpu commit dc40582d5ff94d812cbc08f95cf14b80cd0f410d)
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 875ad48e7b5cdb7beefbf18dddcbee3ed22b5446
Author: Tom St Denis <tom.stdenis@amd.com>
Date:   Wed Nov 11 15:51:19 2015 +0900

    Simplify drmmode_set_mode_major() and avoid leaking memory.
    
    The function would leak the memory allocated for output_ids.  This
    patch addresses that as well as simplifies the logic somewhat.
    
    Signed-off-by: Tom St Denis <tom.stdenis@amd.com>
    (ported from amdgpu commit 460560502a1bdf26d06f3c30df46fa9f28ffb9e5)
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 789d7d6a04cca6b36fb088a074027807ccb8dd61
Author: Tom St Denis <tom.stdenis@amd.com>
Date:   Wed Nov 11 15:48:51 2015 +0900

    Clean up allocation in RADEONInitVideo()
    
    The allocation of the adapters should use the correct sizeof (even if
    allocating an array of pointers).
    
    Signed-off-by: Tom St Denis <tom.stdenis@amd.com>
    (ported from amdgpu commit db3bb2061b9ac16b0922d9afae99874820356a04)
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit d88fa0dd5d37604de8efb05853738cfaca6a3166
Author: Tom St Denis <tom.stdenis@amd.com>
Date:   Wed Nov 11 15:46:50 2015 +0900

    Simplify pick best crtc to fold two loops into one
    
    This patch folds the two for loops from radeon_pick_best_crtc() into
    one to reduce the LOC and make the routine easier to read.
    
    Signed-off-by: Tom St Denis <tom.stdenis@amd.com>
    (ported from amdgpu commit 3055724aef76a624718f26d5f0f9e9d567ffbcfb)
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit dbbcd75b3c80aba77673904d46bca97779fd8a8d
Author: Tom St Denis <tom.stdenis@amd.com>
Date:   Wed Nov 11 12:54:54 2015 +0900

    dri2: Avoid calculation with undefined msc value
    
    If the get_msc() call fails for any reason we should avoid updating the
    vblank counter delta with undefined data.
    
    Signed-off-by: Tom St Denis <tom.stdenis@amd.com>
    Signed-off-by: Michel Dänzer <michel.daenzer@amd.com> (minor fixups)
    (ported from amdgpu commit 8823c3d4c6db70cff7699b31088f2d92db8faaf4)
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 7186a8713ba004de4991f21c1a9fc4abc62aeff4
Author: Stephen Chandler Paul <cpaul@redhat.com>
Date:   Fri Oct 23 09:59:36 2015 -0400

    Handle failures in setting a CRTC to a DRM mode properly
    
    This fixes a bug where running the card out of PPLL's when hotplugging
    another monitor would result in all of the displays going blank and
    failing to work properly until X was restarted or the user switched to
    another VT.
    
    [Michel Dänzer: Pass errno instead of -ret to strerror()]
    
    Signed-off-by: Stephen Chandler Paul <cpaul@redhat.com>
    Reviewed-by: Michel Dänzer <michel.daenzer@amd.com>

commit 548e97b3b7d1e94075a54ca2bb4eb683025098a7
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Oct 16 16:26:58 2015 +0900

    Call xf86CrtcRotate from initial drmmode_set_desired_modes call
    
    Fixes various problems when rotation is specified in xorg.conf.
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=92475
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit ce9914af8d8d5243977023ec7b09c605f9cca8b4
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Oct 2 18:07:18 2015 +0900

    Only align screen / scanout pixmap height where necessary
    
    When using glamor acceleration, the pixmap's header has to have a height
    that matches exactly what the actual height is minus the GPU memory
    alignment. Otherwise CRTCs scanning out from the main scanout buffer
    (e.g. every CRTC that isn't rotated or transformed in some way) won't
    always work. This results in a bug where rotating one monitor in a
    multi-monitor setup won't always work properly. Easiest way to reproduce
    this:
    
    - Have two monitors (I've gotten this working with a 1920x1080 and
      1280x1024, along with two 1920x1080s)
    - Rotate one of them from 0° to 90°, then rotate the same monitor from
      90° to 180°. The monitor that hasn't been rotated won't properly
      update, and will stay on a blank screen
    
    This doesn't seem to make any difference when using EXA for
    acceleration.
    
    Compared to Stephen Chandler's patch, this drops the height alignment
    in most places and only keeps it where it's really necessary.
    
    Reported-and-Tested-by: Stephen Chandler Paul <cpaul@redhat.com>
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 0288a4b87b65ba54f37fbeeea3cb32238deee92e
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Aug 19 16:54:14 2015 +0900

    DRI2: Keep MSC monotonic when moving window between CRTCs
    
    This mirrors the DRI3 implementation in xserver. Fixes VDPAU video
    playback hanging when moving the window between CRTCs.
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=66384
    
    (Ported from amdgpu commit 63948ea091a9b324327ade7ec4fc5d67ca7e6f6f)
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 1d886b526dc49f32dc6744b7a882894bdac4e846
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Aug 19 18:11:45 2015 +0900

    DRI2: Don't ignore rotated CRTCs in amdgpu_dri2_drawable_crtc
    
    Waiting for vblank interrupts works fine with rotated CRTCs. The only
    case we can't handle with rotation is page flipping, which is handled
    in can_exchange().
    
    This fixes gnome-shell hanging on rotation, probably because
    amdgpu_dri2_get_msc returned MSC/UST 0 for rotated CRTCs.
    
    (Ported from amdgpu commit 7b3212e33cd36fb6f122774df27b56ec4e1a22b8)
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 270da55340766074cabff8af4258e29fe2f0fc81
Author: Alex Deucher <alexander.deucher@amd.com>
Date:   Mon Aug 10 15:32:34 2015 -0400

    add new OLAND pci id
    
    Signed-off-by: Alex Deucher <alexander.deucher@amd.com>

commit f123096877f0a0044f3d0315285441f2b5790c29
Author: Mario Kleiner <mario.kleiner.de@gmail.com>
Date:   Mon Aug 10 23:34:39 2015 +0200

    Make selection between DRI2 and DRI3 consistent with other drivers. (v2)
    
    Add Option "DRI" to allow selection of maximum DRI level.
    
    This allows the user to select the maximum level of DRI
    implementation to use, DRI2 or DRI3. It replaces the old
    option "DRI3" which had exactly the same purpose, but
    differs from the method used in both intel ddx and nouveau ddx.
    Make this consistent before a new stable driver is released.
    
    v2: Retain handling of old Option "DRI3" for backwards
        compatibility, but Option "DRI" will take precedence
        over "DRI3" if both are provided.
    
    Signed-off-by: Mario Kleiner <mario.kleiner.de@gmail.com>
    Reviewed-by: Michel Dänzer <michel.daenzer@amd.com>

commit 3791fceabf2cb037467dc41c15364e9f9ec1e47e
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Aug 6 16:27:01 2015 +0900

    Wait for scanout BO initialization to finish before setting mode
    
    This should avoid intermittent artifacts which could sometimes be visible
    when setting a new scanout pixmap, e.g. on server startup or when
    changing resolutions.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 4e3dfa69e4630df2e0ec0f5b81d61159757c4664
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Aug 6 16:16:38 2015 +0900

    Only call drmmode_copy_fb (at most) once on server startup
    
    It doesn't make sense to copy the screen contents from console when VT
    switching back to Xorg or when Xorg resets.
    
    Fixes intermittent artifacts when VT switching back from console to the
    gdm login screen.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 09c7cdb923965f9a1ea11d2f449bc02114408938
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Jul 30 15:58:54 2015 +0900

    glamor: Move declaration of struct radeon_pixmap out of #if/#else blocks
    
    Reviewed-by: Dave Airlie <airlied@redhat.com>

commit 936582fde0db461c5c3d78ce4f5f4c93a88a489d
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Jul 30 15:56:36 2015 +0900

    Remove unused local variable pRADEONEnt
    
    ../../src/radeon_probe.c: In function 'radeon_get_scrninfo':
    ../../src/radeon_probe.c:157:22: warning: variable 'pRADEONEnt' set but not used [-Wunused-but-set-variable]
             RADEONEntPtr pRADEONEnt;
                          ^
    
    Reviewed-by: Dave Airlie <airlied@redhat.com>

commit 5510cd6027d2387efdf33575e3bfc424cb11bfd8
Author: Dave Airlie <airlied@redhat.com>
Date:   Mon Jul 27 09:22:57 2015 +1000

    radeon: move radeon_pixmap forward declaration into other block
    
    There is already a radeon_pixmap forward decl here, the #else
    block is missing one.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>
    Signed-off-by: Dave Airlie <airlied@redhat.com>

commit b32a0a3de84a44b9af4f1ca8be19f10d7fa31b12
Author: Dave Airlie <airlied@redhat.com>
Date:   Wed Jul 22 13:35:07 2015 +1000

    radeon: cleanup the entity rec
    
    Some of these were set, some of them were
    always opposites, so clean things up.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>
    Signed-off-by: Dave Airlie <airlied@redhat.com>

commit fcb32231a38f9461d12720cbf72f63502197a711
Author: Emil Velikov <emil.l.velikov@gmail.com>
Date:   Tue Jul 21 23:55:20 2015 +0100

    Do not link radeon_drv.so against libpciaccess
    
    It's only used/needed by ati_drv.so
    
    Signed-off-by: Emil Velikov <emil.l.velikov@gmail.com>
    Reviewed-by: Michel Dänzer <michel.daenzer@amd.com>

commit b6d871bf299c7d0f106c07ee4d8bd3b2337f53cc
Author: Dave Airlie <airlied@gmail.com>
Date:   Thu Jul 9 19:25:36 2015 +1000

    radeon: adopt for new X server dirty tracking APIs.
    
    Signed-off-by: Dave Airlie <airlied@redhat.com>

commit 95f5d09e3667ded027ae648c97eb4737d8bf67c5
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu May 28 11:24:42 2015 +0900

    present: Handle DPMS off in radeon_present_get_ust_msc
    
    The DRM_IOCTL_WAIT_VBLANK ioctl may return an error during DPMS off,
    which would trigger an error message in drmmode_crtc_get_ust_msc.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 211862b777d0be251a4662f5dd24f2d400544c09
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri May 1 18:20:01 2015 +0900

    present: Look at all CRTCs to determine if we can flip
    
    Inspired by modesetting driver change by Kenneth Graunke.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 802d33e474a82262d9cdf11b03568b0c4929cd0d
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri May 1 18:54:16 2015 +0900

    present: Fall back to modeset for unflip operation
    
    It's not always possible to use the page flip ioctl for this, e.g.
    during DPMS off. We were previously just skipping the unflip in that
    case, which could result in hangs when setting DPMS off while a
    fullscreen Present app is running, e.g. at the GNOME3 lock screen.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit a8ed62010d5012dfb27773595c446b217f3c00c5
Author: Piotr Redlewski <predlewski@gmail.com>
Date:   Mon Jul 6 19:57:07 2015 +0200

    Do not try to enable already enabled CRTCs in DPMS hook
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=91227
    
    Signed-off-by: Piotr Redlewski <predlewski@gmail.com>
    Reviewed-by: Michel Dänzer <michel.daenzer@amd.com>

commit fc07c370dac4649511eb7322d05a61605a539f39
Author: Mario Kleiner <mario.kleiner.de@gmail.com>
Date:   Sun Jun 28 02:45:58 2015 +0200

    Fix inconsistent default eg_tile_split in evergreen_accel.c
    
    eg_tile_split() maps the default: switch-case to tile split
    flag 6, like for a tile split size of 4096 Bytes. All other
    instances of tile split mappings or reverse mappings in both
    the ddx and in Mesa's radeon gallium drivers assign the default:
    case to tile split flag 4, consistent with a default of 1024
    Bytes.
    
    Make this one outlier consistent with other instances of
    mappings in the code to avoid surprises.
    
    Signed-off-by: Mario Kleiner <mario.kleiner.de@gmail.com>

commit ddaba449e8d6fe9fc0d97085e4045843fd8d7af9
Author: Piotr Redlewski <predlewski@gmail.com>
Date:   Wed Jun 24 18:44:39 2015 +0200

    Disable CRTCs when disabling the outputs
    
    When turning the outputs off (DPMSModeOff), CRTCs stayed enabled. This led
    to higher gpu temperatures than with fglrx driver.
    
    v2: when entering DPMS also disable active CRTCs
    v3: use drmmode_set_mode_major() for enabling CRTCs when leaving DPMS
    
    Signed-off-by: Piotr Redlewski <predlewski@gmail.com>
    Reviewed-by: Michel Dänzer <michel.daenzer@amd.com>

commit acc11877423ecd81a6e0a7f38466f80e43efee20
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Jun 16 17:34:57 2015 +0900

    Skip disabled CRTCs in radeon_scanout_(do_)update
    
    The vblank / page flip ioctls don't work as expected for a disabled CRTC.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit fc9fadaebbc8aead6e030d93a9ccd84561f8f59e
Author: Mario Kleiner <mario.kleiner.de@gmail.com>
Date:   Mon Jun 22 00:09:17 2015 +0200

    Don't set TILE_SPLIT flags if surface.tile_split == 0.
    
    On pre-Evergreen hw, libdrm's r6_surface_best() helper
    for the surface managers radeon_surface_best() routine
    is a no-op and therefore doesn't assign any tile_split
    settings to created surfaces, so it leaves
    surface.tile_split on its "undefined" value of 0.
    
    Mesa's DRI3/Present backend creates DRI3 Pixmaps via
    the DRIImage extension and the radeon gallium driver
    implementation of that extension uses the libdrm
    surface manager for backing bo creation and treats
    an undefined surface.tile_split==0, as returned by
    the surface manager for pre-evergreen, as a signal
    to not assign any tile_split flags to the DRI3 Pixmaps
    bo.
    
    The ddx also uses libdrm surface manager to create the
    x-screen pixmap, but so far treated the returned undefined
    surface.tile_split==0 by mapping it to eg_tile_split()'s
    default tile_split flags, which are different from Mesa's
    tiling flags for DRI3 pixmaps. Under DRI3/Present this
    causes a mismatch of src pixmap and destination root
    pixmaps tiling flags and thereby prevents page flipping
    for pixmap presents.
    
    Change the ddx code to treat surface.tile_split==0 the
    same way as the radeon gallium driver to avoid mismatched
    tiling flags and thereby allow DRI3/Present page-flip to
    work on pre-Evergreen hw.
    
    Tested on RV730 and Evergreen "Juniper".
    
    Signed-off-by: Mario Kleiner <mario.kleiner.de@gmail.com>

commit 49f5b0bc301414df049e00d226034e3d6e56421b
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri May 1 19:02:36 2015 +0900

    Don't attempt a DRI2/Present page flip while the other one is flipping
    
    Fixes corrupted display and hangs when switching between DRI2 and DRI3
    fullscreen apps, e.g. a compositor using DRI3 and a fullscreen app using
    DRI2 or vice versa.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit afab7839fc15722dbaa7203d00fe7f6ce5336b9d
Author: Mario Kleiner <mario.kleiner.de@gmail.com>
Date:   Wed Jun 10 20:55:08 2015 +0200

    Allow/Fix use of multiple ZaphodHead outputs per x-screen. (v2)
    
    Defining multiple ZaphodHead outputs per x-screen in a
    multiple x-screen's per gpu configuration caused all
    outputs except one per x-screen to go dark, because
    there was a fixed mapping x-screen number -> crtc number,
    limiting the number of crtc's per x-screen to one.
    
    On a ZaphodHead's setup, be more clever and assign
    as many crtc's to a given x-screen as there are
    ZaphodHeads defined for that screen, assuming
    there are enough unused crtc's available.
    
    Tested on a triple display setup with different combos
    of one, two or three ZaphodHeads per one, two or three
    x-screens.
    
    This is a port of similar code from xf86-video-nouveau.
    
    v2: Implement suggestions by Michel Dänzer: Less verbose
        debug output, more clear warning message on crtc allocation
        failure. Move clearing of per gpu assigned_crtc mask to
        CloseScreen, indeed testing shows no need for the more
        complex new server generation check from v1.
    
    Signed-off-by: Mario Kleiner <mario.kleiner.de@gmail.com>
    (v1) Reviewed-by: Alex Deucher <alexander.deucher@amd.com>
    Reviewed-by: Michel Dänzer <michel.daenzer@amd.com>

commit d7c82731a8bf3d381bc571b94d80d9bb2dd6e40d
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu May 21 16:01:16 2015 +0900

    DRI2: Fix handling of drmmode_crtc_get_ust_msc return code
    
    Fixes regression introduced in commit
    76c2923ac5c7230a8b2f9f8329c308d28b44d9c0 ("DRI2: Split out helper for
    getting UST and MSC of a specific CRTC").
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit e58fc380ccf2a581d28f041fd74b963626ca5404
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu May 28 10:59:22 2015 +0900

    glamor: Only wait for GPU writes in radeon_glamor_prepare_access_cpu_ro
    
    We don't need to wait for GPU reads to finish before reading with the
    CPU.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 5f82a720374c9c1caebb42bfbeea1f0cf8847d28
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu May 21 15:46:32 2015 +0900

    present: Remove get_drmmode_crtc helper
    
    It was getting the drmmode_crtc_private_ptr in a roundabout way.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit d64a13ebe0ecd241ee3260dbffd8f4a01e254183
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed May 20 09:58:38 2015 +0900

    Replace SyncFence typedef with declaration of struct _SyncFence
    
    Fixes build failure in some environments:
    
      CC     radeon_sync.lo
    In file included from radeon_sync.c:28:
    /home/tinderbox/xorg-build/include/xorg/misync.h:31: error: redefinition of typedef 'SyncFence'
    radeon.h:93: note: previous declaration of 'SyncFence' was here
    make[2]: *** [radeon_sync.lo] Error 1
    
    Reported-Tested-and-Acked-by: David Airlie <airlied@redhat.com>

commit 818c180c8932233b214a35ba0647af82f7bcec3d
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue May 12 17:43:57 2015 +0900

    glamor: Deal with glamor_glyphs_init being removed from xserver
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 7c4b78ab10b82c6dba9f72034ff7583859cca63d
Author: Alex Deucher <alexander.deucher@amd.com>
Date:   Tue May 12 13:21:24 2015 -0400

    add new bonaire pci id
    
    Reviewed-by: Michel Dänzer <michel.daenzer@amd.com>
    Signed-off-by: Alex Deucher <alexander.deucher@amd.com>

commit 80eede245d1eda27eaba108b0761a24bfd69aff6
Author: Mario Kleiner <mario.kleiner.de@gmail.com>
Date:   Sat May 9 07:24:36 2015 +0200

    present: Fix present notify timestamps and counts.
    
    Invalid (msc,ust)=(0,0) were returned to the server
    because a wrong crtc_id was used to specify which
    crtc should deliver pageflip completion data. Fix
    it in accordance with the dri2 implementation.
    
    Signed-off-by: Mario Kleiner <mario.kleiner.de@gmail.com>

commit e3be8b0a8cf484ff16597413a6172788178e80c8
Author: Mario Kleiner <mario.kleiner.de@gmail.com>
Date:   Sat May 9 07:24:35 2015 +0200

    present: Move check for async flips
    
    Check for and reject currently unsupported async_flip
    inside radeon_present_check_flip() instead of inside
    radeon_present_flip().
    
    This way the server can detect early that async flips
    aren't supported by the ddx and can deal with this
    correctly by using its non-vsync'ed CopyRegion fallback.
    
    Signed-off-by: Mario Kleiner <mario.kleiner.de@gmail.com>

commit 1584dc545c78e0bce8d4b4b9f26b568e2c211453
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Apr 28 17:14:11 2015 +0900

    Skip disabled CRTCs in drmmode_set_desired_modes() even if set_hw == FALSE
    
    Not skipping a disabled CRTC results in a crash.
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=90187
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 340baf3804b7d9de8082badfc715a9bee7856e8f
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Mon Apr 27 15:07:06 2015 +0900

    Don't call radeon_get_pixmap_private() when using EXA
    
    It only works when using glamor.
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=90169
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 80f3d727f93cb6efedd2b39338d2301035965fe2
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Apr 22 13:33:15 2015 +0900

    On screen resize, clear the new buffer before displaying it
    
    Fixes garbage being intermittently visible during a screen resize.
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=27757#c7
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 3999bf88cdb192fe2f30b03bd2ed6f6a3f9f9057
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Apr 2 18:29:38 2015 +0900

    Make drmmode_copy_fb() work with glamor as well
    
    Needed for Xorg -background none.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit a4a8cdbcc10c1c5f07485a2af9e9e81e490c3e1d
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Apr 2 17:46:34 2015 +0900

    Update scanout pixmap contents before setting a mode with it
    
    This ensures the scanout pixmaps used for Option "TearFree" and Option
    "ShadowPrimary" have been initialized when their initial mode is set.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 673e1c7637687c74fc9bdeeeffb7ace0d04b734f
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Apr 2 17:54:33 2015 +0900

    Defer initial modeset until the first BlockHandler invocation
    
    This ensures that the screen pixmap contents have been initialized when
    the initial modes are set.
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=27757
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 37874a4eeace5df04b02c8fc28f67b824e3f0f5f
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Apr 21 17:19:15 2015 +0900

    Defer initial drmmode_copy_fb call until root window creation
    
    That's late enough for acceleration to be fully initialized, but still
    early enough to set pScreen->canDoBGNoneRoot.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 39c497f3efca5ca08343b884f44c93215dcdef31
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Apr 2 18:10:42 2015 +0900

    Only copy fbcon BO contents if bgNoneRoot is TRUE
    
    Otherwise, the X server will initialize the screen pixmap contents
    anyway.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 1af044d7eee211fd4b248c236280274a68334da5
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Apr 22 18:43:02 2015 +0900

    DRI2: Clear old->devPrivate.ptr in fixup_glamor
    
    It doesn't point to the memory of the newly allocated BO. Fixes crash
    running piglit with Option "ShadowPrimary" enabled.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 43159ef400c3b18b9f4d3e6fa1c4aef2d60d38fe
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Mon Apr 20 18:44:36 2015 +0900

    Add Option "TearFree" v4
    
    Avoids tearing by flipping between two scanout BOs per (non-rotated) CRTC
    
    v2:
    * Fix condition for TearFree log message (Richard Wilbur)
    * Log warning message about DRI page flipping being enabled because of
      TearFree (or ShadowPrimary) also when building without glamor support
    
    v3:
    * Only override fb_id/x/y if all scanout pixmaps have been successfully
      allocated
    
    v4:
    * Make log warning clearer if drmModePageFlip returns an error
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com> (v1)

commit ed401f5b4f07375db17ff05e294907ec95fc946d
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Apr 3 12:11:00 2015 +0900

    glamor: Remove the stride member of struct radeon_pixmap
    
    Its value was always the same as that of the PixmapRec devKind member.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit ae92d1765fa370a8d94c2856ad6c45d273ec3c69
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Mar 18 16:23:24 2015 +0900

    glamor: Add Option "ShadowPrimary" v2
    
    When this option is enabled, most pixmaps (including the screen pixmap)
    are allocated in system RAM and mostly accessed by the CPU. Changed areas
    of the screen pixmap are copied to dedicated per-CRTC scanout pixmaps
    regularly, triggered by the vblank interrupt.
    
    v2:
    * Set region data pointer to NULL for keeping only the extents
    * Move pRegion and pBox local variable declarations closer to their uses
      in drmmode_set_mode_major()

commit eea79472a84672ee4dc7adc4487cec6a4037048a
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Apr 1 15:51:52 2015 +0900

    glamor: Add wrappers for the X server rendering hooks
    
    They can choose between using the GPU or CPU for the operation.

commit 051d46382656ffc3e6cac1aab3aee7efdf5b623a
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Mar 19 17:34:27 2015 +0900

    glamor: Add radeon_pixmap parameter to radeon_glamor_create_textured_pixmap

commit 2fa021f77372ca93375a3d13a0c43a9089674899
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Mar 19 17:38:47 2015 +0900

    glamor: Remove unused function radeon_glamor_pixmap_is_offscreen

commit e96349ba6281fd18b8bf9c76629128276b065e6c
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Apr 1 16:04:13 2015 +0900

    Add RADEON_CREATE_PIXMAP_SCANOUT flag
    
    It means that the pixmap is used for scanout exclusively.

commit 9be7dd382e86d2b804de81d4e2af7431b2e16843
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Apr 1 12:40:16 2015 +0900

    Split out struct drmmode_scanout for rotation shadow buffer information
    
    Will be used for other kinds of dedicated scanout buffers as well.

commit c32b0530302739f6512755bccf281c2300617376
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Mar 19 17:46:48 2015 +0900

    Rename scanout_pixmap_x field to prime_pixmap_x
    
    To avoid confusion with upcoming changes.

commit 5921ba4ca705a0d919515626088f3948cc4848c1
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Mar 31 15:14:52 2015 +0900

    present: Don't flip between BOs with different tiling parameters
    
    The kernel driver doesn't handle that correctly yet.
    
    Fixes or at least avoids issues with OpenGL fullscreen apps with DRI3
    enabled and using PRIME or with (2D) tiling disabled.
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=89720
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 428e416e7cb04a1e0527da39cfebf70218879a77
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Apr 2 10:34:03 2015 +0900

    Add radeon_get_pixmap_tiling_flags helper
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 98fb4199e63fedd4607cddee64bf602d6398df81
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Mar 31 12:25:18 2015 +0900

    Only enable SYNC extension fences and the Present extension along with DRI3
    
    This avoids some trouble with the Gallium nine state tracker, which uses
    the Present extension even when DRI3 is disabled.
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=89772
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit f8b0f23e9f4af9f9097ee5e72d53b45173163c41
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Mar 27 12:34:55 2015 +0900

    DRI2: Use radeon_get_pixmap_handle
    
    Now we can share pixmaps with no struct radeon_bo via DRI2.
    
    Fixes VDPAU video playback freezing when using an OpenGL compositor with
    DRI3 enabled.
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=89755
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>
    Tested-by: Nick Sarnie <commendsarnex@gmail.com>

commit ccbda955ebae1d457d35293833f12791e0f9fb0b
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Mar 27 12:16:44 2015 +0900

    Move get_pixmap_handle helper to radeon_bo_helper.c
    
    No functional change.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>
    Tested-by: Nick Sarnie <commendsarnex@gmail.com>

commit de5ddd09db82141b263338dcf0c28e01f58268ee
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Mar 26 16:33:02 2015 +0900

    Move radeon_drm_handler/abort_proc fields to drmmode_flipdata_rec
    
    Their values are the same for all DRM flip ioctl calls within a single
    radeon_do_pageflip() call.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit e8c0f6319fbf4c3ea11e22ab1a68837031bdec8c
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Mar 26 16:27:35 2015 +0900

    Simplify radeon_do_pageflip() error handling slightly more
    
    We don't need the local variable old_fb_id.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 8fc22360d5520469c82092ccb0fcf2af330c573f
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Mar 26 15:58:01 2015 +0900

    Increase robustness against DRM page flip ioctl failures v3
    
    Centralize cleanup, only clean up things that have been allocated for
    the failed ioctl call.
    
    Fixes double-free after a flip ioctl failure.
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=89681
    
    v2: Only call drmModeRmFB for flipdata->old_fb_id on receipt of last DRM
        page flip event. Fixes Black screen on making glxgears fullscreen with
        DRI3 enabled.
    v3: Avoid double-free of flipdata in the unlikely case that calloc fails
        for flipcarrier, but only for the second or later CRTC.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com> (v2)

commit b16609b453bb1a181198cf27778f205dc23fb642
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Mar 26 17:15:21 2015 +0900

    glamor: Handle GLAMOR_* flags removed from xserver
    
    The behaviour is the same as when the removed flags were passed in.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 391900a670addec39515f924265bfa9f8bfa9ec0
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Mar 18 12:56:07 2015 +0900

    glamor: Avoid generating GEM flink names for BOs shared via DRI3 v2
    
    We can't create our own struct radeon_bo representation in this case
    because destroying that would make the GEM handle inaccessible to glamor
    as well. So just get the handle directly via dma-buf.
    
    v2: Close dma-buf file descriptor, pointed out by Axel Davy.
    
    Reviewed-by: Axel Davy <axel.davy@ens.fr>
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit dfad91fffb5bd013785223b42d78886df839eacf
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Mar 19 12:37:01 2015 +0900

    Present: Add radeon_present_get_pixmap_handle helper
    
    Reviewed-by: Axel Davy <axel.davy@ens.fr>
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 7b4fc4a677d252d01c2bf80d162bc35814059eaa
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Mar 19 12:15:52 2015 +0900

    Make radeon_do_pageflip take a BO handle directly
    
    Reviewed-by: Axel Davy <axel.davy@ens.fr>
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit af6076241c0d322b295a4e898407ae2472bd8eb4
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Mar 24 13:37:01 2015 +0900

    Adapt radeon_sync.c for misyncshm.h vs misync.h as well
    
    This should have been part of the previous commit. Without this, SYNC
    extension fences (and by extension DRI3) were disabled because it checked
    for HAVE_MISYNC_H, but configure now only defines HAVE_MISYNCSHM_H.

commit aa7825eb29cdf6ac9d7b28ad18186807ff384687
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Mon Mar 23 10:12:17 2015 +0900

    configure.ac: Check for misyncshm.h again
    
    We need this header, which was added after the other misync*.h headers,
    along with DRI3 support.

commit 6291baaed261e36a63dc001307427fe00ba82259
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Mar 19 00:12:06 2015 +0900

    EXA: Return NULL from radeon_get_pixmap_bo if there is no driver private
    
    This mirrors what the glamor part of the function does. Fixes a crash
    running glxgears_pixmap with DRI3 enabled, reported by "marvin24" on IRC.

commit f68d9b5ba0c91a725b5eec9386c61bea8824c299
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Mar 18 18:29:27 2015 +0900

    dri3: Use screen->CreatePixmap instead of fbCreatePixmap directly
    
    Fixes crash with EXA reported by "marvin24" on IRC.

commit 4b0997e56dec0053cb2cb793e0f4ae35055ff7e6
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Mar 18 12:30:09 2015 +0900

    glamor: Add glamor_fd_from_pixmap define for standalone glamor tree

commit af1862a37570fa512a525ab47d72b30400d2e2d6
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Mar 18 11:05:40 2015 +0900

    Always include misync.h before other misync headers
    
    Older versions of xserver didn't include misync.h from other misync
    headers as needed.

commit fcd37f65f485291084c174666bd605e215bf1398
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Mar 18 10:39:03 2015 +0900

    DRI3: Use open hook instead of open_client
    
    We don't need the client pointer, and this allows it to work with older
    versions of xserver as well.

commit f940fd741b15f03393037c5bb904cd74f012de9d
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Mar 18 10:06:47 2015 +0900

    Initialize boolean variable before calling xf86GetOptValBool
    
    We were just lucky that it contained 0 in most cases.

commit 4a98f60117c387a228d5cbaadb6e298fb4e865df
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Mar 17 16:47:11 2015 +0900

    Add xorg_list_for_each_entry_safe fallback in radeon_list.h
    
    Fixes another build failure against older versions of xserver reported
    by "Pali" on IRC.

commit 694e04720b886060fe3eefdce59741f218c8269f
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Mar 17 16:32:09 2015 +0900

    Simplify includes in radeon_{dri3,present}.c
    
    Just include radeon.h first. Fixes build failures against older versions
    of xserver because compat-api.h wasn't getting picked up. Reported by
    "Pali" on IRC.

commit 64e1e4dbdd3caee6f5d8f6b6c094b4533fa94953
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Mar 10 16:53:11 2015 +0900

    Add DRI3 support v2
    
    Must be enabled with
    
    	Option	"DRI3"
    
    in xorg.conf.
    
    v2: Adapt to v2 of patches 11/12.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 69ae0194778fe4276895839db92383f63f0b5de4
Author: David Heidelberger <david.heidelberger@ixit.cz>
Date:   Fri Mar 6 17:57:22 2015 +0900

    Handle tiling in radeon_set_shared_pixmap_backing
    
    [ Michel Dänzer: Fixups for glamor ]
    Signed-off-by: David Heidelberger <david.heidelberger@ixit.cz>
    Signed-off-by: Axel Davy <axel.davy@ens.fr>
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 3c65fb849e1ba9fb6454bcaa55b696548902f3fc
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Mar 10 16:52:54 2015 +0900

    Add support for the Present extension v2
    
    v2: Fix up for struct radeon_drm_queue -> radeon_drm_queue_entry.
        Swapped order of patches 11 & 12 because the Present extension uses
        SYNC fences.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 8fc9a241ab59ffbcdc178d6415332c88a54e85fe
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Mar 5 18:18:56 2015 +0900

    Add support for SYNC extension fences v2
    
    v2: Swapped order of patches 11 & 12 because the Present extension uses
        SYNC fences.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 4a35e2f33d9cdfb608423046391311109f96fb6b
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Mar 5 18:34:07 2015 +0900

    Fold radeon_glamor_flush into radeon_cs_flush_indirect
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 4b8adebb80158bcf81ada83bb88517febe931b12
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Mar 5 18:40:23 2015 +0900

    Move #include "radeon_glamor.h" from radeon.h to where it's needed
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 76c2923ac5c7230a8b2f9f8329c308d28b44d9c0
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Mar 4 10:30:19 2015 +0900

    DRI2: Split out helper for getting UST and MSC of a specific CRTC
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 6c3a721cde9317233072b573f9502348dcd21b16
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Mar 10 16:52:18 2015 +0900

    DRI2: Use helper functions for DRM event queue management v3
    
    This is mostly in preparation for Present support, but it also simplifies
    the DRI2 specific code a little.
    
    v2: Fix up for struct radeon_drm_queue -> radeon_drm_queue_entry.
    v3: Removed excess 0s from conversion from microseconds to seconds,
        thanks to Richard Wilbur <richard.wilbur@gmail.com> for the catch!
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit c3fa22a479e61d1899fa9d327d9c4e2a7f64b0c1
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Mar 11 17:47:59 2015 +0900

    DRI2: Move radeon_dri2_flip_event_handler
    
    In preparation for the next change, which will modify it to a static
    function which needs to be in the new place. No functional change.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 65045112fdc8a9fa36e0e00f46739a6152b775ff
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Mar 11 17:33:54 2015 +0900

    DRI2: Remove superfluous assignments to *_info->frame
    
    That field is only used for page flipping.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit ad27f16f308079d06a2b1c788b3cb0947531253a
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Mar 11 17:30:11 2015 +0900

    DRI2: Simplify blit fallback handling for scheduled swaps
    
    Also use radeon_dri2_schedule_event when possible.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit b4af8a327ed8420f0ff4ea0f113f4a59406ed4d3
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Mon Mar 2 18:59:54 2015 +0900

    Add DRM event queue helpers v2
    
    v2: Rename struct radeon_drm_queue to struct radeon_drm_queue_event,
    thanks to Richard Wilbur <richard.wilbur@gmail.com> for the suggestion.
    Also changed the corresponding parameter and local variable names from
    'q' to 'e'.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 7c3470f4b659206ed23f761948936ede3a2dba3d
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Mar 6 18:51:29 2015 +0900

    Move xorg_list backwards compatibility to new radeon_list.h header
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 7388d0b6c54b9d536fdb161e3aa61b326627b939
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Mar 5 17:35:06 2015 +0900

    Require at least xserver 1.8
    
    So we can rely on the list.h header.
    
    xserver 1.8 was released in April 2010.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit b8ec9ed4fe86952763b963c86f0af0dcae69aa6c
Author: Jerome Glisse <jglisse@redhat.com>
Date:   Thu Feb 19 14:47:41 2015 -0500

    Proper leak fix, previous leak fix was bogus.
    
    Signed-off-by: Jérôme Glisse <jglisse@redhat.com>

commit 63dc36dc49f93cb00111b497ab6805194bc9d240
Author: Jerome Glisse <jglisse@redhat.com>
Date:   Thu Feb 19 11:43:08 2015 -0500

    Avoid leaking memory on output.
    
    Signed-off-by: Jérôme Glisse <jglisse@redhat.com>

commit c80ea1e3e8c5f155cedadbe4588870fb1f410ab4
Author: Rolf Eike Beer <eb@emlix.com>
Date:   Tue Jan 13 12:11:26 2015 +0100

    radeon: remove unneeded inclusion of sarea.h
    
    None of the structs or defines from that header is used.
    
    Signed-off-by: Rolf Eike Beer <eb@emlix.com>

commit 04da199231bb3f11cf17f94574a8df05855a7b82
Author: Adam Jackson <ajax@redhat.com>
Date:   Wed Dec 17 14:03:58 2014 -0500

    Remove dead accelDFS flag
    
    Signed-off-by: Adam Jackson <ajax@redhat.com>

commit c9f8f642fd495937400618a4fc25ecae3f8888fc
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Mon Nov 17 12:32:29 2014 +0900

    Prefer drmModeSetCursor2 over drmModeSetCursor
    
    The former includes information about the position of the hotspot within
    the cursor image.
    
    Copied from xf86-video-modesetting.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 2f11dcd43966cf2ee26e61960fd72e6644f5e037
Author: Dave Airlie <airlied@redhat.com>
Date:   Mon Nov 10 13:49:29 2014 +1000

    radeon: add support for DP 1.2 display hotplug (v2)
    
    This allows for dynamic creation of conneectors when the
    kernel tells us.
    
    v2: fix dpms off crash
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>
    Signed-off-by: Dave Airlie <airlied@redhat.com>

commit c88424d1f4aaa78b569e5d44f0b4a47de2f422f4
Author: Dave Airlie <airlied@redhat.com>
Date:   Mon Nov 10 14:17:54 2014 +1000

    radeon: move output name creation to its own function
    
    The secondary indent is deliberate to make the next patch more
    parseable for mst support.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>
    Signed-off-by: Dave Airlie <airlied@redhat.com>

commit 32b003cb7657e07d5af6338ad44d768eda87fd33
Author: Dave Airlie <airlied@redhat.com>
Date:   Mon Nov 10 14:12:34 2014 +1000

    radeon: stop caching mode resources
    
    This is step one towards MST connector hotplug support,
    it stop caching the mode resources structure, and
    just passes a pointer to it around.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>
    Signed-off-by: Dave Airlie <airlied@redhat.com>

commit 7c7b38e0b375b6e8853ad2d1092302ea83f6f570
Author: David Heidelberger <david.heidelberger@ixit.cz>
Date:   Sun Oct 12 16:34:21 2014 +0200

    radeon/vdpau: don't report VDPAU for < r300
    
    Signed-off-by: David Heidelberger <david.heidelberger@ixit.cz>

commit c74de9fec13fac2c836bb2a07ae6f90e1d61e667
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Aug 6 11:08:00 2014 +0900

    PRIME: Don't advertise offload capabilities when acceleration is disabled
    
    Xorg tends to crash if the user tries to actually use the offload
    capabilities with acceleration disabled.
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=57200
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 636a6382f80412ae4e28abe0cd9f98f84cd52291
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Oct 15 12:02:17 2014 +0900

    Remove duplicate OPTION_PAGE_FLIP entry
    
    Reported by 'amanual' on IRC

commit c854b4479ec5122390ede81b655b259efd9b1800
Author: Alex Deucher <alexdeucher@gmail.com>
Date:   Thu Oct 2 10:22:22 2014 -0400

    radeon: bump version post release
    
    Signed-off-by: Alex Deucher <alexdeucher@gmail.com>

commit 068a59e010ce6bfcd54f5a18cc08c55c54b8618d
Author: Alex Deucher <alexander.deucher@amd.com>
Date:   Wed Oct 1 23:38:52 2014 -0400

    radeon: bump version for release
    
    Signed-off-by: Alex Deucher <alexander.deucher@amd.com>

commit 5fee565e420d3efbf72fdf4f63c3d5d93d8ceddb
Author: Alex Deucher <alexander.deucher@amd.com>
Date:   Wed Oct 1 23:36:31 2014 -0400

    radeon: require libdrm_radeon 2.4.58 for latest SI/CI pci ids
    
    Signed-off-by: Alex Deucher <alexander.deucher@amd.com>

commit 56c7fb8ada4cd9cf096c6b06a8d368d286d74e68
Author: Thomas DeRensis <tderensis@gmail.com>
Date:   Wed Sep 10 21:20:32 2014 -0400

    radeon: fix build warnings regarding const qualifier
    
    Signed-off-by: Thomas DeRensis <tderensis@gmail.com>

commit b9a9b244336ed50d7df4f36135f875a3bb6ca948
Author: Thomas DeRensis <tderensis@gmail.com>
Date:   Thu Sep 4 21:45:19 2014 -0400

    radeon: fix a leak in radeon_vbo_get_bo()
    
    The dma_bo struct was never freed in the error path. Reported by cppcheck.
    
    Signed-off-by: Thomas DeRensis <tderensis@gmail.com>
    Reviewed-by: Michel Dänzer <michel.daenzer@amd.com>

commit ba5fcc4d6b6eae3f2c55c6229a53d24d160789c1
Author: Alex Deucher <alexander.deucher@amd.com>
Date:   Thu Aug 21 11:32:45 2014 -0400

    radeon/kms: fix mullins pci id
    
    strange errant change from:
    39fef269f521c92a2a31c80447e9401bacb3797a
    
    Signed-off-by: Alex Deucher <alexander.deucher@amd.com>

commit efef34930650d6d80f7b527f4cee76d9e5954ace
Author: Alex Deucher <alexander.deucher@amd.com>
Date:   Thu Aug 21 11:30:17 2014 -0400

    radeon/kms: add new SI pci ids
    
    Signed-off-by: Alex Deucher <alexander.deucher@amd.com>

commit 39fef269f521c92a2a31c80447e9401bacb3797a
Author: Alex Deucher <alexander.deucher@amd.com>
Date:   Thu Aug 21 11:27:49 2014 -0400

    radeon/kms: add new CIK pci ids
    
    Signed-off-by: Alex Deucher <alexander.deucher@amd.com>

commit 7dab6b2fe9cf690b0dae1c127d0374322bd8278e
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Aug 20 17:51:35 2014 +0900

    Revert "glamor: Set environment variable RADEON_THREAD=0"
    
    This reverts commit 4b5060f357a3cb248c9359c92c1e9c42ef6434c8.
    
    Further testing shows that disabling the thread is only a moderate win in
    some cases, but a much bigger loss in some other cases.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 1ff383360886c5cee1bb75abcc20675aca0336a6
Author: Alex Deucher <alexander.deucher@amd.com>
Date:   Tue Aug 12 12:27:12 2014 -0400

    radeon: fix warnings when building against older xservers
    
    Signed-off-by: Alex Deucher <alexander.deucher@amd.com>

commit 94202cbfbca05a503acdc1cca2f8409d141173af
Author: Alex Deucher <alexdeucher@gmail.com>
Date:   Fri Aug 1 21:55:40 2014 +0200

    radeon: enable hawaii accel conditionally (v3)
    
    Only if the kernel has the new CP firmware.
    
    v2: check value of ACCEL_WORKING2
    v3 (Andreas Boll):
     - check for value 2 or 3 of ACCEL_WORKING2
     - update man page
    
    Reviewed-by: Michel Dänzer <michel.daenzer@amd.com> (v2)
    Signed-off-by: Alex Deucher <alexander.deucher@amd.com>
    Signed-off-by: Andreas Boll <andreas.boll.dev@gmail.com>

commit 03930edd49f6b8a8d79910c7be5408b47db9649b
Author: Andreas Boll <andreas.boll.dev@gmail.com>
Date:   Mon Aug 4 16:23:13 2014 +0200

    radeon: remove definitions already present in radeon_drm.h
    
    Signed-off-by: Andreas Boll <andreas.boll.dev@gmail.com>

commit 91849fba0742ef61ba327e71fc3ce8f754af0a6f
Author: Andreas Boll <andreas.boll.dev@gmail.com>
Date:   Mon Aug 4 16:23:12 2014 +0200

    radeon: drop radeon_drm.h
    
    Now we use libdrm's radeon_drm.h.
    
    Signed-off-by: Andreas Boll <andreas.boll.dev@gmail.com>

commit b4658901bf1d619f8ff9b5f94344894f935ee6c8
Author: Andreas Boll <andreas.boll.dev@gmail.com>
Date:   Mon Aug 4 16:23:11 2014 +0200

    radeon: move RADEON_TILING_{MASK, LINEAR} from radeon_drm.h to radeon.h
    
    This allows us to drop radeon_drm.h from xf86-video-ati and use instead
    radeon_drm.h from libdrm.
    
    Signed-off-by: Andreas Boll <andreas.boll.dev@gmail.com>

commit 656bae7361c1e018553ef6d6d8c9efad616a4513
Author: Andreas Boll <andreas.boll.dev@gmail.com>
Date:   Mon Aug 4 16:23:10 2014 +0200

    radeon: drop redundant radeon_drm.h includes
    
    Already included via radeon.h.
    
    Signed-off-by: Andreas Boll <andreas.boll.dev@gmail.com>

commit fbf575cb010e558a87fad0de45660738c8180896
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Jul 30 17:03:24 2014 +0900

    Add Emacs .dir-local.el file
    
    Based on the one from the Gallium radeon winsys, but enabling tabs for
    indentation.

commit 4b5060f357a3cb248c9359c92c1e9c42ef6434c8
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Jun 19 18:27:59 2014 +0900

    glamor: Set environment variable RADEON_THREAD=0
    
    Reviewed-by: Marek Olšák <marek.olsak@amd.com>

commit 9b54caf6509a9c02dd17c9c43d6be8f7ddc98054
Author: Hans de Goede <hdegoede@redhat.com>
Date:   Mon Jul 28 15:55:12 2014 +0200

    configure: Include xorg-server.h before
 glamor.h
    
    glamor.h cannot be included without first including xorg-server.h, this also
    applies to including it from configure snippets.
    
    Without this the configure glamor checks fail on systems with the latest
    glibc, throwing this error:
    
    In file included from /usr/include/xorg/misc.h:115:0,
                     from /usr/include/xorg/screenint.h:50,
                     from /usr/include/xorg/scrnintstr.h:50,
                     from /usr/include/xorg/glamor.h:32,
                     from conftest.c:61:
    /usr/include/xorg/os.h:579:2: error: expected identifier or '(' before
    '__exten
     strndup(const char *str, size_t n);
      ^
    
    This is caused by HAVE_STRNDUP not being set (it is set from xorg-server.h),
    causing os.h to redefine it.
    
    Signed-off-by: Hans de Goede <hdegoede@redhat.com>

commit c4ae0e2cbcc0e2ebf9f13ee92d59b5120254a1dc
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Mon Jun 30 10:20:12 2014 +0900

    Handle CRTC DPMS from output DPMS hooks
    
    This fixes at least two issues:
    
    The CRTC DPMS hook isn't called after a modeset, so the vertical blank
    interrupt emulation code considered the CRTC disabled after a modeset. As
    a side effect, page flipping was no longer used after a modeset.
    
    This change also makes sure the vertical blank interrupt emulation code
    runs before the hardware CRTC is disabled and after it's enabled from the
    output DPMS hook. The wrong order could cause gnome-shell to hang after
    a suspend/resume and/or DPMS off/on cycle.
    
    Signed-off-by: Michel Dänzer <michel.daenzer@amd.com>
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit c0c3cac8613e31e310242695d0955b452f116e25
Author: Maarten Lankhorst <maarten.lankhorst@canonical.com>
Date:   Wed Jun 25 16:21:57 2014 +0200

    bump version post release

commit 906a0ec9224146098bb4581486129d2934d36495
Author: Maarten Lankhorst <maarten.lankhorst@canonical.com>
Date:   Wed Jun 25 16:10:21 2014 +0200

    bump version for release

commit cc615d06db0332fc6e673b55632bcc7bf957b44b
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Jun 4 16:58:53 2014 +0900

    Rename Option "NoAccel" to "Accel"
    
    Removes the need for a double negation when forcing acceleration on.
    
    Note that this change is backwards compatible, as the option parser
    automagically handles the 'No' prefix.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 851b2cf8714618843725f6d067915375485ade9d
Author: Adam Jackson <ajax@redhat.com>
Date:   Wed May 21 09:34:32 2014 -0400

    kms: Use own thunk function instead of shadowUpdatePackedWeak
    
    I plan to delete the Weak functions from a future server.
    
    Signed-off-by: Adam Jackson <ajax@redhat.com>

commit b2dba2906f0b2284f17f53fd5251ba0f03d52a8b
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu May 15 16:07:53 2014 +0900

    Don't disable acceleration on >= SI on attempts to force EXA
    
    Also make this case clear in the log file:
    
     (WW) RADEON(0): EXA not supported, using glamor
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit be1469cc23aba46daf3293b3d09c5f2e792e7f42
Author: Alex Deucher <alexander.deucher@amd.com>
Date:   Fri May 2 17:48:07 2014 -0400

    radeon: enable tiling for mullins
    
    Signed-off-by: Alex Deucher <alexander.deucher@amd.com>

commit 2ae8e4b8d12f5c9bab6655eb8cd3c5c1d5cfb10e
Author: Samuel Li <samuel.li@amd.com>
Date:   Tue Nov 12 15:30:42 2013 -0500

    radeon: add Mullins pci ids.
    
    Signed-off-by: Samuel Li <samuel.li@amd.com>
    Signed-off-by: Alex Deucher <alexander.deucher@amd.com>
    Reviewed-by: Michel Dänzer <michel.daenzer@amd.com>

commit 5c86a3461597647224c33d5190b4531aeeb2655f
Author: Samuel Li <samuel.li@amd.com>
Date:   Thu Apr 17 15:17:28 2014 -0400

    radeon: add support for Mullins.
    
    Signed-off-by: Samuel Li <samuel.li@amd.com>
    Signed-off-by: Alex Deucher <alexander.deucher@amd.com>
    Reviewed-by: Michel Dänzer <michel.daenzer@amd.com>

commit fdb90ffc50acbb7d5ba0598470f9feeac6ce55fc
Author: Alex Deucher <alexander.deucher@amd.com>
Date:   Fri May 2 17:45:45 2014 -0400

    radeon: require libdrm_radeon 2.4.54 for mullins support
    
    Signed-off-by: Alex Deucher <alexander.deucher@amd.com>

commit 06e3c8c53ef4bd159f5864eabf726438d008b49a
Author: Dave Airlie <airlied@redhat.com>
Date:   Wed Apr 23 13:39:42 2014 +1000

    radeon: fix use-after-free in modesetting cleanup
    
    noticed while looking at something else.
    
    Reviewed-by: Michel Dänzer <michel.daenzer@amd.com>
    Signed-off-by: Dave Airlie <airlied@redhat.com>

commit dbac18c361f9e514ecb40d0617f9d68b65a542e0
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Mon Apr 28 17:51:56 2014 +0900

    Revert "Adapt to load_cursor_argb signature change in xserver 1.15.99.902"
    
    This reverts commit 48d3dbc8a0d3bfde88f46e402e530438f9317715.
    
    xserver Git has been updated to be backwards compatible with the
    previous API.

commit c84230d686c078aac1dc98d82153f8b02521b2e1
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Apr 25 09:17:51 2014 +0900

    dri2: Handle PRIME for source buffer as well in radeon_dri2_copy_region2
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=77810
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 48d3dbc8a0d3bfde88f46e402e530438f9317715
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Apr 15 17:45:35 2014 +0900

    Adapt to load_cursor_argb signature change in xserver 1.15.99.902
    
    Apart from the compiler warning below, not doing this may result in
    accidentally using software cursors.
    
    ../../src/drmmode_display.c:808:5: warning: initialization from incompatible pointer type [enabled by default]
         .load_cursor_argb = drmmode_load_cursor_argb,
         ^
    ../../src/drmmode_display.c:808:5: warning: (near initialization for 'drmmode_crtc_funcs.load_cursor_argb') [enabled by default]
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 409786a8f780d78a83bf0bddea5d37117ff6fa39
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Apr 10 11:43:04 2014 +0900

    glamor: Fix test for creating shared pixmaps
    
    The pixmap usage hint is not a bitmask in general. The test for
    CREATE_PIXMAP_USAGE_SHARED was incorrectly triggering for a glamor internal
    usage hint being added in the xserver tree.
    
    Tested-by: Ed Tomlinson <edtoml@gmail.com>

commit aecf1c4e5f4718adcfb85836830d065d3f4f97a5
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Apr 10 15:10:56 2014 +0900

    dri2: Fix conflicting CreatePixmap usage flag definitions
    
    RADEON_CREATE_PIXMAP_TILING_MICRO_SQUARE was the same as
    RADEON_CREATE_PIXMAP_DRI2.
    
    Disambiguate the definitions and rearrange them to try and prevent this
    from happening again.
    
    Tested-by: Ed Tomlinson <edtoml@gmail.com>

commit b50da3b96c212086cb58501dbe988d64f1f35b6d
Author: Hans de Goede <hdegoede@redhat.com>
Date:   Fri Apr 11 09:44:37 2014 +0200

    Fix building on older servers without xf86platformBus.h
    
    Signed-off-by: Hans de Goede <hdegoede@redhat.com>

commit ed0cfbb4fe77146b0b38f777bc28f3a4ea6da07f
Author: Hans de Goede <hdegoede@redhat.com>
Date:   Fri Mar 7 13:27:30 2014 +0100

    Add support for server managed fds
    
    Signed-off-by: Hans de Goede <hdegoede@redhat.com>

commit 3d7861fe112f25874319d4cdc12b745fbcd359cf
Author: Hans de Goede <hdegoede@redhat.com>
Date:   Mon Mar 17 10:38:13 2014 +0100

    Add radeon_get_drm_master_fd helper function
    
    This is a preparation patch for adding server-managed-fd support without it
    turning into a goto fest.
    
    Signed-off-by: Hans de Goede <hdegoede@redhat.com>

commit a63342ad15408071437c80b411d14196f3288aed
Author: Hans de Goede <hdegoede@redhat.com>
Date:   Mon Mar 17 10:36:55 2014 +0100

    radeon_open_drm_master get rid of unnecessary goto
    
    Signed-off-by: Hans de Goede <hdegoede@redhat.com>

commit bdc412044f6ced056cd57320d1b2ee0d967c2191
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Mar 13 16:40:19 2014 +0900

    Build against glamor in the xserver tree if available

commit 921a153f9964ca452e1241f76c7f7d653f42ceaf
Author: Alex Deucher <alexander.deucher@amd.com>
Date:   Tue Mar 11 12:24:13 2014 -0400

    update man page to reflect tiling changes for CI parts
    
    Signed-off-by: Alex Deucher <alexander.deucher@amd.com>

commit 5eee8a4d5c86bb1cc34d8caf2f2b64b53c241fa5
Author: Alex Deucher <alexander.deucher@amd.com>
Date:   Mon Mar 10 16:20:09 2014 -0400

    radeon: enable tiling by default on CIK
    
    Now that mesa 10.1 is released, we can enable this by
    default for CIK parts.  Tiling improves memory bandwidth
    utilization.
    
    Signed-off-by: Alex Deucher <alexander.deucher@amd.com>
    Reviewed-by: Michel Dänzer <michel.daenzer@amd.com>

commit 691ec3d99c30111a4789830dfccb6eb5d3c40187
Author: Alex Deucher <alexander.deucher@amd.com>
Date:   Mon Mar 10 16:17:34 2014 -0400

    radeon: require libdrm 2.4.51
    
    Required for proper tiling support on CIK parts.
    
    Signed-off-by: Alex Deucher <alexander.deucher@amd.com>
    Reviewed-by: Michel Dänzer <michel.daenzer@amd.com>

commit 515bcf14d514f9dcaaf30fd0bf1ef6dd6ba9a0cd
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Mar 4 12:34:26 2014 +0900

    Allow enabling glamor on R500 (and R300) class 3D engines as well.
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=75709
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit ea6d0affe52d82becadab6fb1c87f9261b0605a2
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Mon Feb 24 13:12:21 2014 +0900

    Only log debugging output about initializing colormaps when we're doing so
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 8da17f30c70f4494ce22ad781a1cee17041812f3
Author: Jérôme Glisse <jglisse@redhat.com>
Date:   Mon Feb 24 14:50:25 2014 -0500

    evergreen: fix shader constant upload on ppc
    
    The number of dword we have to swap is (16*4) ie 16 vectors of
    4 floats each not 16 floats. Never hit this issue before because
    we never had more than 4 constant vector.
    
    Signed-off-by: Jérôme Glisse <jglisse@redhat.com>

commit cadb6b493942a84bfeb298751dce0dee39257a06
Author: Alex Deucher <alexander.deucher@amd.com>
Date:   Fri Feb 21 08:33:21 2014 -0500

    radeon: don't install colormap handling if there are no crtcs
    
    Fixes a crash on cards with 0 crtcs.
    
    Discussion:
    http://lists.freedesktop.org/archives/dri-devel/2014-February/054186.html
    
    Signed-off-by: Alex Deucher <alexander.deucher@amd.com>

commit 7cd972a85705341dd8306eefc558ed9e5def05d7
Author: Maarten Lankhorst <maarten.lankhorst@canonical.com>
Date:   Thu Feb 20 11:14:03 2014 +0100

    return immediately in preinit when called with PROBE_DETECT
    
    This fixes a crash with Xorg -configure.
    
    Bug:
    https://bugs.launchpad.net/ubuntu/+source/xorg/+bug/1278046
    
    Signed-off-by: Maarten Lankhorst <maarten.lankhorst@canonical.com>
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 8de6f7b2f476d3baa9c7e2bb3544e4bafaad46b7
Author: Alex Deucher <alexander.deucher@amd.com>
Date:   Fri Jan 24 11:04:30 2014 -0500

    bump version post release
    
    Signed-off-by: Alex Deucher <alexander.deucher@amd.com>

commit 0333f5bda27dc0ec2edc180c7a4dc9a432f13f97
Author: Alex Deucher <alexander.deucher@amd.com>
Date:   Fri Jan 24 10:19:49 2014 -0500

    radeon: bump version for release
    
    Signed-off-by: Alex Deucher <alexander.deucher@amd.com>

commit fc4167f2a85d9cba65078d8fc6f08c7a619ad66e
Author: Alex Deucher <alexander.deucher@amd.com>
Date:   Fri Jan 24 10:17:08 2014 -0500

    Require glamor 0.6.0
    
    This is required for Xv support and a number of important
    performance improvements.
    
    Signed-off-by: Alex Deucher <alexander.deucher@amd.com>

commit f2a0a5cf6c5a21e2a02280e110a4eb8e6609dace
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Jan 22 11:04:42 2014 +0900

    Don't require the glamoregl module to be pre-loaded with xserver >= 1.15
    
    The issues with loading it on demand have been fixed in xserver 1.15.
    
    Inspired by Jérôme Glisse on IRC.

commit 3213df16d61302148be0088c8f93c6a5a88558f1
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Jan 8 11:30:59 2014 +0900

    dri2: Make last_vblank_seq local unsigned to match dpms_last_seq
    
    Without this, I was occasionally running into gnome-shell hangs due to
    wildly off vblank sequence values. Doesn't seem to happen anymore with
    this change.
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit bcc454ea2fb239e13942270faec7801270615b9c
Author: Alex Deucher <alexander.deucher@amd.com>
Date:   Mon Jan 6 09:52:50 2014 -0500

    radeon/exa: Always use a scratch surface for UTS to vram
    
    If we don't, we may hit a buffer that crosses the
    visible vram boundary resulting in a sigbus when the
    CPU accesses the buffer beyond the PCI aperture.
    This will introduce an extra copy in certain cases.
    
    This is based on Michel's patch from bug 44099 updated
    for all asic families.
    
    Bug:
    https://bugs.freedesktop.org/show_bug.cgi?id=44099
    
    Signed-off-by: Alex Deucher <alexander.deucher@amd.com>
    Reviewed-by: Michel Dänzer <michel.daenzer@amd.com>

commit 04ef035c9315b4a6fbf1b14720be87cee4099a9f
Author: Alex Deucher <alexander.deucher@amd.com>
Date:   Tue Dec 24 15:14:35 2013 -0500

    drm/radeon: fix SUMO2 pci id
    
    0x9649 is sumo2, not sumo.
    
    Signed-off-by: Alex Deucher <alexander.deucher@amd.com>

commit bfbff3b246db509c820df17b8fcf5899882ffcfa
Author: Robert Millan <rmh@freebsd.org>
Date:   Fri Dec 20 11:03:14 2013 +0000

    radeon: Restore kernel module load on FreeBSD.
    
    Since the introduction of a call to drmCheckModesettingSupported()
    in radeon_kernel_mode_enabled(), with abort condition if such call
    fails, the drmOpen() call in radeon_open_drm_master() no longer
    takes the responsibility of loading the radeon kernel module.
    
    However at least on FreeBSD (and GNU/kFreeBSD), X is still relied
    on to load the modules it needs. This commit restores the old
    behaviour of loading kernel modules on these systems.
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=72852
    Signed-off-by: Robert Millan <rmh@freebsd.org>

commit 796c9a0cb587f528326bede11fa3f3eb7d3edaf1
Author: Robert Millan <rmh@freebsd.org>
Date:   Fri Dec 20 10:55:09 2013 +0000

    radeon: Set first parameter of drmOpen() to NULL
    
    Since the introduction of a call to drmCheckModesettingSupported()
    in radeon_kernel_mode_enabled(), with abort condition if such call
    fails, the first argument to drmOpen() call in radeon_open_drm_master()
    has become a no-op red herring.
    
    Such argument (a kernel module name) is supposed to result in load
    of specified kernel module. However, this will never happen. The
    problem is that if the code containing drmOpen() call is reached, it
    means that drmCheckModesettingSupported() check has previously
    succeeded, which implies the module is already loaded.
    
    So, drmOpen() will never load a kernel module. But it gives the
    impression that it will.
    
    In order to avoid this confusion, this commit replaces it with NULL,
    like xf86-video-intel driver does.
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=72849
    Signed-off-by: Robert Millan <rmh@freebsd.org>

commit d571d6af70ef27efd1ed6420eb892bdde963ed7a
Author: Alex Deucher <alexander.deucher@amd.com>
Date:   Tue Sep 24 11:39:10 2013 -0400

    radeon/kms: add Hawaii pci ids
    
    Signed-off-by: Alex Deucher <alexander.deucher@amd.com>

commit e38a92e00d015a6b80a1f3a16d58c61f084b066f
Author: Alex Deucher <alexander.deucher@amd.com>
Date:   Tue Sep 24 11:35:00 2013 -0400

    radeon: add support for Hawaii
    
    Disabled by default until the acceleration code stablizes.
    
    Signed-off-by: Alex Deucher <alexander.deucher@amd.com>

commit e4cd0f4392ea11c93088ad429f36eaaf9bcbf505
Author: Alex Deucher <alexander.deucher@amd.com>
Date:   Wed Oct 30 15:21:26 2013 -0400

    radeon: enable tiling on SI by default (v2)
    
    Now that mesa 9.2 is out with support for tiling
    on SI asics, we can enable it here. Tiling improves
    memory bandwidth utilization.
    
    V2: update man page
    
    Signed-off-by: Alex Deucher <alexander.deucher@amd.com>

commit 3b38701a72fa1cad1e4610a2f4330b3da4cc6391
Author: Vadim Girlin <vadimgirlin@gmail.com>
Date:   Fri Nov 1 10:36:39 2013 -0400

    radeon: disable 2D tiling on buffers < 128 pixels
    
    Seems to run into alignment problems with certain
    card configurations.
    
    bug:
    https://bugs.freedesktop.org/show_bug.cgi?id=70675
    
    Signed-off-by: Alex Deucher <alexander.deucher@amd.com>

commit 0c921edf0162fed616cea9d02e168b719243bcd2
Author: Jerome Glisse <jglisse@redhat.com>
Date:   Wed Oct 30 13:01:02 2013 -0400

    radeon/glamor: with new pixmap for dri2 drawable no need to create new texture
    
    When creating a new pixmap/bo for dri2 drawable there is no need to create a
    new texture, instead the texture associated with the new pixmap should be use
    otherwise there is a missmatch between the bo backing the texture for the
    drawable and the bo used by dri2 client.
    
    Signed-off-by: Jerome Glisse <jglisse@redhat.com>
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit f1dc677e79cd7a88d7379a934ebc7d87a3b18805
Author: Christopher James Halse Rogers <raof@ubuntu.com>
Date:   Mon Sep 23 12:25:29 2013 -0700

    EXA/evergreen: Paranoia around linear tiling. (v2)
    
    The last two bytes of tiling_mode contain the actual tiling mode; the rest are
    extra tiling configuration bits. These configuration bits are not necessarily
    zero for a linear buffer, so mask them out before checking for linearity
    
    v2: Also fix up evergreen_textured_videofuncs.c
    
    agd5f: remove trailing whitespace
    
    Signed-off-by: Christopher James Halse Rogers <raof@ubuntu.com>
    Signed-off-by: Alex Deucher <alexander.deucher@amd.com>

commit 67fb82a3f0759b171fea21b475a70fa825693570
Author: Alex Deucher <alexander.deucher@amd.com>
Date:   Tue Oct 1 09:35:30 2013 -0400

    radeon: fix the non-glamor build harder...
    
    I need to stop pushing patches first thing in the morning.
    
    Signed-off-by: Alex Deucher <alexander.deucher@amd.com>

commit afc0374fdec3e24ece25805724459463e9a19f5e
Author: Alex Deucher <alexander.deucher@amd.com>
Date:   Tue Oct 1 09:32:02 2013 -0400

    drm/radeon: fix non-glamor build
    
    Signed-off-by: Alex Deucher <alexander.deucher@amd.com>

commit 2d791370dfc5570eb74d7a1fb3baf4d4c8ecf243
Author: Dave Airlie <airlied@redhat.com>
Date:   Mon Sep 23 07:57:15 2013 +0100

    radeon: use glamor Xv support if present.
    
    This creates adaptors using glamor if possible.
    
    Signed-off-by: Dave Airlie <airlied@redhat.com>
    Signed-off-by: Alex Deucher <alexander.deucher@amd.com>

commit cbb99f659ee7b18ded0008a606e41ded38c1a194
Author: Alex Deucher <alexander.deucher@amd.com>
Date:   Mon Sep 30 08:55:16 2013 -0400

    Revert "radeon: add glamor Xv support (v2)"
    
    This causes problems if glamor doesn't have Xv support
    enabled.  I just noticed that Dave has a better version,
    so use that instead.
    
    This reverts commit 4fc1fa920584ace2c84d75af82d06962d0c84ec8.

commit 4fc1fa920584ace2c84d75af82d06962d0c84ec8
Author: Alex Deucher <alexander.deucher@amd.com>
Date:   Thu Sep 26 11:02:55 2013 -0400

    radeon: add glamor Xv support (v2)
    
    v2: guard new glamor Xv bits with USE_GLAMOR
    
    Signed-off-by: Alex Deucher <alexander.deucher@amd.com>
    Reviewed-by: Michel Dänzer <michel.daenzer@amd.com>

commit 41dfe327ac8740ac2cd84def96b5947224e422e7
Author: Alex Deucher <alexander.deucher@amd.com>
Date:   Thu Sep 26 11:00:49 2013 -0400

    radeon: fix limit handling for cards with >4G of ram
    
    We can overflow the 32-bit limit.
    
    Signed-off-by: Alex Deucher <alexander.deucher@amd.com>
    Reviewed-by: Michel Dänzer <michel.daenzer@amd.com>

commit c45e728107269c6f51599dad4f6a02ccfef703f1
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Sep 18 10:57:52 2013 +0200

    DRI2: Install client callback only once
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=60182
    Acked-by: Alex Deucher <alexander.deucher@amd.com>

commit b955ddd0d41801e4ca0c30a70a5d0b27c3f366c8
Author: Alex Deucher <alexander.deucher@amd.com>
Date:   Mon Sep 16 10:58:22 2013 -0400

    glamor: require 0.5.1 or newer
    
    0.5.1 fixes a number of issues.
    
    Signed-off-by: Alex Deucher <alexander.deucher@amd.com>

commit 282587cd0709850e7bacb1d8307065d95dc2c97d
Author: Alex Deucher <alexander.deucher@amd.com>
Date:   Mon Sep 16 09:41:13 2013 -0400

    radeon: enable glamor by default (v4)
    
    It's required for newer asics, so enable it by
    default.
    
    v2: update the autoconf help.  Require --disable-glamor
    to build without glamor support.
    v3: default to yes rather than auto
    v4: fix help text
    
    Signed-off-by: Alex Deucher <alexander.deucher@amd.com>
    Reviewed-by: Michel Dänzer <michel.daenzer@amd.com>

commit fdb7563a5cbc736b09c2864b67a93b475c98b2bd
Author: Alex Deucher <alexander.deucher@amd.com>
Date:   Thu Jan 24 21:17:11 2013 -0500

    radeon/kms: add berlin pci ids
    
    Signed-off-by: Alex Deucher <alexander.deucher@amd.com>

commit 8927d33f76ee12bc618fecfc59fc7ff1fcedcd5e
Author: Mark Kettenis <kettenis@openbsd.org>
Date:   Thu Aug 22 10:32:46 2013 -0400

    Fix shadowfb on big-endian machines
    
    For shadowfb, the framebuffer needs to have the RADEON_TILING_SURFACE
    flag set, otherwise the appropriate byte swapping won't happen.
    
    See https://bugs.freedesktop.org/show_bug.cgi?id=66663
    
    Signed-off-by: Mark Kettenis <kettenis@openbsd.org>
    Signed-off-by: Alex Deucher <alexander.deucher@amd.com>

commit fa83d3d1636c315bc43dd622d407eb058e3ef976
Author: Alex Deucher <alexander.deucher@amd.com>
Date:   Tue Aug 20 09:29:23 2013 -0400

    radeon: disallow glamor on pre-R600 asics
    
    I'm not sure they can handle the shaders properly, especially
    only older parts like r300.
    
    This will avoid display corruption problems reported by people
    using glamor on older asics by falling back to EXA if they try
    and enable glamor.
    
    Signed-off-by: Alex Deucher <alexander.deucher@amd.com>
    Reviewed-by: Michel Dänzer <michel.daenzer@amd.com>

commit d0323622ee9b97a5f246baffbb2c65930a78ed14
Author: Maarten Lankhorst <maarten.lankhorst@canonical.com>
Date:   Wed Aug 7 11:27:07 2013 +0200

    bump version post release
    
    Signed-off-by: Maarten Lankhorst <maarten.lankhorst@canonical.com>

commit 9c97cca5c24409ca8447c99f051a12fd2d494e79
Author: Maarten Lankhorst <maarten.lankhorst@canonical.com>
Date:   Wed Aug 7 10:48:17 2013 +0200

    radeon: bump version for release
    
    Signed-off-by: Maarten Lankhorst <maarten.lankhorst@canonical.com>

commit 16270cfb202ab67dd152644ef019b2f1ee4d0341
Author: Maarten Lankhorst <maarten.lankhorst@canonical.com>
Date:   Wed Aug 7 10:29:33 2013 +0200

    add bicubic_table.py to EXTRA_DIST
    
    Signed-off-by: Maarten Lankhorst <maarten.lankhorst@canonical.com>

commit 2cb9197ca7a337c911f38b5de562a2364b922b86
Author: Maarten Lankhorst <maarten.lankhorst@canonical.com>
Date:   Wed Aug 7 10:28:52 2013 +0200

    kill unused radeon_driver.c
    
    Signed-off-by: Maarten Lankhorst <maarten.lankhorst@canonical.com>

commit c5cbfcf575b0b4aea6f797558ae974c1453c8e07
Author: Alex Deucher <alexander.deucher@amd.com>
Date:   Tue Jul 30 10:08:25 2013 -0400

    drmmode: add support for multi-screen reverse optimus
    
    Initial reverse optimus didn't consider multiple screens, so
    this overhauls the code to use the new X server interface,
    and allows for multiple outputs on the dGPU to be used with
    the iGPU doing the rendering.  Ported from Dave's nouveau
    patch.
    
    Signed-off-by: Alex Deucher <alexander.deucher@amd.com>

commit 429d5b797769895eb4f5fef816ce4e2f3a342031
Author: Dave Airlie <airlied@redhat.com>
Date:   Tue Jan 8 15:56:37 2013 +1000

    radeon: add support for reverse prime (v2)
    
    This adds support for reverse prime configurations
    
    v2: fix compilation with older xservers
    
    Signed-off-by: Alex Deucher <alexdeucher@gmail.com>

commit 4de9356a2900ae0fb380a2350791ef045629cd05
Author: Alex Deucher <alexander.deucher@amd.com>
Date:   Mon Aug 5 17:57:16 2013 -0400

    radeon: fix naming clashes with multiple GPUs (v3)
    
    The compat naming code for UMS causes problems
    with multiple GPU as you may end up with the same
    output name on multiple GPUs.  Adjust the naming on
    secondary GPUs to avoid conflicts.
    
    v2: integrate Dave's fixes for nouveau
    v3: keep compat with existing naming on primary GPU
    
    Signed-off-by: Alex Deucher <alexander.deucher@amd.com>

commit 2ae6bb18fefddb309920fa69c9b56c3a7f3db7b4
Author: Grigori Goronzy <greg@chown.ath.cx>
Date:   Wed Jul 31 12:01:20 2013 +0200

    EXA/evergreen/ni: replace magic number
    
    Signed-off-by: Alex Deucher <alexdeucher@gmail.com>

commit 6a278369c05a298a4367306d986467a9ceacae8c
Author: Raul Fernandes <rgfernandes@gmail.com>
Date:   Tue Jul 30 09:26:05 2013 -0400

    EXA/6xx/7xx: optimize non-overlapping Copy
    
    In case dst and src rectangles of a Copy operation in the same surface
    don't overlap, it is safe to skip the scratch surface. This is a
    common case.
    
    Based on evergreen/ni patch from Grigori Goronzy.
    
    Signed-off-by: Alex Deucher <alexander.deucher@amd.com>

commit 4375a6e75e5d41139be7031a0dee58c057ecbd07
Author: Grigori Goronzy <greg@chown.ath.cx>
Date:   Mon Jul 22 02:30:28 2013 +0200

    EXA/evergreen/ni: accelerate PictOpOver with component alpha
    
    Subpixel text rendering is typically done with a solid src and a
    pixmap mask. Traditionally, this cannot be accelerated in a single
    pass and requires two passes [1]. However, we can cheat a little
    with a constant blend color.
    
    We can use:
    
    const.A = src.A / src.A
    const.R = src.R / src.A
    const.G = src.G / src.A
    const.B = src.B / src.A
    
    dst.A = const.A * (src.A * mask.A) + (1 - (src.A * mask.A)) * dst.A
    dst.R = const.R * (src.A * mask.R) + (1 - (src.A * mask.R)) * dst.R
    dst.G = const.G * (src.A * mask.G) + (1 - (src.A * mask.G)) * dst.G
    dst.B = const.B * (src.A * mask.B) + (1 - (src.A * mask.B)) * dst.B
    
    This only needs a single source value. src.A is cancelled down in
    the right places.
    
    [1] http://anholt.livejournal.com/32058.html

commit 94d0d14914a025525a0766669b556eaa6681def7
Author: Grigori Goronzy <greg@chown.ath.cx>
Date:   Thu Jul 18 16:06:23 2013 +0200

    EXA/evergreen/ni: fast solid pixmap support
    
    Solid pixmaps are currently implemented with scratch pixmaps, which
    is slow. This replaces the hack with a proper implementation. The
    Composite shader can now either sample a src/mask or use a constant
    value.

commit 5bb04351c43a91a1d60348b7293544da05d75e72
Author: Grigori Goronzy <greg@chown.ath.cx>
Date:   Fri Jul 27 17:31:53 2012 +0200

    EXA/evergreen/ni: optimize non-overlapping Copy
    
    In case dst and src rectangles of a Copy operation in the same surface
    don't overlap, it is safe to skip the scratch surface. This is a
    common case.

commit c08e09b7bec441c4bf93b4cae4de1260754bf940
Author: Grigori Goronzy <greg@chown.ath.cx>
Date:   Sat May 18 13:46:03 2013 +0200

    Fix RADEON_FALLBACK logging

commit c16c59f8f9b6aa7a4a6a6465582ad98f02a3606a
Author: Mark Kettenis <kettenis@openbsd.org>
Date:   Sun Jul 7 13:44:13 2013 +0200

    Always go through DFS/UTS when byte swapping is needed.
    
    Before commit ef9bfb262db7004bef3704e5d914687e50d3fca4 and
    e5bd99faa3b6629a55168386d5dfa936ee4e97ae, byte swapping for the front buffer
    used to be done in hardware.  Now that this no longer happens we need to let
    DFS/UTS ihandle the byte swapping.
    
    See https://bugs.freedesktop.org/show_bug.cgi?id=66663 .
    
    Signed-off-by: Mark Kettenis <kettenis@openbsd.org>

commit 1239dbbd8c8d9b55756c1de52cad353171a06522
Author: Alex Deucher <alexander.deucher@amd.com>
Date:   Sun Jul 7 20:22:10 2013 -0400

    radeon: bump libdrm requirement to 2.4.46 for CIK support
    
    Signed-off-by: Alex Deucher <alexander.deucher@amd.com>

commit 869e0b187b2d07e637c4482fe50d9f1b0c09f4e4
Author: Alex Deucher <alexander.deucher@amd.com>
Date:   Thu Jan 24 21:12:28 2013 -0500

    radeon/kms: add kabini pci ids
    
    Signed-off-by: Alex Deucher <alexander.deucher@amd.com>

commit 0edcefc4c97e4572431c38fe170032470e22e0b7
Author: Alex Deucher <alexander.deucher@amd.com>
Date:   Fri Jun 7 14:56:26 2013 -0400

    radeon/kms: add bonaire pci ids
    
    Signed-off-by: Alex Deucher <alexander.deucher@amd.com>

commit ebc32b27af25b23604e725eb50d844a8d26116bb
Author: Alex Deucher <alexander.deucher@amd.com>
Date:   Fri Aug 31 18:17:24 2012 -0400

    radeon: update cursor handling for CIK
    
    CIK asics have 128x128 hw cursors
    
    Signed-off-by: Alex Deucher <alexander.deucher@amd.com>

commit 4adaea996454b1ad5185f9c0f37667dbfc266495
Author: Alex Deucher <alexander.deucher@amd.com>
Date:   Fri Jun 7 14:47:36 2013 -0400

    radeon: add family ids for CIK
    
    Signed-off-by: Alex Deucher <alexander.deucher@amd.com>

commit 3626ab147b6749a355e7d21710447f13b9796c77
Author: Leo Liu <leo.liu@amd.com>
Date:   Fri Jun 14 10:27:20 2013 -0400

    radeon: fix a memory leak in get_modes() callback.
    
    leak happens when looping xrandr prop.
    
    Signed-off-by: Leo Liu <leo.liu@amd.com>
    Signed-off-by: Alex Deucher <alexdeucher@gmail.com>

commit c0f7d03cb29166c6c00dd6fb698ba3f70c59dbdf
Author: Alex Deucher <alexdeucher@gmail.com>
Date:   Mon Jun 17 11:38:27 2013 -0400

    man: fix up previous commit
    
    Signed-off-by: Alex Deucher <alexdeucher@gmail.com>

commit 03b5edc9dd3859eed2504155970613aaf88df852
Author: Eric S. Raymond <esr@thyrsus.com>
Date:   Fri Jun 7 13:23:14 2013 -0400

    Fix some incomplete list entries.
    
    This necessarily involved adding some content, which I was able to
    Google for.  Please review, correct, and make more specific.
    
    Bodiless .TP entries screw up doclifter's page parsing.  Please
    don't do that anymore.

commit 7ce43639a8e53eefb94e5255a39c1232b6bdbf66
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Jun 6 09:58:27 2013 +0200

    autogen.sh: Restore passing --enable-maintainer-mode to configure
    
    Looks like this was accidentally dropped when the GNOME Build API was
    implemented.

commit 365e571d9de0b5979425c34210789afca4ea5f68
Author: Samuel Li <samuel.li@amd.com>
Date:   Wed Mar 20 11:59:58 2013 -0400

    radeon: use direct mapping for fast fb access.
    
    Signed-off-by: Samuel Li <samuel.li@amd.com>

commit bd2557ea5ef84b975060e929d5ece53ec464336f
Author: Ilija Hadzic <ilijahadzic@gmail.com>
Date:   Wed May 8 22:39:48 2013 -0400

    DRI2: add interpolated blanks to frame number in event handlers
    
    The 'frame' argument passed to event handlers is the plain
    CRTC vblank counter that stops progressing when the
    associated display is in DPMS-off mode. If we have a
    DPMS-off period the frame counter and MSC will
    diverge, which can cause some higher-level functions
    to return incorrect values.
    
    This patch fixes the problem by adding interpolated
    vblanks to the frame counter before using it in handler
    functions.
    
    Signed-off-by: Ilija Hadzic <ihadzic@research.bell-labs.com>
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 385a92b4fbe8f53b359ef6c463704414d00476fa
Author: Ilija Hadzic <ilijahadzic@gmail.com>
Date:   Wed May 8 22:39:47 2013 -0400

    DRI2: support scheduling emulated events with zero delay
    
    Now that we fully emulating a running CRTC through DPMS-off state
    it is possible to come up with a zero delay when scheduling
    a swap or MSC-wait (e.g., if a call into respective wait function
    was entered very late). This patch wraps the TimerSet function
    into our own radeon_dri2_schedule_event such that the latter
    calls the event right away if zero delay is specified.
    
    Signed-off-by: Ilija Hadzic <ihadzic@research.bell-labs.com>
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit e87b52e6ad41ad7a87e43b818d80e7d522d9c68d
Author: Ilija Hadzic <ilijahadzic@gmail.com>
Date:   Wed May 8 22:39:46 2013 -0400

    DRI2: make wait_msc and get_msc work on disabled CRTCs
    
    Now that the running CRTC is emulated through DPMS-off
    states, wait_msc and get_msc must also work on disabled
    CRTCs. When CRTC is disabled, we must extrapolate the
    MSC count from present time and last MSC when CRTC was
    running and also use timers facility in wait_msc.
    
    v2: CRTC-private now stores frame rate instead of nominal
        vblank period.
    
    Signed-off-by: Ilija Hadzic <ihadzic@research.bell-labs.com>
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit f1584152bbeda98cc1907359f1c7954a84c8837d
Author: Ilija Hadzic <ilijahadzic@gmail.com>
Date:   Wed May 8 22:39:45 2013 -0400

    DRI2: move rename and rework radeon_dri2_deferred_swap
    
    radeon_dri2_deferred_swap will be used to generate
    real events (not just fallbacks) so now it needs to
    generate real timestamp and frame counter. Also
    this function will be used both by schedule_swap
    and wait_msc, so give it a more generic name:
    radeon_dri2_deferred_event
    
    v2: - Extrapolate the frame number from the time
          of actual execution of the function instead
          of using the MSC calculated (extrapolated)
          at event scheduling time.
        - CRTC-private now stores frame rate instead of
          nominal vblank period.
    
    Signed-off-by: Ilija Hadzic <ihadzic@research.bell-labs.com>
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 84bce7943b735aee19e26be4d47fdf140564f3f5
Author: Ilija Hadzic <ilijahadzic@gmail.com>
Date:   Wed May 8 22:39:44 2013 -0400

    DRI2: track CRTC in event record
    
    Tracking the CRTC associated with an event will save us
    some lookups later in event handlers.
    
    Signed-off-by: Ilija Hadzic <ihadzic@research.bell-labs.com>
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit e40d5390b3efdea3e02267413350410d8e6a2970
Author: Ilija Hadzic <ilijahadzic@gmail.com>
Date:   Wed May 8 22:39:43 2013 -0400

    DRI2: hook up vblank extrapolation to schedule_swap
    
    This patch hooks up swap-scheduling function with
    vblank-extrapolation function. Rather than waiting for
    fixed time, we calculate exactly how much we should wait
    and what we should update target_msc to using
    radeon_dri2_extrapolate_msc_delay helper function
    and schedule the swap completion using DIX's timer facility.
    
    Signed-off-by: Ilija Hadzic <ihadzic@research.bell-labs.com>
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit ffaa5abf207415159cdb28e90da49b95f497ef61
Author: Ilija Hadzic <ilijahadzic@gmail.com>
Date:   Wed May 8 22:39:42 2013 -0400

    DRI2: add vblank extrapolation function
    
    Implement a helper function that will be called when emulating
    the running CRTC. The function should be called only when CRTC
    is in DPMS-off state. It will look at the vblank count and the
    time that was recorded last time the CRTC was running and
    calculate how long one must wait (from present time) until
    the target_msc is reached if the CRTC were running.
    
    v2: - CRTC-private now stores frame rate instead of nominal
          vblank period.
        - DIX's timer facility can sometimes wake up the scheduled
          functions more than a millisecond earlier. To avoid
          generating an old MSC, we have to add more margin when
          converting the delay in microseconds to milliseconds.
    
    Signed-off-by: Ilija Hadzic <ihadzic@research.bell-labs.com>
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 80ae2291d082b57c70d27a80182f00d760fb3d3a
Author: Ilija Hadzic <ilijahadzic@gmail.com>
Date:   Wed May 8 22:39:41 2013 -0400

    DRI2: adjust MSC by the number of interpolated vblanks
    
    Normally, MSC value equals the vblank count of the CRTC
    on which the drawable resides. However, we are now interpolating
    vblanks through DPMS-off state, so if the CRTC is turned
    off at some point, the vlbank count does not change, but
    MSC does change by the amount that equals the cumulative
    number of interpolated vblanks.
    
    So each time we interact with the CRTC's vblank facility,
    we have to adjust the vblank counter: in the request, we
    have to subtract the number of interpolated vblanks from
    MSC and in the reply we have to add the number of interpolated
    vblanks to the MSC.
    
    This patch only makes the MSC correct when CRTC is on.
    The subsequent patch will construct the MSC when CRTC is not
    running.
    
    Signed-off-by: Ilija Hadzic <ihadzic@research.bell-labs.com>
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 5fd2eb5d12cea32927a9e6c6ce4afd18aa7d046a
Author: Ilija Hadzic <ilijahadzic@gmail.com>
Date:   Wed May 8 22:39:40 2013 -0400

    drmmode: calculate interpolated vblanks while in dpms-off state
    
    This adds provisions for interpolating vblanks while the CRTC
    is in DPMS-off state. When entering DPMS-off state, we
    record the last vblank time, sequence number and frame rate
    in CRTC-private structure.
    
    When going back to DPMS-on state we read the current
    time and calculate how long we have been off. Then we derive
    how many vblanks that would have been had the CRTC remained
    running. These are the interpolated vblanks.
    
    Finally, we accumulate the number of interpolated vblanks
    in CRTC-private structure to get the number of interpolated
    vblanks over the system lifetime.
    
    v2: Track frame rate instead of vblank period. The former
        eliminates some roundoff errors.
    
    Signed-off-by: Ilija Hadzic <ihadzic@research.bell-labs.com>
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit e41ad30d09be4962cfb1942b0b9f63875dbb2d2a
Author: Ilija Hadzic <ilijahadzic@gmail.com>
Date:   Wed May 8 22:39:39 2013 -0400

    drmmode: remove dead code from drmmode_crtc_dpms
    
    We are about to modify this function, so let's clean it
    up first.
    
    Signed-off-by: Ilija Hadzic <ihadzic@research.bell-labs.com>
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 373671d2eed30e30b3bdee7e40426cf58c127234
Author: Ilija Hadzic <ilijahadzic@gmail.com>
Date:   Wed May 8 22:39:38 2013 -0400

    drmmode: add drmmode_get_current_ust function
    
    The new helper function retrieves current time in the format
    that is compatible with vblank timestamps.
    
    v2: - fix an incorrect statement in a comment
        - add a #define so that don't depend on libdrm patches that
          have not yet been accepted upstream
    
    Signed-off-by: Ilija Hadzic <ihadzic@research.bell-labs.com>
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 006fbbd1d38a089b50ab3197d32815689ed249fa
Author: Ilija Hadzic <ilijahadzic@gmail.com>
Date:   Wed May 8 22:39:37 2013 -0400

    DRI2: make populate_vbl_request_type external
    
    We'll need to use this function in other .c files so
    remove static annotation from it. Also, add radeon_
    prefix because this function is now part of global namespace,
    so it would be nice to know where it is coming from.
    
    Signed-off-by: Ilija Hadzic <ihadzic@research.bell-labs.com>
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit 34660d8757ff16acd1686ff2872f4600d92a68bf
Author: Ilija Hadzic <ilijahadzic@gmail.com>
Date:   Wed May 8 22:39:36 2013 -0400

    DRI2: change signature of populate_vbl_request_type
    
    This function no longer uses info argument, so nuke it.
    
    Signed-off-by: Ilija Hadzic <ihadzic@research.bell-labs.com>
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>

commit ab6e85d1f5dd4657591b314b85fd2453f99c3712
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Mar 22 10:51:05 2013 +0100

    glamor: Keep old private in radeon_pixmap_set_bo

commit 0a84f2760eccf07781ae6c3f55d2d246c155c9ce
Author: Alex Deucher <alexander.deucher@amd.com>
Date:   Mon May 13 17:06:00 2013 -0400

    radeon: add Hainan pci ids
    
    Signed-off-by: Alex Deucher <alexander.deucher@amd.com>

commit 6cee1eaebfcef2b2d2c51ec30c31260fd98b564e
Author: Alex Deucher <alexander.deucher@amd.com>
Date:   Mon May 13 17:01:30 2013 -0400

    radeon: add hainan chip family
    
    Signed-off-by: Alex Deucher <alexander.deucher@amd.com>

commit 8a9e9b21cbb44c23d37bf18c983e2c3f0fe33e87
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Apr 25 17:10:12 2013 +0200

    glamor: Fix build against xserver < 1.13
    
    Those didn't define CREATE_PIXMAP_USAGE_SHARED.

commit 6216b5aa3793abe71b864170bc9d4d745f027328
Author: Alex Deucher <alexander.deucher@amd.com>
Date:   Thu Apr 25 14:19:37 2013 -0400

    radeon: add new richland pci ids
    
    Signed-off-by: Alex Deucher <alexander.deucher@amd.com>

commit fd5903f15b36555bf1ccc1c3865c9fffd499128a
Author: Alex Deucher <alexander.deucher@amd.com>
Date:   Thu Apr 25 14:17:51 2013 -0400

    radeon: add new SI pci ids
    
    Signed-off-by: Alex Deucher <alexander.deucher@amd.com>

commit b2826580e4d246d45871b413e4deecb070162577
Author: Jerome Glisse <jglisse@redhat.com>
Date:   Mon Apr 8 13:45:18 2013 -0400

    radeonsi: add 2d tiling support
    
    Signed-off-by: Jerome Glisse <jglisse@redhat.com>

commit 6e74aacc5e5da3b51744153dad1645caa6ea4ce3
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Mar 27 11:57:29 2013 +0100

    glamor: Only enable for depth >= 24
    
    It can't handle lower depths yet.
    
    Reported-by: Igor Vagulin <igor.vagulin@gmail.com>

commit 33d8408eec806355c2e55726679ec50ef3b769f1
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Mar 12 19:03:06 2013 +0100

    glamor: Enable by default on SI
    
    We should now handle its major initialization failure cases gracefully.
    
    Reviewed-by: Jerome Glisse <jglisse@redhat.com>

commit ad1d8874fab30257ba8ec8bee8ffa42a8fa9b5c0
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Mar 15 18:28:27 2013 +0100

    glamor: Initial PRIME pixmap sharing hooks.
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=57200
    
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>
    Tested-by: Christoph Haag <haagch.christoph@googlemail.com>
    Tested-by: linedot <linedot@xcpp.org>

commit 35b384a00a0c76ea556f55787fccc95ecd51bc0c
Author: Maarten Lankhorst <maarten.lankhorst@canonical.com>
Date:   Thu Mar 21 15:34:21 2013 +0100

    drmmode: handle failure of drmModeGetConnector
    
    Signed-off-by: Maarten Lankhorst <maarten.lankhorst@canonical.com>

commit 751c7259cf23a29fdd2653881e2db63ce3cf1ca5
Author: Maarten Lankhorst <maarten.lankhorst@canonical.com>
Date:   Thu Mar 21 10:40:42 2013 +0100

    Move fd cleanup to correct place.
    
    Oops, just after previous commit I realized that it
    needs to be done from RADEONFreeRec, because when preinit fails
    info pointer can be null in FreeScreen.
    
    Signed-off-by: Maarten Lankhorst <maarten.lankhorst@canonical.com>

commit 1643b8cd2dc53ed36916e11003590c7037b4ddd6
Author: Maarten Lankhorst <maarten.lankhorst@canonical.com>
Date:   Thu Mar 21 10:33:19 2013 +0100

    radeon: add refcounts to fix up zaphod open/close.
    
    Oops, turns out my previous commits were buggy.
    Adding proper refcounts will handle this correctly.
    
    Signed-off-by: Maarten Lankhorst <maarten.lankhorst@canonical.com>

commit a4d1bc43d4d10e2ca1e512c1010e962c587d6c16
Author: Maarten Lankhorst <maarten.lankhorst@canonical.com>
Date:   Wed Mar 20 17:13:44 2013 +0100

    Cleanup drmmode in CloseScreen.
    
    Prevents a use-after-free.
    
    Signed-off-by: Maarten Lankhorst <maarten.lankhorst@canonical.com>

commit 3cb3ab8704813d7c14b9e547a30e37598d70c85a
Author: Maarten Lankhorst <maarten.lankhorst@canonical.com>
Date:   Wed Mar 20 17:12:29 2013 +0100

    Close drm_fd in CloseScreen.
    
    This prevents a small fd leak.
    
    Signed-off-by: Maarten Lankhorst <maarten.lankhorst@canonical.com>

commit 462d8d3b86038438ab854072e546cc7a9efacdd7
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Mar 12 18:59:19 2013 +0100

    glamor: Bail if the glamoregl module wasn't loaded early
    
    Trying to initialize glamor in that case crashes.
    
    Reviewed-by: Jerome Glisse <jglisse@redhat.com>

commit 3e5350bedf50a1a140e0eba08c39ed2451fb9115
Author: Alex Deucher <alexander.deucher@amd.com>
Date:   Fri Mar 8 14:07:42 2013 -0500

    radeon: add Richland pci ids
    
    Signed-off-by: Alex Deucher <alexander.deucher@amd.com>

commit bdbf766d8170f6ea6c16b9780ef5a4007730588b
Author: Alex Deucher <alexander.deucher@amd.com>
Date:   Fri Mar 8 14:00:09 2013 -0500

    radeon: mark trinity APUs with IGP flag
    
    Was missing on trinity.
    
    Signed-off-by: Alex Deucher <alexander.deucher@amd.com>

commit 5ac335eaae135c0e66cc4643908f41174e2f1123
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Mar 8 17:37:41 2013 +0100

    Only parse Option "AccelMethod" if glamor was enabled at build time
    
    Will hopefully make it more obvious when it wasn't.

commit f1059e3f0934ccf1ae183099dbd4de700a7c81ac
Author: Colin Walters <walters@verbum.org>
Date:   Wed Jan 4 17:37:06 2012 -0500

    autogen.sh: Implement GNOME Build API
    
    http://people.gnome.org/~walters/docs/build-api.txt
    
    Signed-off-by: Adam Jackson <ajax@redhat.com>

commit 343b01c9bf35b125cd0c3df8db7c01a5fb227bda
Author: Alex Deucher <alexander.deucher@amd.com>
Date:   Thu Jan 24 19:57:23 2013 -0500

    radeon/kms: add oland pci ids
    
    Signed-off-by: Alex Deucher <alexander.deucher@amd.com>

commit 9980f1e0e0a5df5fb0c791687e5c98c13089d7d1
Author: Alex Deucher <alexander.deucher@amd.com>
Date:   Thu Jan 24 19:52:04 2013 -0500

    radeon: add oland chip family
    
    Signed-off-by: Alex Deucher <alexander.deucher@amd.com>

commit d89e545826969910226cb96e73b64f18e92d2064
Author: Maarten Lankhorst <maarten.lankhorst@canonical.com>
Date:   Wed Jan 30 17:21:05 2013 +0100

    bump version post release
    
    Signed-off-by: Maarten Lankhorst <maarten.lankhorst@canonical.com>

commit 21a4f3eaca98c1c54bffcdf3926c631cec9c409d
Author: Maarten Lankhorst <maarten.lankhorst@canonical.com>
Date:   Wed Jan 30 16:55:27 2013 +0100

    radeon: bump version for release
    
    And fixup distcheck..
    
    Signed-off-by: Maarten Lankhorst <maarten.lankhorst@canonical.com>

commit 102ee4a24e4c9ba0c0b65d3ca8599dc7e0216c1e
Author: Alex Deucher <alexdeucher@gmail.com>
